require '_h2ph_pre.ph';

unless(defined(&_CAM_CAM_CCB_H)) {
    eval 'sub _CAM_CAM_CCB_H () {1;}' unless defined(&_CAM_CAM_CCB_H);
    require 'sys/queue.ph';
    require 'sys/cdefs.ph';
    require 'sys/time.ph';
    unless(defined(&KERNEL)) {
	require 'sys/callout.ph';
    }
    require 'cam/cam_debug.ph';
    require 'cam/scsi/scsi_all.ph';
    eval 'sub IOCDBLEN () { &CAM_MAX_CDBLEN;}' unless defined(&IOCDBLEN);
    eval 'sub VUHBALEN () {14;}' unless defined(&VUHBALEN);
    eval 'sub SIM_IDLEN () {16;}' unless defined(&SIM_IDLEN);
    eval 'sub HBA_IDLEN () {16;}' unless defined(&HBA_IDLEN);
    eval 'sub DEV_IDLEN () {16;}' unless defined(&DEV_IDLEN);
    eval 'sub CCB_PERIPH_PRIV_SIZE () {2;}' unless defined(&CCB_PERIPH_PRIV_SIZE);
    eval 'sub CCB_SIM_PRIV_SIZE () {2;}' unless defined(&CCB_SIM_PRIV_SIZE);
    eval("sub CAM_CDB_POINTER () { 0x00000001; }") unless defined(&CAM_CDB_POINTER);
    eval("sub CAM_QUEUE_ENABLE () { 0x00000002; }") unless defined(&CAM_QUEUE_ENABLE);
    eval("sub CAM_CDB_LINKED () { 0x00000004; }") unless defined(&CAM_CDB_LINKED);
    eval("sub CAM_SCATTER_VALID () { 0x00000010; }") unless defined(&CAM_SCATTER_VALID);
    eval("sub CAM_DIS_AUTOSENSE () { 0x00000020; }") unless defined(&CAM_DIS_AUTOSENSE);
    eval("sub CAM_DIR_RESV () { 0x00000000; }") unless defined(&CAM_DIR_RESV);
    eval("sub CAM_DIR_IN () { 0x00000040; }") unless defined(&CAM_DIR_IN);
    eval("sub CAM_DIR_OUT () { 0x00000080; }") unless defined(&CAM_DIR_OUT);
    eval("sub CAM_DIR_NONE () { 0x000000C0; }") unless defined(&CAM_DIR_NONE);
    eval("sub CAM_DIR_MASK () { 0x000000C0; }") unless defined(&CAM_DIR_MASK);
    eval("sub CAM_SOFT_RST_OP () { 0x00000100; }") unless defined(&CAM_SOFT_RST_OP);
    eval("sub CAM_ENG_SYNC () { 0x00000200; }") unless defined(&CAM_ENG_SYNC);
    eval("sub CAM_DEV_QFRZDIS () { 0x00000400; }") unless defined(&CAM_DEV_QFRZDIS);
    eval("sub CAM_DEV_QFREEZE () { 0x00000800; }") unless defined(&CAM_DEV_QFREEZE);
    eval("sub CAM_HIGH_POWER () { 0x00001000; }") unless defined(&CAM_HIGH_POWER);
    eval("sub CAM_SENSE_PTR () { 0x00002000; }") unless defined(&CAM_SENSE_PTR);
    eval("sub CAM_SENSE_PHYS () { 0x00004000; }") unless defined(&CAM_SENSE_PHYS);
    eval("sub CAM_TAG_ACTION_VALID () { 0x00008000; }") unless defined(&CAM_TAG_ACTION_VALID);
    eval("sub CAM_PASS_ERR_RECOVER () { 0x00010000; }") unless defined(&CAM_PASS_ERR_RECOVER);
    eval("sub CAM_DIS_DISCONNECT () { 0x00020000; }") unless defined(&CAM_DIS_DISCONNECT);
    eval("sub CAM_SG_LIST_PHYS () { 0x00040000; }") unless defined(&CAM_SG_LIST_PHYS);
    eval("sub CAM_MSG_BUF_PHYS () { 0x00080000; }") unless defined(&CAM_MSG_BUF_PHYS);
    eval("sub CAM_SNS_BUF_PHYS () { 0x00100000; }") unless defined(&CAM_SNS_BUF_PHYS);
    eval("sub CAM_DATA_PHYS () { 0x00200000; }") unless defined(&CAM_DATA_PHYS);
    eval("sub CAM_CDB_PHYS () { 0x00400000; }") unless defined(&CAM_CDB_PHYS);
    eval("sub CAM_ENG_SGLIST () { 0x00800000; }") unless defined(&CAM_ENG_SGLIST);
    eval("sub CAM_DIS_AUTOSRP () { 0x01000000; }") unless defined(&CAM_DIS_AUTOSRP);
    eval("sub CAM_DIS_AUTODISC () { 0x02000000; }") unless defined(&CAM_DIS_AUTODISC);
    eval("sub CAM_TGT_CCB_AVAIL () { 0x04000000; }") unless defined(&CAM_TGT_CCB_AVAIL);
    eval("sub CAM_TGT_PHASE_MODE () { 0x08000000; }") unless defined(&CAM_TGT_PHASE_MODE);
    eval("sub CAM_MSGB_VALID () { 0x20000000; }") unless defined(&CAM_MSGB_VALID);
    eval("sub CAM_STATUS_VALID () { 0x40000000; }") unless defined(&CAM_STATUS_VALID);
    eval("sub CAM_DATAB_VALID () { 0x80000000; }") unless defined(&CAM_DATAB_VALID);
    eval("sub CAM_TERM_IO () { 0x20000000; }") unless defined(&CAM_TERM_IO);
    eval("sub CAM_DISCONNECT () { 0x40000000; }") unless defined(&CAM_DISCONNECT);
    eval("sub CAM_SEND_STATUS () { 0x80000000; }") unless defined(&CAM_SEND_STATUS);
    eval("sub XPT_FC_QUEUED () { 0x100; }") unless defined(&XPT_FC_QUEUED);
    eval("sub XPT_FC_USER_CCB () { 0x200; }") unless defined(&XPT_FC_USER_CCB);
    eval("sub XPT_FC_XPT_ONLY () { 0x400; }") unless defined(&XPT_FC_XPT_ONLY);
    eval("sub XPT_NOOP () { 0x00; }") unless defined(&XPT_NOOP);
    eval("sub XPT_SCSI_IO () { 0x01|XPT_FC_QUEUED; }") unless defined(&XPT_SCSI_IO);
    eval("sub XPT_GDEV_TYPE () { 0x02; }") unless defined(&XPT_GDEV_TYPE);
    eval("sub XPT_GDEVLIST () { 0x03; }") unless defined(&XPT_GDEVLIST);
    eval("sub XPT_PATH_INQ () { 0x04; }") unless defined(&XPT_PATH_INQ);
    eval("sub XPT_REL_SIMQ () { 0x05; }") unless defined(&XPT_REL_SIMQ);
    eval("sub XPT_SASYNC_CB () { 0x06; }") unless defined(&XPT_SASYNC_CB);
    eval("sub XPT_SDEV_TYPE () { 0x07; }") unless defined(&XPT_SDEV_TYPE);
    eval("sub XPT_SCAN_BUS () { 0x08|XPT_FC_QUEUED|XPT_FC_USER_CCB|XPT_FC_XPT_ONLY; }") unless defined(&XPT_SCAN_BUS);
    eval("sub XPT_DEV_MATCH () { 0x09|XPT_FC_XPT_ONLY; }") unless defined(&XPT_DEV_MATCH);
    eval("sub XPT_DEBUG () { 0x0a; }") unless defined(&XPT_DEBUG);
    eval("sub XPT_PATH_STATS () { 0x0b; }") unless defined(&XPT_PATH_STATS);
    eval("sub XPT_GDEV_STATS () { 0x0c; }") unless defined(&XPT_GDEV_STATS);
    eval("sub XPT_ABORT () { 0x10; }") unless defined(&XPT_ABORT);
    eval("sub XPT_RESET_BUS () { 0x11|XPT_FC_XPT_ONLY; }") unless defined(&XPT_RESET_BUS);
    eval("sub XPT_RESET_DEV () { 0x12|XPT_FC_QUEUED; }") unless defined(&XPT_RESET_DEV);
    eval("sub XPT_TERM_IO () { 0x13; }") unless defined(&XPT_TERM_IO);
    eval("sub XPT_SCAN_LUN () { 0x14|XPT_FC_QUEUED|XPT_FC_USER_CCB|XPT_FC_XPT_ONLY; }") unless defined(&XPT_SCAN_LUN);
    eval("sub XPT_GET_TRAN_SETTINGS () { 0x15; }") unless defined(&XPT_GET_TRAN_SETTINGS);
    eval("sub XPT_SET_TRAN_SETTINGS () { 0x16; }") unless defined(&XPT_SET_TRAN_SETTINGS);
    eval("sub XPT_CALC_GEOMETRY () { 0x17; }") unless defined(&XPT_CALC_GEOMETRY);
    eval("sub XPT_ENG_INQ () { 0x20|XPT_FC_XPT_ONLY; }") unless defined(&XPT_ENG_INQ);
    eval("sub XPT_ENG_EXEC () { 0x21|XPT_FC_QUEUED|XPT_FC_XPT_ONLY; }") unless defined(&XPT_ENG_EXEC);
    eval("sub XPT_EN_LUN () { 0x30; }") unless defined(&XPT_EN_LUN);
    eval("sub XPT_TARGET_IO () { 0x31|XPT_FC_QUEUED; }") unless defined(&XPT_TARGET_IO);
    eval("sub XPT_ACCEPT_TARGET_IO () { 0x32|XPT_FC_QUEUED|XPT_FC_USER_CCB; }") unless defined(&XPT_ACCEPT_TARGET_IO);
    eval("sub XPT_CONT_TARGET_IO () { 0x33|XPT_FC_QUEUED; }") unless defined(&XPT_CONT_TARGET_IO);
    eval("sub XPT_IMMED_NOTIFY () { 0x34|XPT_FC_QUEUED|XPT_FC_USER_CCB; }") unless defined(&XPT_IMMED_NOTIFY);
    eval("sub XPT_NOTIFY_ACK () { 0x35; }") unless defined(&XPT_NOTIFY_ACK);
    eval("sub XPT_VUNIQUE () { 0x80; }") unless defined(&XPT_VUNIQUE);
    eval 'sub XPT_FC_GROUP_MASK () {0xf0;}' unless defined(&XPT_FC_GROUP_MASK);
    eval 'sub XPT_FC_GROUP {
        local($op) = @_;
	    eval q((($op) &  &XPT_FC_GROUP_MASK));
    }' unless defined(&XPT_FC_GROUP);
    eval 'sub XPT_FC_GROUP_COMMON () {0x00;}' unless defined(&XPT_FC_GROUP_COMMON);
    eval 'sub XPT_FC_GROUP_SCSI_CONTROL () {0x10;}' unless defined(&XPT_FC_GROUP_SCSI_CONTROL);
    eval 'sub XPT_FC_GROUP_HBA_ENGINE () {0x20;}' unless defined(&XPT_FC_GROUP_HBA_ENGINE);
    eval 'sub XPT_FC_GROUP_TMODE () {0x30;}' unless defined(&XPT_FC_GROUP_TMODE);
    eval 'sub XPT_FC_GROUP_VENDOR_UNIQUE () {0x80;}' unless defined(&XPT_FC_GROUP_VENDOR_UNIQUE);
    eval("sub CAM_GDEVLIST_LAST_DEVICE () { 0; }") unless defined(&CAM_GDEVLIST_LAST_DEVICE);
    eval("sub CAM_GDEVLIST_LIST_CHANGED () { 1; }") unless defined(&CAM_GDEVLIST_LIST_CHANGED);
    eval("sub CAM_GDEVLIST_MORE_DEVS () { 2; }") unless defined(&CAM_GDEVLIST_MORE_DEVS);
    eval("sub CAM_GDEVLIST_ERROR () { 3; }") unless defined(&CAM_GDEVLIST_ERROR);
    eval("sub PERIPH_MATCH_NONE () { 0x000; }") unless defined(&PERIPH_MATCH_NONE);
    eval("sub PERIPH_MATCH_PATH () { 0x001; }") unless defined(&PERIPH_MATCH_PATH);
    eval("sub PERIPH_MATCH_TARGET () { 0x002; }") unless defined(&PERIPH_MATCH_TARGET);
    eval("sub PERIPH_MATCH_LUN () { 0x004; }") unless defined(&PERIPH_MATCH_LUN);
    eval("sub PERIPH_MATCH_NAME () { 0x008; }") unless defined(&PERIPH_MATCH_NAME);
    eval("sub PERIPH_MATCH_UNIT () { 0x010; }") unless defined(&PERIPH_MATCH_UNIT);
    eval("sub PERIPH_MATCH_ANY () { 0x01f; }") unless defined(&PERIPH_MATCH_ANY);
    eval("sub DEV_MATCH_NONE () { 0x000; }") unless defined(&DEV_MATCH_NONE);
    eval("sub DEV_MATCH_PATH () { 0x001; }") unless defined(&DEV_MATCH_PATH);
    eval("sub DEV_MATCH_TARGET () { 0x002; }") unless defined(&DEV_MATCH_TARGET);
    eval("sub DEV_MATCH_LUN () { 0x004; }") unless defined(&DEV_MATCH_LUN);
    eval("sub DEV_MATCH_INQUIRY () { 0x008; }") unless defined(&DEV_MATCH_INQUIRY);
    eval("sub DEV_MATCH_ANY () { 0x00f; }") unless defined(&DEV_MATCH_ANY);
    eval("sub BUS_MATCH_NONE () { 0x000; }") unless defined(&BUS_MATCH_NONE);
    eval("sub BUS_MATCH_PATH () { 0x001; }") unless defined(&BUS_MATCH_PATH);
    eval("sub BUS_MATCH_NAME () { 0x002; }") unless defined(&BUS_MATCH_NAME);
    eval("sub BUS_MATCH_UNIT () { 0x004; }") unless defined(&BUS_MATCH_UNIT);
    eval("sub BUS_MATCH_BUS_ID () { 0x008; }") unless defined(&BUS_MATCH_BUS_ID);
    eval("sub BUS_MATCH_ANY () { 0x00f; }") unless defined(&BUS_MATCH_ANY);
    eval("sub DEV_MATCH_PERIPH () { 0; }") unless defined(&DEV_MATCH_PERIPH);
    eval("sub DEV_MATCH_DEVICE () { 1; }") unless defined(&DEV_MATCH_DEVICE);
    eval("sub DEV_MATCH_BUS () { 2; }") unless defined(&DEV_MATCH_BUS);
    eval("sub DEV_RESULT_NOFLAG () { 0x00; }") unless defined(&DEV_RESULT_NOFLAG);
    eval("sub DEV_RESULT_UNCONFIGURED () { 0x01; }") unless defined(&DEV_RESULT_UNCONFIGURED);
    eval("sub CAM_DEV_MATCH_LAST () { 0; }") unless defined(&CAM_DEV_MATCH_LAST);
    eval("sub CAM_DEV_MATCH_MORE () { 1; }") unless defined(&CAM_DEV_MATCH_MORE);
    eval("sub CAM_DEV_MATCH_LIST_CHANGED () { 2; }") unless defined(&CAM_DEV_MATCH_LIST_CHANGED);
    eval("sub CAM_DEV_MATCH_SIZE_ERROR () { 3; }") unless defined(&CAM_DEV_MATCH_SIZE_ERROR);
    eval("sub CAM_DEV_MATCH_ERROR () { 4; }") unless defined(&CAM_DEV_MATCH_ERROR);
    eval("sub CAM_DEV_POS_NONE () { 0x000; }") unless defined(&CAM_DEV_POS_NONE);
    eval("sub CAM_DEV_POS_BUS () { 0x001; }") unless defined(&CAM_DEV_POS_BUS);
    eval("sub CAM_DEV_POS_TARGET () { 0x002; }") unless defined(&CAM_DEV_POS_TARGET);
    eval("sub CAM_DEV_POS_DEVICE () { 0x004; }") unless defined(&CAM_DEV_POS_DEVICE);
    eval("sub CAM_DEV_POS_PERIPH () { 0x008; }") unless defined(&CAM_DEV_POS_PERIPH);
    eval("sub CAM_DEV_POS_PDPTR () { 0x010; }") unless defined(&CAM_DEV_POS_PDPTR);
    eval("sub CAM_DEV_POS_TYPEMASK () { 0xf00; }") unless defined(&CAM_DEV_POS_TYPEMASK);
    eval("sub CAM_DEV_POS_EDT () { 0x100; }") unless defined(&CAM_DEV_POS_EDT);
    eval("sub CAM_DEV_POS_PDRV () { 0x200; }") unless defined(&CAM_DEV_POS_PDRV);
    eval 'sub CAM_BUS_GENERATION () {0x00;}' unless defined(&CAM_BUS_GENERATION);
    eval 'sub CAM_TARGET_GENERATION () {0x01;}' unless defined(&CAM_TARGET_GENERATION);
    eval 'sub CAM_DEV_GENERATION () {0x02;}' unless defined(&CAM_DEV_GENERATION);
    eval 'sub CAM_PERIPH_GENERATION () {0x03;}' unless defined(&CAM_PERIPH_GENERATION);
    eval 'sub CAM_VERSION () {0x11;}' unless defined(&CAM_VERSION);
    eval("sub PI_MDP_ABLE () { 0x80; }") unless defined(&PI_MDP_ABLE);
    eval("sub PI_WIDE_32 () { 0x40; }") unless defined(&PI_WIDE_32);
    eval("sub PI_WIDE_16 () { 0x20; }") unless defined(&PI_WIDE_16);
    eval("sub PI_SDTR_ABLE () { 0x10; }") unless defined(&PI_SDTR_ABLE);
    eval("sub PI_LINKED_CDB () { 0x08; }") unless defined(&PI_LINKED_CDB);
    eval("sub PI_TAG_ABLE () { 0x02; }") unless defined(&PI_TAG_ABLE);
    eval("sub PI_SOFT_RST () { 0x01; }") unless defined(&PI_SOFT_RST);
    eval("sub PIT_PROCESSOR () { 0x80; }") unless defined(&PIT_PROCESSOR);
    eval("sub PIT_PHASE () { 0x40; }") unless defined(&PIT_PHASE);
    eval("sub PIT_DISCONNECT () { 0x20; }") unless defined(&PIT_DISCONNECT);
    eval("sub PIT_TERM_IO () { 0x10; }") unless defined(&PIT_TERM_IO);
    eval("sub PIT_GRP_6 () { 0x08; }") unless defined(&PIT_GRP_6);
    eval("sub PIT_GRP_7 () { 0x04; }") unless defined(&PIT_GRP_7);
    eval("sub PIM_SCANHILO () { 0x80; }") unless defined(&PIM_SCANHILO);
    eval("sub PIM_NOREMOVE () { 0x40; }") unless defined(&PIM_NOREMOVE);
    eval("sub PIM_NOINITIATOR () { 0x20; }") unless defined(&PIM_NOINITIATOR);
    eval("sub PIM_NOBUSRESET () { 0x10; }") unless defined(&PIM_NOBUSRESET);
    eval 'sub CAM_TAG_ACTION_NONE () {0x00;}' unless defined(&CAM_TAG_ACTION_NONE);
    eval 'sub RELSIM_ADJUST_OPENINGS () {0x01;}' unless defined(&RELSIM_ADJUST_OPENINGS);
    eval 'sub RELSIM_RELEASE_AFTER_TIMEOUT () {0x02;}' unless defined(&RELSIM_RELEASE_AFTER_TIMEOUT);
    eval 'sub RELSIM_RELEASE_AFTER_CMDCMPLT () {0x04;}' unless defined(&RELSIM_RELEASE_AFTER_CMDCMPLT);
    eval 'sub RELSIM_RELEASE_AFTER_QEMPTY () {0x08;}' unless defined(&RELSIM_RELEASE_AFTER_QEMPTY);
    eval("sub AC_GETDEV_CHANGED () { 0x800; }") unless defined(&AC_GETDEV_CHANGED);
    eval("sub AC_INQ_CHANGED () { 0x400; }") unless defined(&AC_INQ_CHANGED);
    eval("sub AC_TRANSFER_NEG () { 0x200; }") unless defined(&AC_TRANSFER_NEG);
    eval("sub AC_LOST_DEVICE () { 0x100; }") unless defined(&AC_LOST_DEVICE);
    eval("sub AC_FOUND_DEVICE () { 0x080; }") unless defined(&AC_FOUND_DEVICE);
    eval("sub AC_PATH_DEREGISTERED () { 0x040; }") unless defined(&AC_PATH_DEREGISTERED);
    eval("sub AC_PATH_REGISTERED () { 0x020; }") unless defined(&AC_PATH_REGISTERED);
    eval("sub AC_SENT_BDR () { 0x010; }") unless defined(&AC_SENT_BDR);
    eval("sub AC_SCSI_AEN () { 0x008; }") unless defined(&AC_SCSI_AEN);
    eval("sub AC_UNSOL_RESEL () { 0x002; }") unless defined(&AC_UNSOL_RESEL);
    eval("sub AC_BUS_RESET () { 0x001; }") unless defined(&AC_BUS_RESET);
    eval 'sub CCB_TRANS_SYNC_RATE_VALID () {0x01;}' unless defined(&CCB_TRANS_SYNC_RATE_VALID);
    eval 'sub CCB_TRANS_SYNC_OFFSET_VALID () {0x02;}' unless defined(&CCB_TRANS_SYNC_OFFSET_VALID);
    eval 'sub CCB_TRANS_BUS_WIDTH_VALID () {0x04;}' unless defined(&CCB_TRANS_BUS_WIDTH_VALID);
    eval 'sub CCB_TRANS_DISC_VALID () {0x08;}' unless defined(&CCB_TRANS_DISC_VALID);
    eval 'sub CCB_TRANS_TQ_VALID () {0x10;}' unless defined(&CCB_TRANS_TQ_VALID);
    eval 'sub CCB_TRANS_CURRENT_SETTINGS () {0x01;}' unless defined(&CCB_TRANS_CURRENT_SETTINGS);
    eval 'sub CCB_TRANS_USER_SETTINGS () {0x02;}' unless defined(&CCB_TRANS_USER_SETTINGS);
    eval 'sub CCB_TRANS_DISC_ENB () {0x04;}' unless defined(&CCB_TRANS_DISC_ENB);
    eval 'sub CCB_TRANS_TAG_ENB () {0x08;}' unless defined(&CCB_TRANS_TAG_ENB);
    eval("sub EIT_BUFFER () { 0; }") unless defined(&EIT_BUFFER);
    eval("sub EIT_LOSSLESS () { 1; }") unless defined(&EIT_LOSSLESS);
    eval("sub EIT_LOSSY () { 2; }") unless defined(&EIT_LOSSY);
    eval("sub EIT_ENCRYPT () { 3; }") unless defined(&EIT_ENCRYPT);
    eval("sub EAD_VUNIQUE () { 0; }") unless defined(&EAD_VUNIQUE);
    eval("sub EAD_LZ1V1 () { 1; }") unless defined(&EAD_LZ1V1);
    eval("sub EAD_LZ2V1 () { 2; }") unless defined(&EAD_LZ2V1);
    eval("sub EAD_LZ2V2 () { 3; }") unless defined(&EAD_LZ2V2);
    eval 'sub CAM_TIME_DEFAULT () {0x00000000;}' unless defined(&CAM_TIME_DEFAULT);
    eval 'sub CAM_TIME_INFINITY () {0xffffffff;}' unless defined(&CAM_TIME_INFINITY);
    eval 'sub CAM_SUCCESS () {0;}' unless defined(&CAM_SUCCESS);
    eval 'sub CAM_FAILURE () {1;}' unless defined(&CAM_FAILURE);
    eval 'sub CAM_FALSE () {0;}' unless defined(&CAM_FALSE);
    eval 'sub CAM_TRUE () {1;}' unless defined(&CAM_TRUE);
    eval 'sub XPT_CCB_INVALID () {-1;}' unless defined(&XPT_CCB_INVALID);
}
1;
