require '_h2ph_pre.ph';

unless(defined(&_FLOATINGPOINT_H_)) {
    eval 'sub _FLOATINGPOINT_H_ () {1;}' unless defined(&_FLOATINGPOINT_H_);
    require 'sys/cdefs.ph';
    require 'machine/ieeefp.ph';
    if(defined(&__GNUC__)) {
	eval 'sub __fldenv {
	    local($addr) = @_;
    	    eval q( &__asm  &__volatile(\\"fldenv %0\\" : : \\"m\\" (*($addr))));
	}' unless defined(&__fldenv);
	eval 'sub __fnstenv {
	    local($addr) = @_;
    	    eval q( &__asm  &__volatile(\\"fnstenv %0\\" : \\"=m\\" (*($addr))));
	}' unless defined(&__fnstenv);
	eval 'sub __fnstcw {
	    local($addr) = @_;
    	    eval q( &__asm  &__volatile(\\"fnstcw %0\\" : \\"=m\\" (*($addr))));
	}' unless defined(&__fnstcw);
	eval 'sub __fnstsw {
	    local($addr) = @_;
    	    eval q( &__asm  &__volatile(\\"fnstsw %0\\" : \\"=m\\" (*($addr))));
	}' unless defined(&__fnstsw);
    }
    eval 'sub fpgetround () {
        eval q(( (( &__fpgetreg( &FP_RND_REG) &  &FP_RND_FLD) >>  &FP_RND_OFF)));
    }' unless defined(&fpgetround);
    eval 'sub fpsetround {
        local($m) = @_;
	    eval q((  &__fpsetreg(($m),  &FP_RND_REG,  &FP_RND_FLD,  &FP_RND_OFF)));
    }' unless defined(&fpsetround);
    eval 'sub fpgetprec () {
        eval q(( (( &__fpgetreg( &FP_PRC_REG) &  &FP_PRC_FLD) >>  &FP_PRC_OFF)));
    }' unless defined(&fpgetprec);
    eval 'sub fpsetprec {
        local($m) = @_;
	    eval q((  &__fpsetreg(($m),  &FP_PRC_REG,  &FP_PRC_FLD,  &FP_PRC_OFF)));
    }' unless defined(&fpsetprec);
    eval 'sub fpgetmask () {
        eval q(( ((~ &__fpgetreg( &FP_MSKS_REG) &  &FP_MSKS_FLD) >>  &FP_MSKS_OFF)));
    }' unless defined(&fpgetmask);
    eval 'sub fpsetmask {
        local($m) = @_;
	    eval q(( ( &__fpsetreg(~($m),  &FP_MSKS_REG,  &FP_MSKS_FLD,  &FP_MSKS_OFF))));
    }' unless defined(&fpsetmask);
    eval 'sub fpgetsticky () {
        eval q(( (( &__fpgetreg( &FP_STKY_REG) &  &FP_STKY_FLD) >>  &FP_STKY_OFF)));
    }' unless defined(&fpgetsticky);
    eval 'sub fpresetsticky {
        local($m) = @_;
	    eval q((  &__fpsetreg(0,  &FP_STKY_REG, ($m),  &FP_STKY_OFF)));
    }' unless defined(&fpresetsticky);
    eval 'sub fpsetsticky {
        local($m) = @_;
	    eval q( &fpresetsticky($m));
    }' unless defined(&fpsetsticky);
}
1;
