require '_h2ph_pre.ph';

unless(defined(&_BS_PRIMS)) {
    eval 'sub _BS_PRIMS () {1;}' unless defined(&_BS_PRIMS);
    eval 'sub _BS_CHAR_BIT () {8;}' unless defined(&_BS_CHAR_BIT);
    eval 'sub _BS_BITS_PER_WORD () {( &_BS_CHAR_BIT*$sizeof{ &_BS_word});}' unless defined(&_BS_BITS_PER_WORD);
    eval 'sub _BS_WORDS_NEEDED {
        local($NBITS) = @_;
	    eval q((($NBITS+ &_BS_BITS_PER_WORD-1)/ &_BS_BITS_PER_WORD));
    }' unless defined(&_BS_WORDS_NEEDED);
    if(defined(&CHILL_LIB)) {
	unless(defined(&BITS_BIG_ENDIAN)) {
	    require 'config.ph';
	}
	eval 'sub _BS_BIGENDIAN () { &BITS_BIG_ENDIAN;}' unless defined(&_BS_BIGENDIAN);
    } else {
	eval 'sub _BS_BIGENDIAN () {0;}' unless defined(&_BS_BIGENDIAN);
    }
    if((defined(&_BS_BIGENDIAN) ? &_BS_BIGENDIAN : 0)) {
	eval 'sub _BS_LEFT () {<<;}' unless defined(&_BS_LEFT);
	eval 'sub _BS_RIGHT () {>>;}' unless defined(&_BS_RIGHT);
    } else {
	eval 'sub _BS_LEFT () {>>;}' unless defined(&_BS_LEFT);
	eval 'sub _BS_RIGHT () {<<;}' unless defined(&_BS_RIGHT);
    }
    if((defined(&_BS_BIGENDIAN) ? &_BS_BIGENDIAN : 0)) {
	eval 'sub _BS_BITMASK {
	    local($BITNO) = @_;
    	    eval q((1<< ( &_BS_BITS_PER_WORD - 1- ($BITNO))));
	}' unless defined(&_BS_BITMASK);
    } else {
	eval 'sub _BS_BITMASK {
	    local($BITNO) = @_;
    	    eval q((1<< ($BITNO)));
	}' unless defined(&_BS_BITMASK);
    }
    eval 'sub _BS_ADJUST_ALIGNED {
        local($NEW_PTR, $PTR, $OFFSET) = @_;
	    eval q(( = ((-0) & ~( &sizeof-1)), += - ($NEW_PTR) ));
    }' unless defined(&_BS_ADJUST_ALIGNED);
    eval 'sub _BS_NORMALIZE {
        local($PTR, $OFFSET) = @_;
	    eval q({  &_BS_size_t  &__tmp_ind =  &_BS_INDEX ($OFFSET); ($PTR) +=  &__tmp_ind; ($OFFSET) -=  &__tmp_ind *  &_BS_BITS_PER_WORD; });
    }' unless defined(&_BS_NORMALIZE);
    eval 'sub _BS_INDEX {
        local($I) = @_;
	    eval q((($I) /  &_BS_BITS_PER_WORD));
    }' unless defined(&_BS_INDEX);
    eval 'sub _BS_POS {
        local($I) = @_;
	    eval q((($I) & ( &_BS_BITS_PER_WORD -1)));
    }' unless defined(&_BS_POS);
    unless(defined(&_BS_size_t)) {
	if((defined(&__GNUC__) ? &__GNUC__ : 0) > 1) {
	    eval 'sub _BS_size_t () { &__SIZE_TYPE__;}' unless defined(&_BS_size_t);
	} else {
	    eval 'sub _BS_size_t () {\'unsigned long\';}' unless defined(&_BS_size_t);
	}
    }
    unless(defined(&__P)) {
	if(defined(&__STDC__)) {
	    eval 'sub __P {
	        local($protos) = @_;
    		eval q($protos);
	    }' unless defined(&__P);
	} else {
	    eval 'sub __P {
	        local($protos) = @_;
    		eval q(());
	    }' unless defined(&__P);
	}
    }
    if(!defined( &__STDC__)  && !defined( &const)) {
	eval 'sub const () {1;}' unless defined(&const);
    }
    if(!defined( &__STDC__)  && !defined( &void)) {
	eval 'sub void () {\'int\';}' unless defined(&void);
    }
    eval("sub _BS_alu_clear () { 0; }") unless defined(&_BS_alu_clear);
    eval("sub _BS_alu_and () { 1; }") unless defined(&_BS_alu_and);
    eval("sub _BS_alu_andReverse () { 2; }") unless defined(&_BS_alu_andReverse);
    eval("sub _BS_alu_copy () { 3; }") unless defined(&_BS_alu_copy);
    eval("sub _BS_alu_andInverted () { 4; }") unless defined(&_BS_alu_andInverted);
    eval("sub _BS_alu_noop () { 5; }") unless defined(&_BS_alu_noop);
    eval("sub _BS_alu_xor () { 6; }") unless defined(&_BS_alu_xor);
    eval("sub _BS_alu_or () { 7; }") unless defined(&_BS_alu_or);
    eval("sub _BS_alu_nor () { 8; }") unless defined(&_BS_alu_nor);
    eval("sub _BS_alu_equiv () { 9; }") unless defined(&_BS_alu_equiv);
    eval("sub _BS_alu_invert () { 10; }") unless defined(&_BS_alu_invert);
    eval("sub _BS_alu_orReverse () { 11; }") unless defined(&_BS_alu_orReverse);
    eval("sub _BS_alu_copyInverted () { 12; }") unless defined(&_BS_alu_copyInverted);
    eval("sub _BS_alu_orInverted () { 13; }") unless defined(&_BS_alu_orInverted);
    eval("sub _BS_alu_nand () { 14; }") unless defined(&_BS_alu_nand);
    eval("sub _BS_alu_set () { 15; }") unless defined(&_BS_alu_set);
    eval 'sub _BS () {1;}' unless defined(&_BS);
    eval 'sub _BS () {1;}' unless defined(&_BS);
    if(defined(&__cplusplus)) {
    }
    eval 'sub _BS_copy_0 {
        local($DS, $SS, $LENGTH) = @_;
	    eval q( &_BS_copy($DS, 0, $SS, 0, $LENGTH));
    }' unless defined(&_BS_copy_0);
    if(defined(&__cplusplus)) {
    }
}
1;
