require '_h2ph_pre.ph';

unless(defined(&_T)) {
    sub _T {
	local($type) = @_;
	eval q( &typeof($type));
    }
}
unless(defined(&pointer_to)) {
    sub pointer_to {
	local($type) = @_;
	eval q( &_T( &_T($type)*));
    }
}
unless(defined(&member_of)) {
    sub member_of {
	local($cls,$type) = @_;
	eval q( &_T( &_T $cls::));
    }
}
unless(defined(&function)) {
    sub function {
	local($res, $args) = @_;
	eval q( &_T( &_T $args));
    }
}
unless(defined(&_xq_yq)) {
    sub _xq_yq {
	local($x,$y) = @_;
	eval q($x   &_  $y);
    }
}
unless(defined(&_x_y)) {
    sub _x_y {
	local($x,$y) = @_;
	eval q( &_xq_yq($x,$y));
    }
}
unless(defined(&_gensym)) {
    sub _gensym {
	local($stem) = @_;
	eval q( &_x_y($stem,  &__LINE__));
    }
}
1;
