require '_h2ph_pre.ph';

unless(defined(&_MACHINE_APIC_H_)) {
    eval 'sub _MACHINE_APIC_H_ () {1;}' unless defined(&_MACHINE_APIC_H_);
    unless(defined(&LOCORE)) {
	require 'sys/types.ph';
	eval 'sub PAD3 () {\'int\' : 32; \'int\' : 32; \'int\' : 32;}' unless defined(&PAD3);
	eval 'sub PAD4 () {\'int\' : 32; \'int\' : 32; \'int\' : 32; \'int\' : 32;}' unless defined(&PAD4);
	undef(&PAD4) if defined(&PAD4);
	undef(&PAD3) if defined(&PAD3);
    }
    eval 'sub LOPRIO_LEVEL () {0x00000010;}' unless defined(&LOPRIO_LEVEL);
    if(defined(&GRAB_LOPRIO)) {
	eval 'sub ALLHWI_LEVEL () {0x00000000;}' unless defined(&ALLHWI_LEVEL);
    }
    eval 'sub COUNT_FIELD () {0x00ffffff;}' unless defined(&COUNT_FIELD);
    eval 'sub FREE_LOCK () {0xffffffff;}' unless defined(&FREE_LOCK);
    eval 'sub CHEAP_TPR () {1;}' unless defined(&CHEAP_TPR);
    eval 'sub DEFAULT_APIC_BASE () {0xfee00000;}' unless defined(&DEFAULT_APIC_BASE);
    eval 'sub APIC_VER_VERSION () {0x000000ff;}' unless defined(&APIC_VER_VERSION);
    eval 'sub APIC_VER_MAXLVT () {0x00ff0000;}' unless defined(&APIC_VER_MAXLVT);
    eval 'sub MAXLVTSHIFT () {16;}' unless defined(&MAXLVTSHIFT);
    eval 'sub APIC_SVR_VECTOR () {0x000000ff;}' unless defined(&APIC_SVR_VECTOR);
    eval 'sub APIC_SVR_VEC_PROG () {0x000000f0;}' unless defined(&APIC_SVR_VEC_PROG);
    eval 'sub APIC_SVR_VEC_FIX () {0x0000000f;}' unless defined(&APIC_SVR_VEC_FIX);
    eval 'sub APIC_SVR_ENABLE () {0x00000100;}' unless defined(&APIC_SVR_ENABLE);
    eval 'sub APIC_SVR_SWDIS () {0x00000000;}' unless defined(&APIC_SVR_SWDIS);
    eval 'sub APIC_SVR_SWEN () {0x00000100;}' unless defined(&APIC_SVR_SWEN);
    eval 'sub APIC_SVR_FOCUS () {0x00000200;}' unless defined(&APIC_SVR_FOCUS);
    eval 'sub APIC_SVR_FEN () {0x00000000;}' unless defined(&APIC_SVR_FEN);
    eval 'sub APIC_SVR_FDIS () {0x00000200;}' unless defined(&APIC_SVR_FDIS);
    eval 'sub APIC_TPR_PRIO () {0x000000ff;}' unless defined(&APIC_TPR_PRIO);
    eval 'sub APIC_TPR_INT () {0x000000f0;}' unless defined(&APIC_TPR_INT);
    eval 'sub APIC_TPR_SUB () {0x0000000f;}' unless defined(&APIC_TPR_SUB);
    eval 'sub APIC_VECTOR_MASK () {0x000000ff;}' unless defined(&APIC_VECTOR_MASK);
    eval 'sub APIC_DELMODE_MASK () {0x00000700;}' unless defined(&APIC_DELMODE_MASK);
    eval 'sub APIC_DELMODE_FIXED () {0x00000000;}' unless defined(&APIC_DELMODE_FIXED);
    eval 'sub APIC_DELMODE_LOWPRIO () {0x00000100;}' unless defined(&APIC_DELMODE_LOWPRIO);
    eval 'sub APIC_DELMODE_SMI () {0x00000200;}' unless defined(&APIC_DELMODE_SMI);
    eval 'sub APIC_DELMODE_RR () {0x00000300;}' unless defined(&APIC_DELMODE_RR);
    eval 'sub APIC_DELMODE_NMI () {0x00000400;}' unless defined(&APIC_DELMODE_NMI);
    eval 'sub APIC_DELMODE_INIT () {0x00000500;}' unless defined(&APIC_DELMODE_INIT);
    eval 'sub APIC_DELMODE_STARTUP () {0x00000600;}' unless defined(&APIC_DELMODE_STARTUP);
    eval 'sub APIC_DELMODE_RESV () {0x00000700;}' unless defined(&APIC_DELMODE_RESV);
    eval 'sub APIC_DESTMODE_MASK () {0x00000800;}' unless defined(&APIC_DESTMODE_MASK);
    eval 'sub APIC_DESTMODE_PHY () {0x00000000;}' unless defined(&APIC_DESTMODE_PHY);
    eval 'sub APIC_DESTMODE_LOG () {0x00000800;}' unless defined(&APIC_DESTMODE_LOG);
    eval 'sub APIC_DELSTAT_MASK () {0x00001000;}' unless defined(&APIC_DELSTAT_MASK);
    eval 'sub APIC_DELSTAT_IDLE () {0x00000000;}' unless defined(&APIC_DELSTAT_IDLE);
    eval 'sub APIC_DELSTAT_PEND () {0x00001000;}' unless defined(&APIC_DELSTAT_PEND);
    eval 'sub APIC_RESV1_MASK () {0x00002000;}' unless defined(&APIC_RESV1_MASK);
    eval 'sub APIC_LEVEL_MASK () {0x00004000;}' unless defined(&APIC_LEVEL_MASK);
    eval 'sub APIC_LEVEL_DEASSERT () {0x00000000;}' unless defined(&APIC_LEVEL_DEASSERT);
    eval 'sub APIC_LEVEL_ASSERT () {0x00004000;}' unless defined(&APIC_LEVEL_ASSERT);
    eval 'sub APIC_TRIGMOD_MASK () {0x00008000;}' unless defined(&APIC_TRIGMOD_MASK);
    eval 'sub APIC_TRIGMOD_EDGE () {0x00000000;}' unless defined(&APIC_TRIGMOD_EDGE);
    eval 'sub APIC_TRIGMOD_LEVEL () {0x00008000;}' unless defined(&APIC_TRIGMOD_LEVEL);
    eval 'sub APIC_RRSTAT_MASK () {0x00030000;}' unless defined(&APIC_RRSTAT_MASK);
    eval 'sub APIC_RRSTAT_INVALID () {0x00000000;}' unless defined(&APIC_RRSTAT_INVALID);
    eval 'sub APIC_RRSTAT_INPROG () {0x00010000;}' unless defined(&APIC_RRSTAT_INPROG);
    eval 'sub APIC_RRSTAT_VALID () {0x00020000;}' unless defined(&APIC_RRSTAT_VALID);
    eval 'sub APIC_RRSTAT_RESV () {0x00030000;}' unless defined(&APIC_RRSTAT_RESV);
    eval 'sub APIC_DEST_MASK () {0x000c0000;}' unless defined(&APIC_DEST_MASK);
    eval 'sub APIC_DEST_DESTFLD () {0x00000000;}' unless defined(&APIC_DEST_DESTFLD);
    eval 'sub APIC_DEST_SELF () {0x00040000;}' unless defined(&APIC_DEST_SELF);
    eval 'sub APIC_DEST_ALLISELF () {0x00080000;}' unless defined(&APIC_DEST_ALLISELF);
    eval 'sub APIC_DEST_ALLESELF () {0x000c0000;}' unless defined(&APIC_DEST_ALLESELF);
    eval 'sub APIC_RESV2_MASK () {0xfff00000;}' unless defined(&APIC_RESV2_MASK);
    eval 'sub APIC_ID_MASK () {0x0f000000;}' unless defined(&APIC_ID_MASK);
    eval 'sub APIC_LVT_VECTOR () {0x000000ff;}' unless defined(&APIC_LVT_VECTOR);
    eval 'sub APIC_LVT_DM () {0x00000700;}' unless defined(&APIC_LVT_DM);
    eval 'sub APIC_LVT_DM_FIXED () {0x00000000;}' unless defined(&APIC_LVT_DM_FIXED);
    eval 'sub APIC_LVT_DM_NMI () {0x00000400;}' unless defined(&APIC_LVT_DM_NMI);
    eval 'sub APIC_LVT_DM_EXTINT () {0x00000700;}' unless defined(&APIC_LVT_DM_EXTINT);
    eval 'sub APIC_LVT_DS () {0x00001000;}' unless defined(&APIC_LVT_DS);
    eval 'sub APIC_LVT_IIPP () {0x00002000;}' unless defined(&APIC_LVT_IIPP);
    eval 'sub APIC_LVT_IIPP_INTALO () {0x00002000;}' unless defined(&APIC_LVT_IIPP_INTALO);
    eval 'sub APIC_LVT_IIPP_INTAHI () {0x00000000;}' unless defined(&APIC_LVT_IIPP_INTAHI);
    eval 'sub APIC_LVT_RIRR () {0x00004000;}' unless defined(&APIC_LVT_RIRR);
    eval 'sub APIC_LVT_TM () {0x00008000;}' unless defined(&APIC_LVT_TM);
    eval 'sub APIC_LVT_M () {0x00010000;}' unless defined(&APIC_LVT_M);
    eval 'sub APIC_LVTT_VECTOR () {0x000000ff;}' unless defined(&APIC_LVTT_VECTOR);
    eval 'sub APIC_LVTT_DS () {0x00001000;}' unless defined(&APIC_LVTT_DS);
    eval 'sub APIC_LVTT_M () {0x00010000;}' unless defined(&APIC_LVTT_M);
    eval 'sub APIC_LVTT_TM () {0x00020000;}' unless defined(&APIC_LVTT_TM);
    eval 'sub APIC_TDCR_2 () {0x00;}' unless defined(&APIC_TDCR_2);
    eval 'sub APIC_TDCR_4 () {0x01;}' unless defined(&APIC_TDCR_4);
    eval 'sub APIC_TDCR_8 () {0x02;}' unless defined(&APIC_TDCR_8);
    eval 'sub APIC_TDCR_16 () {0x03;}' unless defined(&APIC_TDCR_16);
    eval 'sub APIC_TDCR_32 () {0x08;}' unless defined(&APIC_TDCR_32);
    eval 'sub APIC_TDCR_64 () {0x09;}' unless defined(&APIC_TDCR_64);
    eval 'sub APIC_TDCR_128 () {0x0a;}' unless defined(&APIC_TDCR_128);
    eval 'sub APIC_TDCR_1 () {0x0b;}' unless defined(&APIC_TDCR_1);
    eval 'sub APIC_IRQ0 () {0x00000001;}' unless defined(&APIC_IRQ0);
    eval 'sub APIC_IRQ1 () {0x00000002;}' unless defined(&APIC_IRQ1);
    eval 'sub APIC_IRQ2 () {0x00000004;}' unless defined(&APIC_IRQ2);
    eval 'sub APIC_IRQ3 () {0x00000008;}' unless defined(&APIC_IRQ3);
    eval 'sub APIC_IRQ4 () {0x00000010;}' unless defined(&APIC_IRQ4);
    eval 'sub APIC_IRQ5 () {0x00000020;}' unless defined(&APIC_IRQ5);
    eval 'sub APIC_IRQ6 () {0x00000040;}' unless defined(&APIC_IRQ6);
    eval 'sub APIC_IRQ7 () {0x00000080;}' unless defined(&APIC_IRQ7);
    eval 'sub APIC_IRQ8 () {0x00000100;}' unless defined(&APIC_IRQ8);
    eval 'sub APIC_IRQ9 () {0x00000200;}' unless defined(&APIC_IRQ9);
    eval 'sub APIC_IRQ10 () {0x00000400;}' unless defined(&APIC_IRQ10);
    eval 'sub APIC_IRQ11 () {0x00000800;}' unless defined(&APIC_IRQ11);
    eval 'sub APIC_IRQ12 () {0x00001000;}' unless defined(&APIC_IRQ12);
    eval 'sub APIC_IRQ13 () {0x00002000;}' unless defined(&APIC_IRQ13);
    eval 'sub APIC_IRQ14 () {0x00004000;}' unless defined(&APIC_IRQ14);
    eval 'sub APIC_IRQ15 () {0x00008000;}' unless defined(&APIC_IRQ15);
    eval 'sub APIC_IRQ16 () {0x00010000;}' unless defined(&APIC_IRQ16);
    eval 'sub APIC_IRQ17 () {0x00020000;}' unless defined(&APIC_IRQ17);
    eval 'sub APIC_IRQ18 () {0x00040000;}' unless defined(&APIC_IRQ18);
    eval 'sub APIC_IRQ19 () {0x00080000;}' unless defined(&APIC_IRQ19);
    eval 'sub APIC_IRQ20 () {0x00100000;}' unless defined(&APIC_IRQ20);
    eval 'sub APIC_IRQ21 () {0x00200000;}' unless defined(&APIC_IRQ21);
    eval 'sub APIC_IRQ22 () {0x00400000;}' unless defined(&APIC_IRQ22);
    eval 'sub APIC_IRQ23 () {0x00800000;}' unless defined(&APIC_IRQ23);
    eval 'sub DEFAULT_IO_APIC_BASE () {0xfec00000;}' unless defined(&DEFAULT_IO_APIC_BASE);
    eval 'sub IOAPIC_WINDOW () {0x10;}' unless defined(&IOAPIC_WINDOW);
    eval 'sub IOAPIC_ID () {0x00;}' unless defined(&IOAPIC_ID);
    eval 'sub IOAPIC_VER () {0x01;}' unless defined(&IOAPIC_VER);
    eval 'sub IOAPIC_ARB () {0x02;}' unless defined(&IOAPIC_ARB);
    eval 'sub IOAPIC_REDTBL () {0x10;}' unless defined(&IOAPIC_REDTBL);
    eval 'sub IOAPIC_REDTBL0 () { &IOAPIC_REDTBL;}' unless defined(&IOAPIC_REDTBL0);
    eval 'sub IOAPIC_REDTBL1 () {( &IOAPIC_REDTBL+0x02);}' unless defined(&IOAPIC_REDTBL1);
    eval 'sub IOAPIC_REDTBL2 () {( &IOAPIC_REDTBL+0x04);}' unless defined(&IOAPIC_REDTBL2);
    eval 'sub IOAPIC_REDTBL3 () {( &IOAPIC_REDTBL+0x06);}' unless defined(&IOAPIC_REDTBL3);
    eval 'sub IOAPIC_REDTBL4 () {( &IOAPIC_REDTBL+0x08);}' unless defined(&IOAPIC_REDTBL4);
    eval 'sub IOAPIC_REDTBL5 () {( &IOAPIC_REDTBL+0x0a);}' unless defined(&IOAPIC_REDTBL5);
    eval 'sub IOAPIC_REDTBL6 () {( &IOAPIC_REDTBL+0x0c);}' unless defined(&IOAPIC_REDTBL6);
    eval 'sub IOAPIC_REDTBL7 () {( &IOAPIC_REDTBL+0x0e);}' unless defined(&IOAPIC_REDTBL7);
    eval 'sub IOAPIC_REDTBL8 () {( &IOAPIC_REDTBL+0x10);}' unless defined(&IOAPIC_REDTBL8);
    eval 'sub IOAPIC_REDTBL9 () {( &IOAPIC_REDTBL+0x12);}' unless defined(&IOAPIC_REDTBL9);
    eval 'sub IOAPIC_REDTBL10 () {( &IOAPIC_REDTBL+0x14);}' unless defined(&IOAPIC_REDTBL10);
    eval 'sub IOAPIC_REDTBL11 () {( &IOAPIC_REDTBL+0x16);}' unless defined(&IOAPIC_REDTBL11);
    eval 'sub IOAPIC_REDTBL12 () {( &IOAPIC_REDTBL+0x18);}' unless defined(&IOAPIC_REDTBL12);
    eval 'sub IOAPIC_REDTBL13 () {( &IOAPIC_REDTBL+0x1a);}' unless defined(&IOAPIC_REDTBL13);
    eval 'sub IOAPIC_REDTBL14 () {( &IOAPIC_REDTBL+0x1c);}' unless defined(&IOAPIC_REDTBL14);
    eval 'sub IOAPIC_REDTBL15 () {( &IOAPIC_REDTBL+0x1e);}' unless defined(&IOAPIC_REDTBL15);
    eval 'sub IOAPIC_REDTBL16 () {( &IOAPIC_REDTBL+0x20);}' unless defined(&IOAPIC_REDTBL16);
    eval 'sub IOAPIC_REDTBL17 () {( &IOAPIC_REDTBL+0x22);}' unless defined(&IOAPIC_REDTBL17);
    eval 'sub IOAPIC_REDTBL18 () {( &IOAPIC_REDTBL+0x24);}' unless defined(&IOAPIC_REDTBL18);
    eval 'sub IOAPIC_REDTBL19 () {( &IOAPIC_REDTBL+0x26);}' unless defined(&IOAPIC_REDTBL19);
    eval 'sub IOAPIC_REDTBL20 () {( &IOAPIC_REDTBL+0x28);}' unless defined(&IOAPIC_REDTBL20);
    eval 'sub IOAPIC_REDTBL21 () {( &IOAPIC_REDTBL+0x2a);}' unless defined(&IOAPIC_REDTBL21);
    eval 'sub IOAPIC_REDTBL22 () {( &IOAPIC_REDTBL+0x2c);}' unless defined(&IOAPIC_REDTBL22);
    eval 'sub IOAPIC_REDTBL23 () {( &IOAPIC_REDTBL+0x2e);}' unless defined(&IOAPIC_REDTBL23);
    eval 'sub IOART_VER_VERSION () {0x000000ff;}' unless defined(&IOART_VER_VERSION);
    eval 'sub IOART_VER_MAXREDIR () {0x00ff0000;}' unless defined(&IOART_VER_MAXREDIR);
    eval 'sub MAXREDIRSHIFT () {16;}' unless defined(&MAXREDIRSHIFT);
    eval 'sub IOART_DEST () { &APIC_ID_MASK;}' unless defined(&IOART_DEST);
    eval 'sub IOART_RESV () {0x00fe0000;}' unless defined(&IOART_RESV);
    eval 'sub IOART_INTMASK () {0x00010000;}' unless defined(&IOART_INTMASK);
    eval 'sub IOART_INTMCLR () {0x00000000;}' unless defined(&IOART_INTMCLR);
    eval 'sub IOART_INTMSET () {0x00010000;}' unless defined(&IOART_INTMSET);
    eval 'sub IOART_TRGRMOD () {0x00008000;}' unless defined(&IOART_TRGRMOD);
    eval 'sub IOART_TRGREDG () {0x00000000;}' unless defined(&IOART_TRGREDG);
    eval 'sub IOART_TRGRLVL () {0x00008000;}' unless defined(&IOART_TRGRLVL);
    eval 'sub IOART_REM_IRR () {0x00004000;}' unless defined(&IOART_REM_IRR);
    eval 'sub IOART_INTPOL () {0x00002000;}' unless defined(&IOART_INTPOL);
    eval 'sub IOART_INTAHI () {0x00000000;}' unless defined(&IOART_INTAHI);
    eval 'sub IOART_INTALO () {0x00002000;}' unless defined(&IOART_INTALO);
    eval 'sub IOART_DELIVS () {0x00001000;}' unless defined(&IOART_DELIVS);
    eval 'sub IOART_DESTMOD () {0x00000800;}' unless defined(&IOART_DESTMOD);
    eval 'sub IOART_DESTPHY () {0x00000000;}' unless defined(&IOART_DESTPHY);
    eval 'sub IOART_DESTLOG () {0x00000800;}' unless defined(&IOART_DESTLOG);
    eval 'sub IOART_DELMOD () {0x00000700;}' unless defined(&IOART_DELMOD);
    eval 'sub IOART_DELFIXED () {0x00000000;}' unless defined(&IOART_DELFIXED);
    eval 'sub IOART_DELLOPRI () {0x00000100;}' unless defined(&IOART_DELLOPRI);
    eval 'sub IOART_DELSMI () {0x00000200;}' unless defined(&IOART_DELSMI);
    eval 'sub IOART_DELRSV1 () {0x00000300;}' unless defined(&IOART_DELRSV1);
    eval 'sub IOART_DELNMI () {0x00000400;}' unless defined(&IOART_DELNMI);
    eval 'sub IOART_DELINIT () {0x00000500;}' unless defined(&IOART_DELINIT);
    eval 'sub IOART_DELRSV2 () {0x00000600;}' unless defined(&IOART_DELRSV2);
    eval 'sub IOART_DELEXINT () {0x00000700;}' unless defined(&IOART_DELEXINT);
    eval 'sub IOART_INTVEC () {0x000000ff;}' unless defined(&IOART_INTVEC);
}
1;
