require '_h2ph_pre.ph';

unless(defined(&_MACHINE_CONSOLE_H_)) {
    eval 'sub _MACHINE_CONSOLE_H_ () {1;}' unless defined(&_MACHINE_CONSOLE_H_);
    unless(defined(&KERNEL)) {
	require 'sys/types.ph';
    }
    require 'sys/ioccom.ph';
    eval 'sub KDGKBMODE () { &_IOR(ord(\'K\'), 6, \'int\');}' unless defined(&KDGKBMODE);
    eval 'sub KDSKBMODE () { &_IO(ord(\'K\'), 7);}' unless defined(&KDSKBMODE);
    eval 'sub KDMKTONE () { &_IO(ord(\'K\'), 8);}' unless defined(&KDMKTONE);
    eval 'sub KDGETMODE () { &_IOR(ord(\'K\'), 9, \'int\');}' unless defined(&KDGETMODE);
    eval 'sub KDSETMODE () { &_IO(ord(\'K\'), 10);}' unless defined(&KDSETMODE);
    eval 'sub KDSBORDER () { &_IO(ord(\'K\'), 13);}' unless defined(&KDSBORDER);
    eval 'sub KDGKBSTATE () { &_IOR(ord(\'K\'), 19, \'int\');}' unless defined(&KDGKBSTATE);
    eval 'sub KDSKBSTATE () { &_IO(ord(\'K\'), 20);}' unless defined(&KDSKBSTATE);
    eval 'sub KDENABIO () { &_IO(ord(\'K\'), 60);}' unless defined(&KDENABIO);
    eval 'sub KDDISABIO () { &_IO(ord(\'K\'), 61);}' unless defined(&KDDISABIO);
    eval 'sub KIOCSOUND () { &_IO(ord(\'K\'), 63);}' unless defined(&KIOCSOUND);
    eval 'sub KDGKBTYPE () { &_IOR(ord(\'K\'), 64, \'int\');}' unless defined(&KDGKBTYPE);
    eval 'sub KDGETLED () { &_IOR(ord(\'K\'), 65, \'int\');}' unless defined(&KDGETLED);
    eval 'sub KDSETLED () { &_IO(ord(\'K\'), 66);}' unless defined(&KDSETLED);
    eval 'sub KDSETRAD () { &_IO(ord(\'K\'), 67);}' unless defined(&KDSETRAD);
    eval 'sub KDRASTER () { &_IOW(ord(\'K\'), 100,  &scr_size_t);}' unless defined(&KDRASTER);
    eval 'sub KDGKBINFO () { &_IOR(ord(\'K\'), 101,  &keyboard_info_t);}' unless defined(&KDGKBINFO);
    eval 'sub KDSETREPEAT () { &_IOW(ord(\'K\'), 102,  &keyboard_delay_t);}' unless defined(&KDSETREPEAT);
    eval 'sub KDGETREPEAT () { &_IOR(ord(\'K\'), 103,  &keyboard_delay_t);}' unless defined(&KDGETREPEAT);
    eval 'sub GETFKEY () { &_IOWR(ord(\'k\'), 0,  &fkeyarg_t);}' unless defined(&GETFKEY);
    eval 'sub SETFKEY () { &_IOWR(ord(\'k\'), 1,  &fkeyarg_t);}' unless defined(&SETFKEY);
    eval 'sub GIO_SCRNMAP () { &_IOR(ord(\'k\'), 2,  &scrmap_t);}' unless defined(&GIO_SCRNMAP);
    eval 'sub PIO_SCRNMAP () { &_IOW(ord(\'k\'), 3,  &scrmap_t);}' unless defined(&PIO_SCRNMAP);
    eval 'sub GIO_KEYMAP () { &_IOR(ord(\'k\'), 6,  &keymap_t);}' unless defined(&GIO_KEYMAP);
    eval 'sub PIO_KEYMAP () { &_IOW(ord(\'k\'), 7,  &keymap_t);}' unless defined(&PIO_KEYMAP);
    eval 'sub GIO_DEADKEYMAP () { &_IOR(ord(\'k\'), 8,  &accentmap_t);}' unless defined(&GIO_DEADKEYMAP);
    eval 'sub PIO_DEADKEYMAP () { &_IOW(ord(\'k\'), 9,  &accentmap_t);}' unless defined(&PIO_DEADKEYMAP);
    eval 'sub GIO_KEYMAPENT () { &_IOWR(ord(\'k\'), 10,  &keyarg_t);}' unless defined(&GIO_KEYMAPENT);
    eval 'sub PIO_KEYMAPENT () { &_IOW(ord(\'k\'), 11,  &keyarg_t);}' unless defined(&PIO_KEYMAPENT);
    eval 'sub GIO_ATTR () { &_IOR(ord(\'a\'), 0, \'int\');}' unless defined(&GIO_ATTR);
    eval 'sub GIO_COLOR () { &_IOR(ord(\'c\'), 0, \'int\');}' unless defined(&GIO_COLOR);
    eval 'sub CONS_CURRENT () { &_IOR(ord(\'c\'), 1, \'int\');}' unless defined(&CONS_CURRENT);
    eval 'sub CONS_GET () { &_IOR(ord(\'c\'), 2, \'int\');}' unless defined(&CONS_GET);
    eval 'sub CONS_IO () { &_IO(ord(\'c\'), 3);}' unless defined(&CONS_IO);
    eval 'sub CONS_BLANKTIME () { &_IOW(ord(\'c\'), 4, \'int\');}' unless defined(&CONS_BLANKTIME);
    eval 'sub CONS_SSAVER () { &_IOW(ord(\'c\'), 5,  &ssaver_t);}' unless defined(&CONS_SSAVER);
    eval 'sub CONS_GSAVER () { &_IOWR(ord(\'c\'), 6,  &ssaver_t);}' unless defined(&CONS_GSAVER);
    eval 'sub CONS_CURSORTYPE () { &_IOW(ord(\'c\'), 7, \'int\');}' unless defined(&CONS_CURSORTYPE);
    eval 'sub CONS_BELLTYPE () { &_IOW(ord(\'c\'), 8, \'int\');}' unless defined(&CONS_BELLTYPE);
    eval 'sub CONS_HISTORY () { &_IOW(ord(\'c\'), 9, \'int\');}' unless defined(&CONS_HISTORY);
    eval 'sub CONS_MOUSECTL () { &_IOWR(ord(\'c\'), 10,  &mouse_info_t);}' unless defined(&CONS_MOUSECTL);
    eval 'sub CONS_IDLE () { &_IOR(ord(\'c\'), 11, \'int\');}' unless defined(&CONS_IDLE);
    eval 'sub CONS_SAVERMODE () { &_IOW(ord(\'c\'), 12, \'int\');}' unless defined(&CONS_SAVERMODE);
    eval 'sub CONS_SAVERSTART () { &_IOW(ord(\'c\'), 13, \'int\');}' unless defined(&CONS_SAVERSTART);
    eval 'sub PIO_FONT8x8 () { &_IOW(ord(\'c\'), 64,  &fnt8_t);}' unless defined(&PIO_FONT8x8);
    eval 'sub GIO_FONT8x8 () { &_IOR(ord(\'c\'), 65,  &fnt8_t);}' unless defined(&GIO_FONT8x8);
    eval 'sub PIO_FONT8x14 () { &_IOW(ord(\'c\'), 66,  &fnt14_t);}' unless defined(&PIO_FONT8x14);
    eval 'sub GIO_FONT8x14 () { &_IOR(ord(\'c\'), 67,  &fnt14_t);}' unless defined(&GIO_FONT8x14);
    eval 'sub PIO_FONT8x16 () { &_IOW(ord(\'c\'), 68,  &fnt16_t);}' unless defined(&PIO_FONT8x16);
    eval 'sub GIO_FONT8x16 () { &_IOR(ord(\'c\'), 69,  &fnt16_t);}' unless defined(&GIO_FONT8x16);
    eval 'sub CONS_GETINFO () { &_IOWR(ord(\'c\'), 73,  &vid_info_t);}' unless defined(&CONS_GETINFO);
    eval 'sub CONS_GETVERS () { &_IOR(ord(\'c\'), 74, \'int\');}' unless defined(&CONS_GETVERS);
    eval 'sub CONS_CURRENTADP () { &_IOR(ord(\'c\'), 100, \'int\');}' unless defined(&CONS_CURRENTADP);
    eval 'sub CONS_ADPINFO () { &_IOWR(ord(\'c\'), 101,  &video_adapter_info_t);}' unless defined(&CONS_ADPINFO);
    eval 'sub CONS_MODEINFO () { &_IOWR(ord(\'c\'), 102,  &video_info_t);}' unless defined(&CONS_MODEINFO);
    eval 'sub CONS_FINDMODE () { &_IOWR(ord(\'c\'), 103,  &video_info_t);}' unless defined(&CONS_FINDMODE);
    eval 'sub CONS_SETWINORG () { &_IO(ord(\'c\'), 104);}' unless defined(&CONS_SETWINORG);
    eval 'sub CONS_SETKBD () { &_IO(ord(\'c\'), 110);}' unless defined(&CONS_SETKBD);
    eval 'sub CONS_RELKBD () { &_IO(ord(\'c\'), 111);}' unless defined(&CONS_RELKBD);
    eval 'sub CONS_LKM_SAVER () {0;}' unless defined(&CONS_LKM_SAVER);
    eval 'sub CONS_USR_SAVER () {1;}' unless defined(&CONS_USR_SAVER);
    if(defined(&PC98)) {
	eval 'sub ADJUST_CLOCK () { &_IO(ord(\'t\'),100);}' unless defined(&ADJUST_CLOCK);
    }
    eval 'sub VT_OPENQRY () { &_IOR(ord(\'v\'), 1, \'int\');}' unless defined(&VT_OPENQRY);
    eval 'sub VT_SETMODE () { &_IOW(ord(\'v\'), 2,  &vtmode_t);}' unless defined(&VT_SETMODE);
    eval 'sub VT_GETMODE () { &_IOR(ord(\'v\'), 3,  &vtmode_t);}' unless defined(&VT_GETMODE);
    eval 'sub VT_RELDISP () { &_IO(ord(\'v\'), 4);}' unless defined(&VT_RELDISP);
    eval 'sub VT_ACTIVATE () { &_IO(ord(\'v\'), 5);}' unless defined(&VT_ACTIVATE);
    eval 'sub VT_WAITACTIVE () { &_IO(ord(\'v\'), 6);}' unless defined(&VT_WAITACTIVE);
    eval 'sub VT_GETACTIVE () { &_IOR(ord(\'v\'), 7, \'int\');}' unless defined(&VT_GETACTIVE);
    eval 'sub VT_FALSE () {0;}' unless defined(&VT_FALSE);
    eval 'sub VT_TRUE () {1;}' unless defined(&VT_TRUE);
    eval 'sub VT_ACKACQ () {2;}' unless defined(&VT_ACKACQ);
    eval 'sub VT_AUTO () {0;}' unless defined(&VT_AUTO);
    eval 'sub VT_PROCESS () {1;}' unless defined(&VT_PROCESS);
    eval 'sub VT_KERNEL () {255;}' unless defined(&VT_KERNEL);
    unless(defined(&_VT_MODE_DECLARED)) {
	eval 'sub _VT_MODE_DECLARED () {1;}' unless defined(&_VT_MODE_DECLARED);
    }
    eval 'sub MOUSE_SHOW () {0x01;}' unless defined(&MOUSE_SHOW);
    eval 'sub MOUSE_HIDE () {0x02;}' unless defined(&MOUSE_HIDE);
    eval 'sub MOUSE_MOVEABS () {0x03;}' unless defined(&MOUSE_MOVEABS);
    eval 'sub MOUSE_MOVEREL () {0x04;}' unless defined(&MOUSE_MOVEREL);
    eval 'sub MOUSE_GETINFO () {0x05;}' unless defined(&MOUSE_GETINFO);
    eval 'sub MOUSE_MODE () {0x06;}' unless defined(&MOUSE_MODE);
    eval 'sub MOUSE_ACTION () {0x07;}' unless defined(&MOUSE_ACTION);
    eval 'sub MOUSE_MOTION_EVENT () {0x08;}' unless defined(&MOUSE_MOTION_EVENT);
    eval 'sub MOUSE_BUTTON_EVENT () {0x09;}' unless defined(&MOUSE_BUTTON_EVENT);
    eval 'sub MOUSE_MOUSECHAR () {0x0a;}' unless defined(&MOUSE_MOUSECHAR);
    eval 'sub KD_MONO () {1;}' unless defined(&KD_MONO);
    eval 'sub KD_HERCULES () {2;}' unless defined(&KD_HERCULES);
    eval 'sub KD_CGA () {3;}' unless defined(&KD_CGA);
    eval 'sub KD_EGA () {4;}' unless defined(&KD_EGA);
    eval 'sub KD_VGA () {5;}' unless defined(&KD_VGA);
    eval 'sub KD_PC98 () {6;}' unless defined(&KD_PC98);
    eval 'sub KD_TEXT () {0;}' unless defined(&KD_TEXT);
    eval 'sub KD_TEXT0 () {0;}' unless defined(&KD_TEXT0);
    eval 'sub KD_TEXT1 () {2;}' unless defined(&KD_TEXT1);
    eval 'sub KD_GRAPHICS () {1;}' unless defined(&KD_GRAPHICS);
    eval 'sub KD_PIXEL () {3;}' unless defined(&KD_PIXEL);
    eval 'sub K_RAW () {0;}' unless defined(&K_RAW);
    eval 'sub K_XLATE () {1;}' unless defined(&K_XLATE);
    eval 'sub K_CODE () {2;}' unless defined(&K_CODE);
    eval 'sub KB_84 () {1;}' unless defined(&KB_84);
    eval 'sub KB_101 () {2;}' unless defined(&KB_101);
    eval 'sub KB_OTHER () {3;}' unless defined(&KB_OTHER);
    eval 'sub CLKED () {1;}' unless defined(&CLKED);
    eval 'sub NLKED () {2;}' unless defined(&NLKED);
    eval 'sub SLKED () {4;}' unless defined(&SLKED);
    eval 'sub ALKED () {8;}' unless defined(&ALKED);
    eval 'sub LOCK_MASK () {( &CLKED |  &NLKED |  &SLKED |  &ALKED);}' unless defined(&LOCK_MASK);
    eval 'sub LED_CAP () {1;}' unless defined(&LED_CAP);
    eval 'sub LED_NUM () {2;}' unless defined(&LED_NUM);
    eval 'sub LED_SCR () {4;}' unless defined(&LED_SCR);
    eval 'sub LED_MASK () {( &LED_CAP |  &LED_NUM |  &LED_SCR);}' unless defined(&LED_MASK);
    eval 'sub FLAG_LOCK_O () {0;}' unless defined(&FLAG_LOCK_O);
    eval 'sub FLAG_LOCK_C () {1;}' unless defined(&FLAG_LOCK_C);
    eval 'sub FLAG_LOCK_N () {2;}' unless defined(&FLAG_LOCK_N);
    eval 'sub NUM_KEYS () {256;}' unless defined(&NUM_KEYS);
    eval 'sub NUM_STATES () {8;}' unless defined(&NUM_STATES);
    eval 'sub ALTGR_OFFSET () {128;}' unless defined(&ALTGR_OFFSET);
    unless(defined(&_KEYMAP_DECLARED)) {
	eval 'sub _KEYMAP_DECLARED () {1;}' unless defined(&_KEYMAP_DECLARED);
    }
    eval 'sub NUM_DEADKEYS () {15;}' unless defined(&NUM_DEADKEYS);
    eval 'sub NUM_ACCENTCHARS () {52;}' unless defined(&NUM_ACCENTCHARS);
    eval 'sub MAXFK () {16;}' unless defined(&MAXFK);
    eval 'sub NUM_FKEYS () {96;}' unless defined(&NUM_FKEYS);
    eval 'sub MAXSSAVER () {16;}' unless defined(&MAXSSAVER);
    eval 'sub V_INFO_COLOR () {(1<<0);}' unless defined(&V_INFO_COLOR);
    eval 'sub V_INFO_GRAPHICS () {(1<<1);}' unless defined(&V_INFO_GRAPHICS);
    eval 'sub V_INFO_LINEAR () {(1<<2);}' unless defined(&V_INFO_LINEAR);
    eval 'sub V_INFO_VESA () {(1<<3);}' unless defined(&V_INFO_VESA);
    eval 'sub V_ADP_COLOR () {(1<<0);}' unless defined(&V_ADP_COLOR);
    eval 'sub V_ADP_MODECHANGE () {(1<<1);}' unless defined(&V_ADP_MODECHANGE);
    eval 'sub V_ADP_STATESAVE () {(1<<2);}' unless defined(&V_ADP_STATESAVE);
    eval 'sub V_ADP_STATELOAD () {(1<<3);}' unless defined(&V_ADP_STATELOAD);
    eval 'sub V_ADP_FONT () {(1<<4);}' unless defined(&V_ADP_FONT);
    eval 'sub V_ADP_PALETTE () {(1<<5);}' unless defined(&V_ADP_PALETTE);
    eval 'sub V_ADP_BORDER () {(1<<6);}' unless defined(&V_ADP_BORDER);
    eval 'sub V_ADP_VESA () {(1<<7);}' unless defined(&V_ADP_VESA);
    eval 'sub V_ADP_PROBED () {(1<<16);}' unless defined(&V_ADP_PROBED);
    eval 'sub V_ADP_INITIALIZED () {(1<<17);}' unless defined(&V_ADP_INITIALIZED);
    eval 'sub V_ADP_REGISTERED () {(1<<18);}' unless defined(&V_ADP_REGISTERED);
    eval 'sub V_ADP_PRIMARY () {0;}' unless defined(&V_ADP_PRIMARY);
    eval 'sub V_ADP_SECONDARY () {1;}' unless defined(&V_ADP_SECONDARY);
    eval 'sub NOP () {0x00;}' unless defined(&NOP);
    eval 'sub LSH () {0x02;}' unless defined(&LSH);
    eval 'sub RSH () {0x03;}' unless defined(&RSH);
    eval 'sub CLK () {0x04;}' unless defined(&CLK);
    eval 'sub NLK () {0x05;}' unless defined(&NLK);
    eval 'sub SLK () {0x06;}' unless defined(&SLK);
    eval 'sub LALT () {0x07;}' unless defined(&LALT);
    eval 'sub BTAB () {0x08;}' unless defined(&BTAB);
    eval 'sub LCTR () {0x09;}' unless defined(&LCTR);
    eval 'sub NEXT () {0x0a;}' unless defined(&NEXT);
    eval 'sub F_SCR () {0x0b;}' unless defined(&F_SCR);
    eval 'sub L_SCR () {0x1a;}' unless defined(&L_SCR);
    eval 'sub F_FN () {0x1b;}' unless defined(&F_FN);
    eval 'sub L_FN () {0x7a;}' unless defined(&L_FN);
    eval 'sub RCTR () {0x80;}' unless defined(&RCTR);
    eval 'sub RALT () {0x81;}' unless defined(&RALT);
    eval 'sub ALK () {0x82;}' unless defined(&ALK);
    eval 'sub ASH () {0x83;}' unless defined(&ASH);
    eval 'sub META () {0x84;}' unless defined(&META);
    eval 'sub RBT () {0x85;}' unless defined(&RBT);
    eval 'sub DBG () {0x86;}' unless defined(&DBG);
    eval 'sub SUSP () {0x87;}' unless defined(&SUSP);
    eval 'sub SPSC () {0x88;}' unless defined(&SPSC);
    eval 'sub F_ACC () { &DGRA;}' unless defined(&F_ACC);
    eval 'sub DGRA () {0x89;}' unless defined(&DGRA);
    eval 'sub DACU () {0x8a;}' unless defined(&DACU);
    eval 'sub DCIR () {0x8b;}' unless defined(&DCIR);
    eval 'sub DTIL () {0x8c;}' unless defined(&DTIL);
    eval 'sub DMAC () {0x8d;}' unless defined(&DMAC);
    eval 'sub DBRE () {0x8e;}' unless defined(&DBRE);
    eval 'sub DDOT () {0x8f;}' unless defined(&DDOT);
    eval 'sub DUML () {0x90;}' unless defined(&DUML);
    eval 'sub DDIA () {0x90;}' unless defined(&DDIA);
    eval 'sub DSLA () {0x91;}' unless defined(&DSLA);
    eval 'sub DRIN () {0x92;}' unless defined(&DRIN);
    eval 'sub DCED () {0x93;}' unless defined(&DCED);
    eval 'sub DAPO () {0x94;}' unless defined(&DAPO);
    eval 'sub DDAC () {0x95;}' unless defined(&DDAC);
    eval 'sub DOGO () {0x96;}' unless defined(&DOGO);
    eval 'sub DCAR () {0x97;}' unless defined(&DCAR);
    eval 'sub L_ACC () { &DCAR;}' unless defined(&L_ACC);
    eval 'sub STBY () {0x98;}' unless defined(&STBY);
    eval 'sub F {
        local($x) = @_;
	    eval q((($x)+ &F_FN-1));
    }' unless defined(&F);
    eval 'sub S {
        local($x) = @_;
	    eval q((($x)+ &F_SCR-1));
    }' unless defined(&S);
    eval 'sub ACC {
        local($x) = @_;
	    eval q((($x)+ &F_ACC));
    }' unless defined(&ACC);
    eval 'sub NOKEY () {0x100;}' unless defined(&NOKEY);
    eval 'sub FKEY () {0x200;}' unless defined(&FKEY);
    eval 'sub MKEY () {0x400;}' unless defined(&MKEY);
    eval 'sub BKEY () {0x800;}' unless defined(&BKEY);
    eval 'sub SPCLKEY () {0x8000;}' unless defined(&SPCLKEY);
    eval 'sub RELKEY () {0x4000;}' unless defined(&RELKEY);
    eval 'sub ERRKEY () {0x2000;}' unless defined(&ERRKEY);
    eval 'sub KEYCHAR {
        local($c) = @_;
	    eval q((($c) & 0x00ff));
    }' unless defined(&KEYCHAR);
    eval 'sub KEYFLAGS {
        local($c) = @_;
	    eval q((($c) & ~0x00ff));
    }' unless defined(&KEYFLAGS);
    eval 'sub M_B40x25 () {0;}' unless defined(&M_B40x25);
    eval 'sub M_C40x25 () {1;}' unless defined(&M_C40x25);
    eval 'sub M_B80x25 () {2;}' unless defined(&M_B80x25);
    eval 'sub M_C80x25 () {3;}' unless defined(&M_C80x25);
    eval 'sub M_BG320 () {4;}' unless defined(&M_BG320);
    eval 'sub M_CG320 () {5;}' unless defined(&M_CG320);
    eval 'sub M_BG640 () {6;}' unless defined(&M_BG640);
    eval 'sub M_EGAMONO80x25 () {7;}' unless defined(&M_EGAMONO80x25);
    eval 'sub M_CG320_D () {13;}' unless defined(&M_CG320_D);
    eval 'sub M_CG640_E () {14;}' unless defined(&M_CG640_E);
    eval 'sub M_EGAMONOAPA () {15;}' unless defined(&M_EGAMONOAPA);
    eval 'sub M_CG640x350 () {16;}' unless defined(&M_CG640x350);
    eval 'sub M_ENHMONOAPA2 () {17;}' unless defined(&M_ENHMONOAPA2);
    eval 'sub M_ENH_CG640 () {18;}' unless defined(&M_ENH_CG640);
    eval 'sub M_ENH_B40x25 () {19;}' unless defined(&M_ENH_B40x25);
    eval 'sub M_ENH_C40x25 () {20;}' unless defined(&M_ENH_C40x25);
    eval 'sub M_ENH_B80x25 () {21;}' unless defined(&M_ENH_B80x25);
    eval 'sub M_ENH_C80x25 () {22;}' unless defined(&M_ENH_C80x25);
    eval 'sub M_VGA_C40x25 () {23;}' unless defined(&M_VGA_C40x25);
    eval 'sub M_VGA_C80x25 () {24;}' unless defined(&M_VGA_C80x25);
    eval 'sub M_VGA_M80x25 () {25;}' unless defined(&M_VGA_M80x25);
    eval 'sub M_VGA11 () {26;}' unless defined(&M_VGA11);
    eval 'sub M_BG640x480 () {26;}' unless defined(&M_BG640x480);
    eval 'sub M_VGA12 () {27;}' unless defined(&M_VGA12);
    eval 'sub M_CG640x480 () {27;}' unless defined(&M_CG640x480);
    eval 'sub M_VGA13 () {28;}' unless defined(&M_VGA13);
    eval 'sub M_VGA_CG320 () {28;}' unless defined(&M_VGA_CG320);
    eval 'sub M_VGA_C80x50 () {30;}' unless defined(&M_VGA_C80x50);
    eval 'sub M_VGA_M80x50 () {31;}' unless defined(&M_VGA_M80x50);
    eval 'sub M_VGA_C80x30 () {32;}' unless defined(&M_VGA_C80x30);
    eval 'sub M_VGA_M80x30 () {33;}' unless defined(&M_VGA_M80x30);
    eval 'sub M_VGA_C80x60 () {34;}' unless defined(&M_VGA_C80x60);
    eval 'sub M_VGA_M80x60 () {35;}' unless defined(&M_VGA_M80x60);
    eval 'sub M_VGA_CG640 () {36;}' unless defined(&M_VGA_CG640);
    eval 'sub M_VGA_MODEX () {37;}' unless defined(&M_VGA_MODEX);
    eval 'sub M_ENH_B80x43 () {0x70;}' unless defined(&M_ENH_B80x43);
    eval 'sub M_ENH_C80x43 () {0x71;}' unless defined(&M_ENH_C80x43);
    eval 'sub M_PC98_80x25 () {98;}' unless defined(&M_PC98_80x25);
    eval 'sub M_PC98_80x30 () {99;}' unless defined(&M_PC98_80x30);
    eval 'sub M_HGC_P0 () {0xe0;}' unless defined(&M_HGC_P0);
    eval 'sub M_HGC_P1 () {0xe1;}' unless defined(&M_HGC_P1);
    eval 'sub M_MCA_MODE () {0xff;}' unless defined(&M_MCA_MODE);
    eval 'sub M_TEXT_80x25 () {200;}' unless defined(&M_TEXT_80x25);
    eval 'sub M_TEXT_80x30 () {201;}' unless defined(&M_TEXT_80x30);
    eval 'sub M_TEXT_80x43 () {202;}' unless defined(&M_TEXT_80x43);
    eval 'sub M_TEXT_80x50 () {203;}' unless defined(&M_TEXT_80x50);
    eval 'sub M_TEXT_80x60 () {204;}' unless defined(&M_TEXT_80x60);
    eval 'sub M_TEXT_132x25 () {205;}' unless defined(&M_TEXT_132x25);
    eval 'sub M_TEXT_132x30 () {206;}' unless defined(&M_TEXT_132x30);
    eval 'sub M_TEXT_132x43 () {207;}' unless defined(&M_TEXT_132x43);
    eval 'sub M_TEXT_132x50 () {208;}' unless defined(&M_TEXT_132x50);
    eval 'sub M_TEXT_132x60 () {209;}' unless defined(&M_TEXT_132x60);
    eval 'sub SW_PC98_80x25 () { &_IO(ord(\'S\'),  &M_PC98_80x25);}' unless defined(&SW_PC98_80x25);
    eval 'sub SW_PC98_80x30 () { &_IO(ord(\'S\'),  &M_PC98_80x30);}' unless defined(&SW_PC98_80x30);
    eval 'sub SW_B40x25 () { &_IO(ord(\'S\'),  &M_B40x25);}' unless defined(&SW_B40x25);
    eval 'sub SW_C40x25 () { &_IO(ord(\'S\'),  &M_C40x25);}' unless defined(&SW_C40x25);
    eval 'sub SW_B80x25 () { &_IO(ord(\'S\'),  &M_B80x25);}' unless defined(&SW_B80x25);
    eval 'sub SW_C80x25 () { &_IO(ord(\'S\'),  &M_C80x25);}' unless defined(&SW_C80x25);
    eval 'sub SW_BG320 () { &_IO(ord(\'S\'),  &M_BG320);}' unless defined(&SW_BG320);
    eval 'sub SW_CG320 () { &_IO(ord(\'S\'),  &M_CG320);}' unless defined(&SW_CG320);
    eval 'sub SW_BG640 () { &_IO(ord(\'S\'),  &M_BG640);}' unless defined(&SW_BG640);
    eval 'sub SW_EGAMONO80x25 () { &_IO(ord(\'S\'),  &M_EGAMONO80x25);}' unless defined(&SW_EGAMONO80x25);
    eval 'sub SW_CG320_D () { &_IO(ord(\'S\'),  &M_CG320_D);}' unless defined(&SW_CG320_D);
    eval 'sub SW_CG640_E () { &_IO(ord(\'S\'),  &M_CG640_E);}' unless defined(&SW_CG640_E);
    eval 'sub SW_EGAMONOAPA () { &_IO(ord(\'S\'),  &M_EGAMONOAPA);}' unless defined(&SW_EGAMONOAPA);
    eval 'sub SW_CG640x350 () { &_IO(ord(\'S\'),  &M_CG640x350);}' unless defined(&SW_CG640x350);
    eval 'sub SW_ENH_MONOAPA2 () { &_IO(ord(\'S\'),  &M_ENHMONOAPA2);}' unless defined(&SW_ENH_MONOAPA2);
    eval 'sub SW_ENH_CG640 () { &_IO(ord(\'S\'),  &M_ENH_CG640);}' unless defined(&SW_ENH_CG640);
    eval 'sub SW_ENH_B40x25 () { &_IO(ord(\'S\'),  &M_ENH_B40x25);}' unless defined(&SW_ENH_B40x25);
    eval 'sub SW_ENH_C40x25 () { &_IO(ord(\'S\'),  &M_ENH_C40x25);}' unless defined(&SW_ENH_C40x25);
    eval 'sub SW_ENH_B80x25 () { &_IO(ord(\'S\'),  &M_ENH_B80x25);}' unless defined(&SW_ENH_B80x25);
    eval 'sub SW_ENH_C80x25 () { &_IO(ord(\'S\'),  &M_ENH_C80x25);}' unless defined(&SW_ENH_C80x25);
    eval 'sub SW_ENH_B80x43 () { &_IO(ord(\'S\'),  &M_ENH_B80x43);}' unless defined(&SW_ENH_B80x43);
    eval 'sub SW_ENH_C80x43 () { &_IO(ord(\'S\'),  &M_ENH_C80x43);}' unless defined(&SW_ENH_C80x43);
    eval 'sub SW_MCAMODE () { &_IO(ord(\'S\'),  &M_MCA_MODE);}' unless defined(&SW_MCAMODE);
    eval 'sub SW_VGA_C40x25 () { &_IO(ord(\'S\'),  &M_VGA_C40x25);}' unless defined(&SW_VGA_C40x25);
    eval 'sub SW_VGA_C80x25 () { &_IO(ord(\'S\'),  &M_VGA_C80x25);}' unless defined(&SW_VGA_C80x25);
    eval 'sub SW_VGA_C80x30 () { &_IO(ord(\'S\'),  &M_VGA_C80x30);}' unless defined(&SW_VGA_C80x30);
    eval 'sub SW_VGA_C80x50 () { &_IO(ord(\'S\'),  &M_VGA_C80x50);}' unless defined(&SW_VGA_C80x50);
    eval 'sub SW_VGA_C80x60 () { &_IO(ord(\'S\'),  &M_VGA_C80x60);}' unless defined(&SW_VGA_C80x60);
    eval 'sub SW_VGA_M80x25 () { &_IO(ord(\'S\'),  &M_VGA_M80x25);}' unless defined(&SW_VGA_M80x25);
    eval 'sub SW_VGA_M80x30 () { &_IO(ord(\'S\'),  &M_VGA_M80x30);}' unless defined(&SW_VGA_M80x30);
    eval 'sub SW_VGA_M80x50 () { &_IO(ord(\'S\'),  &M_VGA_M80x50);}' unless defined(&SW_VGA_M80x50);
    eval 'sub SW_VGA_M80x60 () { &_IO(ord(\'S\'),  &M_VGA_M80x60);}' unless defined(&SW_VGA_M80x60);
    eval 'sub SW_VGA11 () { &_IO(ord(\'S\'),  &M_VGA11);}' unless defined(&SW_VGA11);
    eval 'sub SW_BG640x480 () { &_IO(ord(\'S\'),  &M_VGA11);}' unless defined(&SW_BG640x480);
    eval 'sub SW_VGA12 () { &_IO(ord(\'S\'),  &M_VGA12);}' unless defined(&SW_VGA12);
    eval 'sub SW_CG640x480 () { &_IO(ord(\'S\'),  &M_VGA12);}' unless defined(&SW_CG640x480);
    eval 'sub SW_VGA13 () { &_IO(ord(\'S\'),  &M_VGA13);}' unless defined(&SW_VGA13);
    eval 'sub SW_VGA_CG320 () { &_IO(ord(\'S\'),  &M_VGA13);}' unless defined(&SW_VGA_CG320);
    eval 'sub SW_VGA_CG640 () { &_IO(ord(\'S\'),  &M_VGA_CG640);}' unless defined(&SW_VGA_CG640);
    eval 'sub SW_VGA_MODEX () { &_IO(ord(\'S\'),  &M_VGA_MODEX);}' unless defined(&SW_VGA_MODEX);
    eval 'sub SW_TEXT_80x25 () { &_IO(ord(\'S\'),  &M_TEXT_80x25);}' unless defined(&SW_TEXT_80x25);
    eval 'sub SW_TEXT_80x30 () { &_IO(ord(\'S\'),  &M_TEXT_80x30);}' unless defined(&SW_TEXT_80x30);
    eval 'sub SW_TEXT_80x43 () { &_IO(ord(\'S\'),  &M_TEXT_80x43);}' unless defined(&SW_TEXT_80x43);
    eval 'sub SW_TEXT_80x50 () { &_IO(ord(\'S\'),  &M_TEXT_80x50);}' unless defined(&SW_TEXT_80x50);
    eval 'sub SW_TEXT_80x60 () { &_IO(ord(\'S\'),  &M_TEXT_80x60);}' unless defined(&SW_TEXT_80x60);
    eval 'sub SW_TEXT_132x25 () { &_IO(ord(\'S\'),  &M_TEXT_132x25);}' unless defined(&SW_TEXT_132x25);
    eval 'sub SW_TEXT_132x30 () { &_IO(ord(\'S\'),  &M_TEXT_132x30);}' unless defined(&SW_TEXT_132x30);
    eval 'sub SW_TEXT_132x43 () { &_IO(ord(\'S\'),  &M_TEXT_132x43);}' unless defined(&SW_TEXT_132x43);
    eval 'sub SW_TEXT_132x50 () { &_IO(ord(\'S\'),  &M_TEXT_132x50);}' unless defined(&SW_TEXT_132x50);
    eval 'sub SW_TEXT_132x60 () { &_IO(ord(\'S\'),  &M_TEXT_132x60);}' unless defined(&SW_TEXT_132x60);
    eval 'sub M_VESA_BASE () {0x100;}' unless defined(&M_VESA_BASE);
    eval 'sub M_VESA_CG640x400 () {0x100;}' unless defined(&M_VESA_CG640x400);
    eval 'sub M_VESA_CG640x480 () {0x101;}' unless defined(&M_VESA_CG640x480);
    eval 'sub M_VESA_800x600 () {0x102;}' unless defined(&M_VESA_800x600);
    eval 'sub M_VESA_CG800x600 () {0x103;}' unless defined(&M_VESA_CG800x600);
    eval 'sub M_VESA_1024x768 () {0x104;}' unless defined(&M_VESA_1024x768);
    eval 'sub M_VESA_CG1024x768 () {0x105;}' unless defined(&M_VESA_CG1024x768);
    eval 'sub M_VESA_1280x1024 () {0x106;}' unless defined(&M_VESA_1280x1024);
    eval 'sub M_VESA_CG1280x1024 () {0x107;}' unless defined(&M_VESA_CG1280x1024);
    eval 'sub M_VESA_C80x60 () {0x108;}' unless defined(&M_VESA_C80x60);
    eval 'sub M_VESA_C132x25 () {0x109;}' unless defined(&M_VESA_C132x25);
    eval 'sub M_VESA_C132x43 () {0x10a;}' unless defined(&M_VESA_C132x43);
    eval 'sub M_VESA_C132x50 () {0x10b;}' unless defined(&M_VESA_C132x50);
    eval 'sub M_VESA_C132x60 () {0x10c;}' unless defined(&M_VESA_C132x60);
    eval 'sub M_VESA_32K_320 () {0x10d;}' unless defined(&M_VESA_32K_320);
    eval 'sub M_VESA_64K_320 () {0x10e;}' unless defined(&M_VESA_64K_320);
    eval 'sub M_VESA_FULL_320 () {0x10f;}' unless defined(&M_VESA_FULL_320);
    eval 'sub M_VESA_32K_640 () {0x110;}' unless defined(&M_VESA_32K_640);
    eval 'sub M_VESA_64K_640 () {0x111;}' unless defined(&M_VESA_64K_640);
    eval 'sub M_VESA_FULL_640 () {0x112;}' unless defined(&M_VESA_FULL_640);
    eval 'sub M_VESA_32K_800 () {0x113;}' unless defined(&M_VESA_32K_800);
    eval 'sub M_VESA_64K_800 () {0x114;}' unless defined(&M_VESA_64K_800);
    eval 'sub M_VESA_FULL_800 () {0x115;}' unless defined(&M_VESA_FULL_800);
    eval 'sub M_VESA_32K_1024 () {0x116;}' unless defined(&M_VESA_32K_1024);
    eval 'sub M_VESA_64K_1024 () {0x117;}' unless defined(&M_VESA_64K_1024);
    eval 'sub M_VESA_FULL_1024 () {0x118;}' unless defined(&M_VESA_FULL_1024);
    eval 'sub M_VESA_32K_1280 () {0x119;}' unless defined(&M_VESA_32K_1280);
    eval 'sub M_VESA_64K_1280 () {0x11a;}' unless defined(&M_VESA_64K_1280);
    eval 'sub M_VESA_FULL_1280 () {0x11b;}' unless defined(&M_VESA_FULL_1280);
    eval 'sub M_VESA_MODE_MAX () {0x1ff;}' unless defined(&M_VESA_MODE_MAX);
    eval 'sub SW_VESA_CG640x400 () { &_IO(ord(\'V\'),  &M_VESA_CG640x400 -  &M_VESA_BASE);}' unless defined(&SW_VESA_CG640x400);
    eval 'sub SW_VESA_CG640x480 () { &_IO(ord(\'V\'),  &M_VESA_CG640x480 -  &M_VESA_BASE);}' unless defined(&SW_VESA_CG640x480);
    eval 'sub SW_VESA_800x600 () { &_IO(ord(\'V\'),  &M_VESA_800x600 -  &M_VESA_BASE);}' unless defined(&SW_VESA_800x600);
    eval 'sub SW_VESA_CG800x600 () { &_IO(ord(\'V\'),  &M_VESA_CG800x600 -  &M_VESA_BASE);}' unless defined(&SW_VESA_CG800x600);
    eval 'sub SW_VESA_1024x768 () { &_IO(ord(\'V\'),  &M_VESA_1024x768 -  &M_VESA_BASE);}' unless defined(&SW_VESA_1024x768);
    eval 'sub SW_VESA_CG1024x768 () { &_IO(ord(\'V\'),  &M_VESA_CG1024x768 -  &M_VESA_BASE);}' unless defined(&SW_VESA_CG1024x768);
    eval 'sub SW_VESA_1280x1024 () { &_IO(ord(\'V\'),  &M_VESA_1280x1024 -  &M_VESA_BASE);}' unless defined(&SW_VESA_1280x1024);
    eval 'sub SW_VESA_CG1280x1024 () { &_IO(ord(\'V\'),  &M_VESA_CG1280x1024 -  &M_VESA_BASE);}' unless defined(&SW_VESA_CG1280x1024);
    eval 'sub SW_VESA_C80x60 () { &_IO(ord(\'V\'),  &M_VESA_C80x60 -  &M_VESA_BASE);}' unless defined(&SW_VESA_C80x60);
    eval 'sub SW_VESA_C132x25 () { &_IO(ord(\'V\'),  &M_VESA_C132x25 -  &M_VESA_BASE);}' unless defined(&SW_VESA_C132x25);
    eval 'sub SW_VESA_C132x43 () { &_IO(ord(\'V\'),  &M_VESA_C132x43 -  &M_VESA_BASE);}' unless defined(&SW_VESA_C132x43);
    eval 'sub SW_VESA_C132x50 () { &_IO(ord(\'V\'),  &M_VESA_C132x50 -  &M_VESA_BASE);}' unless defined(&SW_VESA_C132x50);
    eval 'sub SW_VESA_C132x60 () { &_IO(ord(\'V\'),  &M_VESA_C132x60 -  &M_VESA_BASE);}' unless defined(&SW_VESA_C132x60);
    eval 'sub SW_VESA_32K_320 () { &_IO(ord(\'V\'),  &M_VESA_32K_320 -  &M_VESA_BASE);}' unless defined(&SW_VESA_32K_320);
    eval 'sub SW_VESA_64K_320 () { &_IO(ord(\'V\'),  &M_VESA_64K_320 -  &M_VESA_BASE);}' unless defined(&SW_VESA_64K_320);
    eval 'sub SW_VESA_FULL_320 () { &_IO(ord(\'V\'),  &M_VESA_FULL_320 -  &M_VESA_BASE);}' unless defined(&SW_VESA_FULL_320);
    eval 'sub SW_VESA_32K_640 () { &_IO(ord(\'V\'),  &M_VESA_32K_640 -  &M_VESA_BASE);}' unless defined(&SW_VESA_32K_640);
    eval 'sub SW_VESA_64K_640 () { &_IO(ord(\'V\'),  &M_VESA_64K_640 -  &M_VESA_BASE);}' unless defined(&SW_VESA_64K_640);
    eval 'sub SW_VESA_FULL_640 () { &_IO(ord(\'V\'),  &M_VESA_FULL_640 -  &M_VESA_BASE);}' unless defined(&SW_VESA_FULL_640);
    eval 'sub SW_VESA_32K_800 () { &_IO(ord(\'V\'),  &M_VESA_32K_800 -  &M_VESA_BASE);}' unless defined(&SW_VESA_32K_800);
    eval 'sub SW_VESA_64K_800 () { &_IO(ord(\'V\'),  &M_VESA_64K_800 -  &M_VESA_BASE);}' unless defined(&SW_VESA_64K_800);
    eval 'sub SW_VESA_FULL_800 () { &_IO(ord(\'V\'),  &M_VESA_FULL_800 -  &M_VESA_BASE);}' unless defined(&SW_VESA_FULL_800);
    eval 'sub SW_VESA_32K_1024 () { &_IO(ord(\'V\'),  &M_VESA_32K_1024 -  &M_VESA_BASE);}' unless defined(&SW_VESA_32K_1024);
    eval 'sub SW_VESA_64K_1024 () { &_IO(ord(\'V\'),  &M_VESA_64K_1024 -  &M_VESA_BASE);}' unless defined(&SW_VESA_64K_1024);
    eval 'sub SW_VESA_FULL_1024 () { &_IO(ord(\'V\'),  &M_VESA_FULL_1024 -  &M_VESA_BASE);}' unless defined(&SW_VESA_FULL_1024);
    eval 'sub SW_VESA_32K_1280 () { &_IO(ord(\'V\'),  &M_VESA_32K_1280 -  &M_VESA_BASE);}' unless defined(&SW_VESA_32K_1280);
    eval 'sub SW_VESA_64K_1280 () { &_IO(ord(\'V\'),  &M_VESA_64K_1280 -  &M_VESA_BASE);}' unless defined(&SW_VESA_64K_1280);
    eval 'sub SW_VESA_FULL_1280 () { &_IO(ord(\'V\'),  &M_VESA_FULL_1280 -  &M_VESA_BASE);}' unless defined(&SW_VESA_FULL_1280);
}
1;
