require '_h2ph_pre.ph';

unless(defined(&_MACHINE_MPAPIC_H_)) {
    eval 'sub _MACHINE_MPAPIC_H_ () {1;}' unless defined(&_MACHINE_MPAPIC_H_);
    require 'machine/apic.ph';
    require 'i386/isa/icu.ph';
    if(!defined( &NBUS)) {
	eval 'sub NBUS () {4;}' unless defined(&NBUS);
    }
    if(!defined( &NINTR)) {
	eval 'sub NINTR () {48;}' unless defined(&NINTR);
    }
    eval 'sub NAPICID () {16;}' unless defined(&NAPICID);
    eval("sub CBUS () { 1; }") unless defined(&CBUS);
    eval("sub CBUSII () { 2; }") unless defined(&CBUSII);
    eval("sub EISA () { 3; }") unless defined(&EISA);
    eval("sub ISA () { 6; }") unless defined(&ISA);
    eval("sub PCI () { 13; }") unless defined(&PCI);
    eval("sub XPRESS () { 18; }") unless defined(&XPRESS);
    eval("sub MAX_BUSTYPE () { 18; }") unless defined(&MAX_BUSTYPE);
    eval("sub UNKNOWN_BUSTYPE () { 0xff; }") unless defined(&UNKNOWN_BUSTYPE);
    eval 'sub CPU_TO_ID {
        local($CPU) = @_;
	    eval q(( $cpu_num_to_apic_id[$CPU]));
    }' unless defined(&CPU_TO_ID);
    eval 'sub ID_TO_CPU {
        local($ID) = @_;
	    eval q(( $apic_id_to_logical[$ID]));
    }' unless defined(&ID_TO_CPU);
    eval 'sub IO_TO_ID {
        local($IO) = @_;
	    eval q(( $io_num_to_apic_id[$IO]));
    }' unless defined(&IO_TO_ID);
    eval 'sub ID_TO_IO {
        local($ID) = @_;
	    eval q(( $apic_id_to_logical[$ID]));
    }' unless defined(&ID_TO_IO);
}
1;
