require '_h2ph_pre.ph';

unless(defined(&_MACHINE_PMAP_H_)) {
    eval 'sub _MACHINE_PMAP_H_ () {1;}' unless defined(&_MACHINE_PMAP_H_);
    eval 'sub PG_V () {0x001;}' unless defined(&PG_V);
    eval 'sub PG_RW () {0x002;}' unless defined(&PG_RW);
    eval 'sub PG_U () {0x004;}' unless defined(&PG_U);
    eval 'sub PG_NC_PWT () {0x008;}' unless defined(&PG_NC_PWT);
    eval 'sub PG_NC_PCD () {0x010;}' unless defined(&PG_NC_PCD);
    eval 'sub PG_A () {0x020;}' unless defined(&PG_A);
    eval 'sub PG_M () {0x040;}' unless defined(&PG_M);
    eval 'sub PG_PS () {0x080;}' unless defined(&PG_PS);
    eval 'sub PG_G () {0x100;}' unless defined(&PG_G);
    eval 'sub PG_AVAIL1 () {0x200;}' unless defined(&PG_AVAIL1);
    eval 'sub PG_AVAIL2 () {0x400;}' unless defined(&PG_AVAIL2);
    eval 'sub PG_AVAIL3 () {0x800;}' unless defined(&PG_AVAIL3);
    eval 'sub PG_W () { &PG_AVAIL1;}' unless defined(&PG_W);
    eval 'sub PG_MANAGED () { &PG_AVAIL2;}' unless defined(&PG_MANAGED);
    eval 'sub PG_FRAME () {(~ &PAGE_MASK);}' unless defined(&PG_FRAME);
    eval 'sub PG_PROT () {( &PG_RW| &PG_U);}' unless defined(&PG_PROT);
    eval 'sub PG_N () {( &PG_NC_PWT| &PG_NC_PCD);}' unless defined(&PG_N);
    eval 'sub PGEX_P () {0x01;}' unless defined(&PGEX_P);
    eval 'sub PGEX_W () {0x02;}' unless defined(&PGEX_W);
    eval 'sub PGEX_U () {0x04;}' unless defined(&PGEX_U);
    eval 'sub VADDR {
        local($pdi, $pti) = @_;
	    eval q((((($pdi)<< &PDRSHIFT)|(($pti)<< &PAGE_SHIFT))));
    }' unless defined(&VADDR);
    unless(defined(&NKPT)) {
	eval 'sub NKPT () {17;}' unless defined(&NKPT);
    }
    unless(defined(&NKPDE)) {
	if(defined(&SMP)) {
	    eval 'sub NKPDE () {254;}' unless defined(&NKPDE);
	} else {
	    eval 'sub NKPDE () {255;}' unless defined(&NKPDE);
	}
    }
    eval 'sub APTDPTDI () {( &NPDEPG-1);}' unless defined(&APTDPTDI);
    if(defined(&SMP)) {
	eval 'sub MPPTDI () {( &APTDPTDI-1);}' unless defined(&MPPTDI);
	eval 'sub KPTDI () {( &MPPTDI- &NKPDE);}' unless defined(&KPTDI);
    } else {
	eval 'sub KPTDI () {( &APTDPTDI- &NKPDE);}' unless defined(&KPTDI);
    }
    eval 'sub PTDPTDI () {( &KPTDI-1);}' unless defined(&PTDPTDI);
    eval 'sub UMAXPTDI () {( &PTDPTDI-1);}' unless defined(&UMAXPTDI);
    eval 'sub UMAXPTEOFF () {( &NPTEPG- &UPAGES_HOLE);}' unless defined(&UMAXPTEOFF);
    eval 'sub ISA_HOLE_START () {0xa0000;}' unless defined(&ISA_HOLE_START);
    eval 'sub ISA_HOLE_LENGTH () {(0x100000- &ISA_HOLE_START);}' unless defined(&ISA_HOLE_LENGTH);
    unless(defined(&LOCORE)) {
	require 'sys/queue.ph';
	eval 'sub PDESIZE () {$sizeof{ &pd_entry_t};}' unless defined(&PDESIZE);
	eval 'sub PTESIZE () {$sizeof{ &pt_entry_t};}' unless defined(&PTESIZE);
	if(defined(&KERNEL)) {
	}
	if(defined(&KERNEL)) {
	    eval 'sub vtopte {
	        local($va) = @_;
    		eval q(( &PTmap +  &i386_btop($va)));
	    }' unless defined(&vtopte);
	    eval 'sub avtopte {
	        local($va) = @_;
    		eval q(( &APTmap +  &i386_btop($va)));
	    }' unless defined(&avtopte);
	    if(0) {
		eval 'sub vtophys {
		    local($va) = @_;
    		    eval q((( (* &vtopte) &PG_FRAME) | (($va) &  &PAGE_MASK)));
		}' unless defined(&vtophys);
	    } else {
		eval 'sub vtophys {
		    local($va) = @_;
    		    eval q( &pmap_kextract(( ($va))));
		}' unless defined(&vtophys);
	    }
	    eval 'sub avtophys {
	        local($va) = @_;
    		eval q((( (* &avtopte) &PG_FRAME) | (($va) &  &PAGE_MASK)));
	    }' unless defined(&avtophys);
	}
	eval 'sub pmap_resident_count {
	    local($pmap) = @_;
    	    eval q(($pmap)-> ($pm_stats->{resident_count}));
	}' unless defined(&pmap_resident_count);
	eval 'sub PM_FLAG_LOCKED () {0x1;}' unless defined(&PM_FLAG_LOCKED);
	eval 'sub PM_FLAG_WANTED () {0x2;}' unless defined(&PM_FLAG_WANTED);
	if(defined(&KERNEL)) {
	}
	eval 'sub PV_ENTRY_NULL () {( 0);}' unless defined(&PV_ENTRY_NULL);
	eval 'sub PV_CI () {0x01;}' unless defined(&PV_CI);
	eval 'sub PV_PTPAGE () {0x02;}' unless defined(&PV_PTPAGE);
	if(defined(&KERNEL)) {
	    eval 'sub NPPROVMTRR () {8;}' unless defined(&NPPROVMTRR);
	    eval 'sub PPRO_VMTRRphysBase0 () {0x200;}' unless defined(&PPRO_VMTRRphysBase0);
	    eval 'sub PPRO_VMTRRphysMask0 () {0x201;}' unless defined(&PPRO_VMTRRphysMask0);
	}
    }
}
1;
