require '_h2ph_pre.ph';

unless(defined(&_MACHINE_SEGMENTS_H_)) {
    eval 'sub _MACHINE_SEGMENTS_H_ () {1;}' unless defined(&_MACHINE_SEGMENTS_H_);
    eval 'sub ISPL {
        local($s) = @_;
	    eval q((($s)&3));
    }' unless defined(&ISPL);
    eval 'sub SEL_KPL () {0;}' unless defined(&SEL_KPL);
    eval 'sub SEL_UPL () {3;}' unless defined(&SEL_UPL);
    eval 'sub ISLDT {
        local($s) = @_;
	    eval q((($s) &SEL_LDT));
    }' unless defined(&ISLDT);
    eval 'sub SEL_LDT () {4;}' unless defined(&SEL_LDT);
    eval 'sub IDXSEL {
        local($s) = @_;
	    eval q(((($s)>>3) & 0x1fff));
    }' unless defined(&IDXSEL);
    eval 'sub LSEL {
        local($s,$r) = @_;
	    eval q(((($s)<<3) |  &SEL_LDT | $r));
    }' unless defined(&LSEL);
    eval 'sub GSEL {
        local($s,$r) = @_;
	    eval q(((($s)<<3) | $r));
    }' unless defined(&GSEL);
    eval 'sub SDT_SYSNULL () {0;}' unless defined(&SDT_SYSNULL);
    eval 'sub SDT_SYS286TSS () {1;}' unless defined(&SDT_SYS286TSS);
    eval 'sub SDT_SYSLDT () {2;}' unless defined(&SDT_SYSLDT);
    eval 'sub SDT_SYS286BSY () {3;}' unless defined(&SDT_SYS286BSY);
    eval 'sub SDT_SYS286CGT () {4;}' unless defined(&SDT_SYS286CGT);
    eval 'sub SDT_SYSTASKGT () {5;}' unless defined(&SDT_SYSTASKGT);
    eval 'sub SDT_SYS286IGT () {6;}' unless defined(&SDT_SYS286IGT);
    eval 'sub SDT_SYS286TGT () {7;}' unless defined(&SDT_SYS286TGT);
    eval 'sub SDT_SYSNULL2 () {8;}' unless defined(&SDT_SYSNULL2);
    eval 'sub SDT_SYS386TSS () {9;}' unless defined(&SDT_SYS386TSS);
    eval 'sub SDT_SYSNULL3 () {10;}' unless defined(&SDT_SYSNULL3);
    eval 'sub SDT_SYS386BSY () {11;}' unless defined(&SDT_SYS386BSY);
    eval 'sub SDT_SYS386CGT () {12;}' unless defined(&SDT_SYS386CGT);
    eval 'sub SDT_SYSNULL4 () {13;}' unless defined(&SDT_SYSNULL4);
    eval 'sub SDT_SYS386IGT () {14;}' unless defined(&SDT_SYS386IGT);
    eval 'sub SDT_SYS386TGT () {15;}' unless defined(&SDT_SYS386TGT);
    eval 'sub SDT_MEMRO () {16;}' unless defined(&SDT_MEMRO);
    eval 'sub SDT_MEMROA () {17;}' unless defined(&SDT_MEMROA);
    eval 'sub SDT_MEMRW () {18;}' unless defined(&SDT_MEMRW);
    eval 'sub SDT_MEMRWA () {19;}' unless defined(&SDT_MEMRWA);
    eval 'sub SDT_MEMROD () {20;}' unless defined(&SDT_MEMROD);
    eval 'sub SDT_MEMRODA () {21;}' unless defined(&SDT_MEMRODA);
    eval 'sub SDT_MEMRWD () {22;}' unless defined(&SDT_MEMRWD);
    eval 'sub SDT_MEMRWDA () {23;}' unless defined(&SDT_MEMRWDA);
    eval 'sub SDT_MEME () {24;}' unless defined(&SDT_MEME);
    eval 'sub SDT_MEMEA () {25;}' unless defined(&SDT_MEMEA);
    eval 'sub SDT_MEMER () {26;}' unless defined(&SDT_MEMER);
    eval 'sub SDT_MEMERA () {27;}' unless defined(&SDT_MEMERA);
    eval 'sub SDT_MEMEC () {28;}' unless defined(&SDT_MEMEC);
    eval 'sub SDT_MEMEAC () {29;}' unless defined(&SDT_MEMEAC);
    eval 'sub SDT_MEMERC () {30;}' unless defined(&SDT_MEMERC);
    eval 'sub SDT_MEMERAC () {31;}' unless defined(&SDT_MEMERAC);
    eval 'sub ISMEMSDP {
        local($s) = @_;
	    eval q((( ($s->{d_type})) >=  &SDT_MEMRO  && ( ($s->{d_type})) <=  &SDT_MEMERAC));
    }' unless defined(&ISMEMSDP);
    eval 'sub IS286GDP {
        local($s) = @_;
	    eval q(((( ($s->{d_type})) >=  &SDT_SYS286CGT  && ( ($s->{d_type})) <  &SDT_SYS286TGT)));
    }' unless defined(&IS286GDP);
    eval 'sub IS386GDP {
        local($s) = @_;
	    eval q(((( ($s->{d_type})) >=  &SDT_SYS386CGT  && ( ($s->{d_type})) <  &SDT_SYS386TGT)));
    }' unless defined(&IS386GDP);
    eval 'sub ISGDP {
        local($s) = @_;
	    eval q(( &IS286GDP($s) ||  &IS386GDP($s)));
    }' unless defined(&ISGDP);
    eval 'sub ISSDP {
        local($s) = @_;
	    eval q(( &ISMEMSDP($s) || ! &ISGDP($s)));
    }' unless defined(&ISSDP);
    eval 'sub ISSYSSDP {
        local($s) = @_;
	    eval q((! &ISMEMSDP($s)  && ! &ISGDP($s)));
    }' unless defined(&ISSYSSDP);
    eval 'sub SEGEX_EXT () {0x01;}' unless defined(&SEGEX_EXT);
    eval 'sub SEGEX_IDT () {0x02;}' unless defined(&SEGEX_IDT);
    eval 'sub SEGEX_TI () {0x04;}' unless defined(&SEGEX_TI);
    eval 'sub SEGEX_IDX {
        local($s) = @_;
	    eval q((($s)>>3)&0x1fff));
    }' unless defined(&SEGEX_IDX);
    if(defined( &SMP) || defined( &APIC_IO)) {
	eval 'sub NIDT () {256;}' unless defined(&NIDT);
    } else {
	eval 'sub NIDT () {129;}' unless defined(&NIDT);
    }
    eval 'sub NRSVIDT () {32;}' unless defined(&NRSVIDT);
    eval 'sub GNULL_SEL () {0;}' unless defined(&GNULL_SEL);
    eval 'sub GCODE_SEL () {1;}' unless defined(&GCODE_SEL);
    eval 'sub GDATA_SEL () {2;}' unless defined(&GDATA_SEL);
    eval 'sub GLDT_SEL () {3;}' unless defined(&GLDT_SEL);
    eval 'sub GTGATE_SEL () {4;}' unless defined(&GTGATE_SEL);
    eval 'sub GPANIC_SEL () {5;}' unless defined(&GPANIC_SEL);
    eval 'sub GPROC0_SEL () {6;}' unless defined(&GPROC0_SEL);
    eval 'sub GUSERLDT_SEL () {7;}' unless defined(&GUSERLDT_SEL);
    eval 'sub GAPMCODE32_SEL () {8;}' unless defined(&GAPMCODE32_SEL);
    eval 'sub GAPMCODE16_SEL () {9;}' unless defined(&GAPMCODE16_SEL);
    eval 'sub GAPMDATA_SEL () {10;}' unless defined(&GAPMDATA_SEL);
    if(defined(&BDE_DEBUGGER)) {
	eval 'sub NGDT () {18;}' unless defined(&NGDT);
    } else {
	eval 'sub NGDT () {( &GAPMDATA_SEL + 1);}' unless defined(&NGDT);
    }
    eval 'sub LSYS5CALLS_SEL () {0;}' unless defined(&LSYS5CALLS_SEL);
    eval 'sub LSYS5SIGR_SEL () {1;}' unless defined(&LSYS5SIGR_SEL);
    eval 'sub L43BSDCALLS_SEL () {2;}' unless defined(&L43BSDCALLS_SEL);
    eval 'sub LUCODE_SEL () {3;}' unless defined(&LUCODE_SEL);
    eval 'sub LUDATA_SEL () {4;}' unless defined(&LUDATA_SEL);
    eval 'sub LBSDICALLS_SEL () {16;}' unless defined(&LBSDICALLS_SEL);
    eval 'sub NLDT () {( &LBSDICALLS_SEL + 1);}' unless defined(&NLDT);
    if(defined(&KERNEL)) {
    }
}
1;
