require '_h2ph_pre.ph';

unless(defined(&_MACHINE_SMP_H_)) {
    eval 'sub _MACHINE_SMP_H_ () {1;}' unless defined(&_MACHINE_SMP_H_);
    if(defined(&KERNEL)) {
	if(defined( &SMP)  && !defined( &APIC_IO)) {
	    die("APIC_IO\ required\ for\ SMP\,\ add\ \"options\ APIC_IO\"\ to\ your\ config\ file\.");
	}
	if(defined( &SMP)  && !defined( &NCPU)) {
	    eval 'sub NCPU () {2;}' unless defined(&NCPU);
	}
	if(defined( &APIC_IO)  && !defined( &NAPIC)) {
	    eval 'sub NAPIC () {1;}' unless defined(&NAPIC);
	}
	if(defined( &SMP) || defined( &APIC_IO)) {
	    unless(defined(&LOCORE)) {
		eval 'sub POSTCODE {
		    local($X) = @_;
    		    eval q( &current_postcode = ($X),  &outb(0x80,  &current_postcode));
		}' unless defined(&POSTCODE);
		eval 'sub POSTCODE_LO {
		    local($X) = @_;
    		    eval q( &current_postcode &= 0xf0,  &current_postcode |= (($X) & 0x0f),  &outb(0x80,  &current_postcode));
		}' unless defined(&POSTCODE_LO);
		eval 'sub POSTCODE_HI {
		    local($X) = @_;
    		    eval q( &current_postcode &= 0x0f,  &current_postcode |= ((($X) << 4) & 0xf0),  &outb(0x80,  &current_postcode));
		}' unless defined(&POSTCODE_HI);
		require 'machine/apic.ph';
		if(defined(&RECURSIVE_MPINTRLOCK)) {
		}
		if(defined(&RECURSIVE_MPINTRLOCK)) {
		}
		eval 'sub APIC_INTMAPSIZE () {24;}' unless defined(&APIC_INTMAPSIZE);
		if(defined(&BETTER_CLOCK)) {
		}
		if(defined(&APIC_INTR_REORDER)) {
		}
		if(defined( &READY)) {
		}
	    }
	}
    }
}
1;
