require '_h2ph_pre.ph';

unless(defined(&_NET_IF_MEDIA_H_)) {
    eval 'sub _NET_IF_MEDIA_H_ () {1;}' unless defined(&_NET_IF_MEDIA_H_);
    if(defined(&KERNEL)) {
	require 'sys/queue.ph';
    }
    eval 'sub IFM_ETHER () {0x00000020;}' unless defined(&IFM_ETHER);
    eval 'sub IFM_10_T () {3;}' unless defined(&IFM_10_T);
    eval 'sub IFM_10_2 () {4;}' unless defined(&IFM_10_2);
    eval 'sub IFM_10_5 () {5;}' unless defined(&IFM_10_5);
    eval 'sub IFM_100_TX () {6;}' unless defined(&IFM_100_TX);
    eval 'sub IFM_100_FX () {7;}' unless defined(&IFM_100_FX);
    eval 'sub IFM_100_T4 () {8;}' unless defined(&IFM_100_T4);
    eval 'sub IFM_100_VG () {9;}' unless defined(&IFM_100_VG);
    eval 'sub IFM_100_T2 () {10;}' unless defined(&IFM_100_T2);
    eval 'sub IFM_1000_FX () {11;}' unless defined(&IFM_1000_FX);
    eval 'sub IFM_10_STP () {12;}' unless defined(&IFM_10_STP);
    eval 'sub IFM_10_FL () {13;}' unless defined(&IFM_10_FL);
    eval 'sub IFM_1000_SX () {14;}' unless defined(&IFM_1000_SX);
    eval 'sub IFM_1000_LX () {15;}' unless defined(&IFM_1000_LX);
    eval 'sub IFM_1000_CX () {16;}' unless defined(&IFM_1000_CX);
    eval 'sub IFM_1000_TX () {17;}' unless defined(&IFM_1000_TX);
    eval 'sub IFM_homePNA () {18;}' unless defined(&IFM_homePNA);
    eval 'sub IFM_TOKEN () {0x00000040;}' unless defined(&IFM_TOKEN);
    eval 'sub IFM_TOK_STP4 () {3;}' unless defined(&IFM_TOK_STP4);
    eval 'sub IFM_TOK_STP16 () {4;}' unless defined(&IFM_TOK_STP16);
    eval 'sub IFM_TOK_UTP4 () {5;}' unless defined(&IFM_TOK_UTP4);
    eval 'sub IFM_TOK_UTP16 () {6;}' unless defined(&IFM_TOK_UTP16);
    eval 'sub IFM_TOK_STP100 () {7;}' unless defined(&IFM_TOK_STP100);
    eval 'sub IFM_TOK_UTP100 () {8;}' unless defined(&IFM_TOK_UTP100);
    eval 'sub IFM_TOK_ETR () {0x00000200;}' unless defined(&IFM_TOK_ETR);
    eval 'sub IFM_TOK_SRCRT () {0x00000400;}' unless defined(&IFM_TOK_SRCRT);
    eval 'sub IFM_TOK_ALLR () {0x00000800;}' unless defined(&IFM_TOK_ALLR);
    eval 'sub IFM_TOK_DTR () {0x00002000;}' unless defined(&IFM_TOK_DTR);
    eval 'sub IFM_TOK_CLASSIC () {0x00004000;}' unless defined(&IFM_TOK_CLASSIC);
    eval 'sub IFM_TOK_AUTO () {0x00008000;}' unless defined(&IFM_TOK_AUTO);
    eval 'sub IFM_FDDI () {0x00000060;}' unless defined(&IFM_FDDI);
    eval 'sub IFM_FDDI_SMF () {3;}' unless defined(&IFM_FDDI_SMF);
    eval 'sub IFM_FDDI_MMF () {4;}' unless defined(&IFM_FDDI_MMF);
    eval 'sub IFM_FDDI_UTP () {5;}' unless defined(&IFM_FDDI_UTP);
    eval 'sub IFM_FDDI_DA () {0x00000100;}' unless defined(&IFM_FDDI_DA);
    eval 'sub IFM_AUTO () {0;}' unless defined(&IFM_AUTO);
    eval 'sub IFM_MANUAL () {1;}' unless defined(&IFM_MANUAL);
    eval 'sub IFM_NONE () {2;}' unless defined(&IFM_NONE);
    eval 'sub IFM_FDX () {0x00100000;}' unless defined(&IFM_FDX);
    eval 'sub IFM_HDX () {0x00200000;}' unless defined(&IFM_HDX);
    eval 'sub IFM_FLAG0 () {0x01000000;}' unless defined(&IFM_FLAG0);
    eval 'sub IFM_FLAG1 () {0x02000000;}' unless defined(&IFM_FLAG1);
    eval 'sub IFM_FLAG2 () {0x04000000;}' unless defined(&IFM_FLAG2);
    eval 'sub IFM_LOOP () {0x08000000;}' unless defined(&IFM_LOOP);
    eval 'sub IFM_NMASK () {0x000000e0;}' unless defined(&IFM_NMASK);
    eval 'sub IFM_TMASK () {0x0000001f;}' unless defined(&IFM_TMASK);
    eval 'sub IFM_IMASK () {0xf0000000;}' unless defined(&IFM_IMASK);
    eval 'sub IFM_ISHIFT () {28;}' unless defined(&IFM_ISHIFT);
    eval 'sub IFM_OMASK () {0x0000ff00;}' unless defined(&IFM_OMASK);
    eval 'sub IFM_GMASK () {0x0ff00000;}' unless defined(&IFM_GMASK);
    eval 'sub IFM_AVALID () {0x00000001;}' unless defined(&IFM_AVALID);
    eval 'sub IFM_ACTIVE () {0x00000002;}' unless defined(&IFM_ACTIVE);
    eval 'sub IFM_TYPE {
        local($x) = @_;
	    eval q((($x) &  &IFM_NMASK));
    }' unless defined(&IFM_TYPE);
    eval 'sub IFM_SUBTYPE {
        local($x) = @_;
	    eval q((($x) &  &IFM_TMASK));
    }' unless defined(&IFM_SUBTYPE);
    eval 'sub IFM_TYPE_OPTIONS {
        local($x) = @_;
	    eval q((($x) &  &IFM_OMASK));
    }' unless defined(&IFM_TYPE_OPTIONS);
    eval 'sub IFM_INST {
        local($x) = @_;
	    eval q(((($x) &  &IFM_IMASK) >>  &IFM_ISHIFT));
    }' unless defined(&IFM_INST);
    eval 'sub IFM_OPTIONS {
        local($x) = @_;
	    eval q((($x) & ( &IFM_OMASK| &IFM_GMASK)));
    }' unless defined(&IFM_OPTIONS);
    eval 'sub IFM_INST_MAX () { &IFM_INST( &IFM_IMASK);}' unless defined(&IFM_INST_MAX);
    eval 'sub IFM_MAKEWORD {
        local($type, $subtype, $options, $instance) = @_;
	    eval q((($type) | ($subtype) | ($options) | (($instance) <<  &IFM_ISHIFT)));
    }' unless defined(&IFM_MAKEWORD);
    eval 'sub IFM_TYPE_DESCRIPTIONS () {{ {  &IFM_ETHER, "Ethernet" }, {  &IFM_TOKEN, "Token ring" }, {  &IFM_FDDI, "FDDI" }, { 0,  &NULL }, };}' unless defined(&IFM_TYPE_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_ETHERNET_DESCRIPTIONS () {{ {  &IFM_10_T, "10baseT/UTP" }, {  &IFM_10_2, "10base2/BNC" }, {  &IFM_10_5, "10base5/AUI" }, {  &IFM_100_TX, "100baseTX" }, {  &IFM_100_FX, "100baseFX" }, {  &IFM_100_T4, "100baseT4" }, {  &IFM_100_VG, "100baseVG" }, {  &IFM_100_T2, "100baseT2" }, {  &IFM_1000_FX, "1000baseFX" }, {  &IFM_10_STP, "10baseSTP" }, {  &IFM_10_FL, "10baseFL" }, {  &IFM_1000_SX, "1000baseSX" }, {  &IFM_1000_LX, "1000baseLX" }, {  &IFM_1000_CX, "1000baseCX" }, {  &IFM_1000_TX, "1000baseTX" }, {  &IFM_homePNA, "homePNA" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_ETHERNET_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_ETHERNET_ALIASES () {{ {  &IFM_10_T, "UTP" }, {  &IFM_10_T, "10UTP" }, {  &IFM_10_2, "BNC" }, {  &IFM_10_2, "10BNC" }, {  &IFM_10_5, "AUI" }, {  &IFM_10_5, "10AUI" }, {  &IFM_100_TX, "100TX" }, {  &IFM_100_FX, "100FX" }, {  &IFM_100_T4, "100T4" }, {  &IFM_100_VG, "100VG" }, {  &IFM_100_T2, "100T2" }, {  &IFM_1000_FX, "1000FX" }, {  &IFM_10_STP, "10STP" }, {  &IFM_10_FL, "10FL" }, {  &IFM_1000_FX, "1000SX" }, {  &IFM_1000_FX, "1000LX" }, {  &IFM_1000_FX, "1000CX" }, {  &IFM_1000_FX, "1000TX" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_ETHERNET_ALIASES);
    eval 'sub IFM_SUBTYPE_ETHERNET_OPTION_DESCRIPTIONS () {{ { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_ETHERNET_OPTION_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_TOKENRING_DESCRIPTIONS () {{ {  &IFM_TOK_STP4, "DB9/4Mbit" }, {  &IFM_TOK_STP16, "DB9/16Mbit" }, {  &IFM_TOK_UTP4, "UTP/4Mbit" }, {  &IFM_TOK_UTP16, "UTP/16Mbit" }, {  &IFM_TOK_STP100, "STP/100Mbit" }, {  &IFM_TOK_UTP100, "UTP/100Mbit" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_TOKENRING_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_TOKENRING_ALIASES () {{ {  &IFM_TOK_STP4, "4STP" }, {  &IFM_TOK_STP16, "16STP" }, {  &IFM_TOK_UTP4, "4UTP" }, {  &IFM_TOK_UTP16, "16UTP" }, {  &IFM_TOK_STP100, "100STP" }, {  &IFM_TOK_UTP100, "100UTP" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_TOKENRING_ALIASES);
    eval 'sub IFM_SUBTYPE_TOKENRING_OPTION_DESCRIPTIONS () {{ {  &IFM_TOK_ETR, "EarlyTokenRelease" }, {  &IFM_TOK_SRCRT, "SourceRouting" }, {  &IFM_TOK_ALLR, "AllRoutes" }, {  &IFM_TOK_DTR, "Dedicated" }, {  &IFM_TOK_CLASSIC,"Classic" }, {  &IFM_TOK_AUTO, "Auto-mode" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_TOKENRING_OPTION_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_FDDI_DESCRIPTIONS () {{ {  &IFM_FDDI_SMF, "Single-mode" }, {  &IFM_FDDI_MMF, "Multi-mode" }, {  &IFM_FDDI_UTP, "UTP" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_FDDI_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_FDDI_ALIASES () {{ {  &IFM_FDDI_SMF, "SMF" }, {  &IFM_FDDI_MMF, "MMF" }, {  &IFM_FDDI_UTP, "CDDI" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_FDDI_ALIASES);
    eval 'sub IFM_SUBTYPE_FDDI_OPTION_DESCRIPTIONS () {{ {  &IFM_FDDI_DA, "Dual-attach" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_FDDI_OPTION_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_SHARED_DESCRIPTIONS () {{ {  &IFM_AUTO, "autoselect" }, {  &IFM_MANUAL, "manual" }, {  &IFM_NONE, "none" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_SHARED_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_SHARED_ALIASES () {{ {  &IFM_AUTO, "auto" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_SHARED_ALIASES);
    eval 'sub IFM_SHARED_OPTION_DESCRIPTIONS () {{ {  &IFM_FDX, "full-duplex" }, {  &IFM_HDX, "half-duplex" }, {  &IFM_FLAG0, "flag0" }, {  &IFM_FLAG1, "flag1" }, {  &IFM_FLAG2, "flag2" }, {  &IFM_LOOP, "hw-loopback" }, { 0,  &NULL }, };}' unless defined(&IFM_SHARED_OPTION_DESCRIPTIONS);
}
1;
