require '_h2ph_pre.ph';

unless(defined(&_NETATM_ATM_H)) {
    eval 'sub _NETATM_ATM_H () {1;}' unless defined(&_NETATM_ATM_H);
    eval 'sub ATM_PROTO_AAL5 () {0x5301;}' unless defined(&ATM_PROTO_AAL5);
    eval 'sub ATM_PROTO_SSCOP () {0x5302;}' unless defined(&ATM_PROTO_SSCOP);
    eval 'sub ATM_ADDR_LEN () {20;}' unless defined(&ATM_ADDR_LEN);
    eval 'sub T_ATM_ABSENT () {(-1);}' unless defined(&T_ATM_ABSENT);
    eval 'sub T_ATM_ENDSYS_ADDR () {1;}' unless defined(&T_ATM_ENDSYS_ADDR);
    eval 'sub T_ATM_NSAP_ADDR () {1;}' unless defined(&T_ATM_NSAP_ADDR);
    eval 'sub T_ATM_E164_ADDR () {2;}' unless defined(&T_ATM_E164_ADDR);
    eval 'sub T_ATM_SPANS_ADDR () {3;}' unless defined(&T_ATM_SPANS_ADDR);
    eval 'sub T_ATM_PVC_ADDR () {4;}' unless defined(&T_ATM_PVC_ADDR);
    eval 'sub AFI_DCC () {0x39;}' unless defined(&AFI_DCC);
    eval 'sub AFI_ICD () {0x47;}' unless defined(&AFI_ICD);
    eval 'sub AFI_E164 () {0x45;}' unless defined(&AFI_E164);
    eval 'sub ATM_PVC_GET_VPI {
        local($addr) = @_;
	    eval q((((($addr)-> $aap_vpi[0] << 8) | ($addr)-> $aap_vpi[1])));
    }' unless defined(&ATM_PVC_GET_VPI);
    eval 'sub ATM_PVC_GET_VCI {
        local($addr) = @_;
	    eval q((((($addr)-> $aap_vci[0] << 8) | ($addr)-> $aap_vci[1])));
    }' unless defined(&ATM_PVC_GET_VCI);
    eval 'sub ATM_PVC_SET_VPI {
        local($addr,$vpi) = @_;
	    eval q({ ($addr)-> $aap_vpi[0] = (($vpi) >> 8) & 0xff; ($addr)-> $aap_vpi[1] = ($vpi) & 0xff; });
    }' unless defined(&ATM_PVC_SET_VPI);
    eval 'sub ATM_PVC_SET_VCI {
        local($addr,$vci) = @_;
	    eval q({ ($addr)-> $aap_vci[0] = (($vci) >> 8) & 0xff; ($addr)-> $aap_vci[1] = ($vci) & 0xff; });
    }' unless defined(&ATM_PVC_SET_VCI);
    eval 'sub T_ATM_ABSENT () {(-1);}' unless defined(&T_ATM_ABSENT);
    eval 'sub T_ATM_PRESENT () {(-2);}' unless defined(&T_ATM_PRESENT);
    eval 'sub T_ATM_ANY () {(-3);}' unless defined(&T_ATM_ANY);
    if((defined( &BSD)  && ((defined(&BSD) ? &BSD : 0) >= 199103))) {
    } else {
    }
    eval 'sub T_ATM_SIGNALING () {0x5301;}' unless defined(&T_ATM_SIGNALING);
    eval 'sub T_ATM_AAL5 () {1;}' unless defined(&T_ATM_AAL5);
    eval 'sub T_ATM_TRAFFIC () {2;}' unless defined(&T_ATM_TRAFFIC);
    eval 'sub T_ATM_BEARER_CAP () {3;}' unless defined(&T_ATM_BEARER_CAP);
    eval 'sub T_ATM_BHLI () {4;}' unless defined(&T_ATM_BHLI);
    eval 'sub T_ATM_BLLI () {5;}' unless defined(&T_ATM_BLLI);
    eval 'sub T_ATM_DEST_ADDR () {6;}' unless defined(&T_ATM_DEST_ADDR);
    eval 'sub T_ATM_DEST_SUB () {7;}' unless defined(&T_ATM_DEST_SUB);
    eval 'sub T_ATM_ORIG_ADDR () {8;}' unless defined(&T_ATM_ORIG_ADDR);
    eval 'sub T_ATM_ORIG_SUB () {9;}' unless defined(&T_ATM_ORIG_SUB);
    eval 'sub T_ATM_CALLER_ID () {10;}' unless defined(&T_ATM_CALLER_ID);
    eval 'sub T_ATM_CAUSE () {11;}' unless defined(&T_ATM_CAUSE);
    eval 'sub T_ATM_QOS () {12;}' unless defined(&T_ATM_QOS);
    eval 'sub T_ATM_TRANSIT () {13;}' unless defined(&T_ATM_TRANSIT);
    eval 'sub T_ATM_ADD_LEAF () {14;}' unless defined(&T_ATM_ADD_LEAF);
    eval 'sub T_ATM_DROP_LEAF () {15;}' unless defined(&T_ATM_DROP_LEAF);
    eval 'sub T_ATM_LEAF_IND () {16;}' unless defined(&T_ATM_LEAF_IND);
    eval 'sub T_ATM_NET_INTF () {17;}' unless defined(&T_ATM_NET_INTF);
    eval 'sub T_ATM_LLC () {18;}' unless defined(&T_ATM_LLC);
    eval 'sub T_ATM_APP_NAME () {19;}' unless defined(&T_ATM_APP_NAME);
    eval 'sub T_ATM_ABSENT () {(-1);}' unless defined(&T_ATM_ABSENT);
    eval 'sub T_ATM_NULL () {0;}' unless defined(&T_ATM_NULL);
    eval 'sub T_NO () {0;}' unless defined(&T_NO);
    eval 'sub T_YES () {1;}' unless defined(&T_YES);
    eval 'sub T_ATM_SSCS_SSCOP_REL () {1;}' unless defined(&T_ATM_SSCS_SSCOP_REL);
    eval 'sub T_ATM_SSCS_SSCOP_UNREL () {2;}' unless defined(&T_ATM_SSCS_SSCOP_UNREL);
    eval 'sub T_ATM_SSCS_FR () {4;}' unless defined(&T_ATM_SSCS_FR);
    eval 'sub T_ATM_CLASS_A () {0x01;}' unless defined(&T_ATM_CLASS_A);
    eval 'sub T_ATM_CLASS_C () {0x03;}' unless defined(&T_ATM_CLASS_C);
    eval 'sub T_ATM_CLASS_X () {0x10;}' unless defined(&T_ATM_CLASS_X);
    eval 'sub T_ATM_CBR () {0x01;}' unless defined(&T_ATM_CBR);
    eval 'sub T_ATM_VBR () {0x02;}' unless defined(&T_ATM_VBR);
    eval 'sub T_ATM_END_TO_END () {0x01;}' unless defined(&T_ATM_END_TO_END);
    eval 'sub T_ATM_NO_END_TO_END () {0x02;}' unless defined(&T_ATM_NO_END_TO_END);
    eval 'sub T_ATM_1_TO_1 () {0x00;}' unless defined(&T_ATM_1_TO_1);
    eval 'sub T_ATM_1_TO_MANY () {0x01;}' unless defined(&T_ATM_1_TO_MANY);
    eval 'sub T_ATM_ISO_APP_ID () {0;}' unless defined(&T_ATM_ISO_APP_ID);
    eval 'sub T_ATM_USER_APP_ID () {1;}' unless defined(&T_ATM_USER_APP_ID);
    eval 'sub T_ATM_VENDOR_APP_ID () {3;}' unless defined(&T_ATM_VENDOR_APP_ID);
    eval 'sub T_ATM_SIMPLE_ID () {1;}' unless defined(&T_ATM_SIMPLE_ID);
    eval 'sub T_ATM_IPI_ID () {2;}' unless defined(&T_ATM_IPI_ID);
    eval 'sub T_ATM_SNAP_ID () {3;}' unless defined(&T_ATM_SNAP_ID);
    eval 'sub T_ATM_USER_ID () {4;}' unless defined(&T_ATM_USER_ID);
    eval 'sub T_ATM_BLLI_NORMAL_MODE () {1;}' unless defined(&T_ATM_BLLI_NORMAL_MODE);
    eval 'sub T_ATM_BLLI_EXTENDED_MODE () {2;}' unless defined(&T_ATM_BLLI_EXTENDED_MODE);
    eval 'sub T_ATM_BLLI2_I1745 () {1;}' unless defined(&T_ATM_BLLI2_I1745);
    eval 'sub T_ATM_BLLI2_Q921 () {2;}' unless defined(&T_ATM_BLLI2_Q921);
    eval 'sub T_ATM_BLLI2_X25_LINK () {6;}' unless defined(&T_ATM_BLLI2_X25_LINK);
    eval 'sub T_ATM_BLLI2_X25_MLINK () {7;}' unless defined(&T_ATM_BLLI2_X25_MLINK);
    eval 'sub T_ATM_BLLI2_LAPB () {8;}' unless defined(&T_ATM_BLLI2_LAPB);
    eval 'sub T_ATM_BLLI2_HDLC_ARM () {9;}' unless defined(&T_ATM_BLLI2_HDLC_ARM);
    eval 'sub T_ATM_BLLI2_HDLC_NRM () {10;}' unless defined(&T_ATM_BLLI2_HDLC_NRM);
    eval 'sub T_ATM_BLLI2_HDLC_ABM () {11;}' unless defined(&T_ATM_BLLI2_HDLC_ABM);
    eval 'sub T_ATM_BLLI2_I8802 () {12;}' unless defined(&T_ATM_BLLI2_I8802);
    eval 'sub T_ATM_BLLI2_X75 () {13;}' unless defined(&T_ATM_BLLI2_X75);
    eval 'sub T_ATM_BLLI2_Q922 () {14;}' unless defined(&T_ATM_BLLI2_Q922);
    eval 'sub T_ATM_BLLI2_I7776 () {17;}' unless defined(&T_ATM_BLLI2_I7776);
    eval 'sub T_ATM_BLLI3_X25 () {6;}' unless defined(&T_ATM_BLLI3_X25);
    eval 'sub T_ATM_BLLI3_I8208 () {7;}' unless defined(&T_ATM_BLLI3_I8208);
    eval 'sub T_ATM_BLLI3_X223 () {8;}' unless defined(&T_ATM_BLLI3_X223);
    eval 'sub T_ATM_BLLI3_I8473 () {9;}' unless defined(&T_ATM_BLLI3_I8473);
    eval 'sub T_ATM_BLLI3_T70 () {10;}' unless defined(&T_ATM_BLLI3_T70);
    eval 'sub T_ATM_BLLI3_I9577 () {11;}' unless defined(&T_ATM_BLLI3_I9577);
    eval 'sub T_ATM_PACKET_SIZE_16 () {4;}' unless defined(&T_ATM_PACKET_SIZE_16);
    eval 'sub T_ATM_PACKET_SIZE_32 () {5;}' unless defined(&T_ATM_PACKET_SIZE_32);
    eval 'sub T_ATM_PACKET_SIZE_64 () {6;}' unless defined(&T_ATM_PACKET_SIZE_64);
    eval 'sub T_ATM_PACKET_SIZE_128 () {7;}' unless defined(&T_ATM_PACKET_SIZE_128);
    eval 'sub T_ATM_PACKET_SIZE_256 () {8;}' unless defined(&T_ATM_PACKET_SIZE_256);
    eval 'sub T_ATM_PACKET_SIZE_512 () {9;}' unless defined(&T_ATM_PACKET_SIZE_512);
    eval 'sub T_ATM_PACKET_SIZE_1024 () {10;}' unless defined(&T_ATM_PACKET_SIZE_1024);
    eval 'sub T_ATM_PACKET_SIZE_2048 () {11;}' unless defined(&T_ATM_PACKET_SIZE_2048);
    eval 'sub T_ATM_PACKET_SIZE_4096 () {12;}' unless defined(&T_ATM_PACKET_SIZE_4096);
    eval 'sub T_ATM_PRES_ALLOWED () {0;}' unless defined(&T_ATM_PRES_ALLOWED);
    eval 'sub T_ATM_PRES_RESTRICTED () {1;}' unless defined(&T_ATM_PRES_RESTRICTED);
    eval 'sub T_ATM_PRES_UNAVAILABLE () {2;}' unless defined(&T_ATM_PRES_UNAVAILABLE);
    eval 'sub T_ATM_USER_ID_NOT_SCREENED () {0;}' unless defined(&T_ATM_USER_ID_NOT_SCREENED);
    eval 'sub T_ATM_USER_ID_PASSED_SCREEN () {1;}' unless defined(&T_ATM_USER_ID_PASSED_SCREEN);
    eval 'sub T_ATM_USER_ID_FAILED_SCREEN () {2;}' unless defined(&T_ATM_USER_ID_FAILED_SCREEN);
    eval 'sub T_ATM_NETWORK_PROVIDED_ID () {3;}' unless defined(&T_ATM_NETWORK_PROVIDED_ID);
    eval 'sub T_ATM_ITU_CODING () {0;}' unless defined(&T_ATM_ITU_CODING);
    eval 'sub T_ATM_NETWORK_CODING () {3;}' unless defined(&T_ATM_NETWORK_CODING);
    eval 'sub T_ATM_LOC_USER () {0;}' unless defined(&T_ATM_LOC_USER);
    eval 'sub T_ATM_LOC_LOCAL_PRIVATE_NET () {1;}' unless defined(&T_ATM_LOC_LOCAL_PRIVATE_NET);
    eval 'sub T_ATM_LOC_LOCAL_PUBLIC_NET () {2;}' unless defined(&T_ATM_LOC_LOCAL_PUBLIC_NET);
    eval 'sub T_ATM_LOC_TRANSIT_NET () {3;}' unless defined(&T_ATM_LOC_TRANSIT_NET);
    eval 'sub T_ATM_LOC_REMOTE_PUBLIC_NET () {4;}' unless defined(&T_ATM_LOC_REMOTE_PUBLIC_NET);
    eval 'sub T_ATM_LOC_REMOTE_PRIVATE_NET () {5;}' unless defined(&T_ATM_LOC_REMOTE_PRIVATE_NET);
    eval 'sub T_ATM_LOC_INTERNATIONAL_NET () {7;}' unless defined(&T_ATM_LOC_INTERNATIONAL_NET);
    eval 'sub T_ATM_LOC_BEYOND_INTERWORKING () {10;}' unless defined(&T_ATM_LOC_BEYOND_INTERWORKING);
    eval 'sub T_ATM_CAUSE_UNALLOCATED_NUMBER () {1;}' unless defined(&T_ATM_CAUSE_UNALLOCATED_NUMBER);
    eval 'sub T_ATM_CAUSE_NO_ROUTE_TO_TRANSIT_NETWORK () {2;}' unless defined(&T_ATM_CAUSE_NO_ROUTE_TO_TRANSIT_NETWORK);
    eval 'sub T_ATM_CAUSE_NO_ROUTE_TO_DESTINATION () {3;}' unless defined(&T_ATM_CAUSE_NO_ROUTE_TO_DESTINATION);
    eval 'sub T_ATM_CAUSE_NORMAL_CALL_CLEARING () {16;}' unless defined(&T_ATM_CAUSE_NORMAL_CALL_CLEARING);
    eval 'sub T_ATM_CAUSE_USER_BUSY () {17;}' unless defined(&T_ATM_CAUSE_USER_BUSY);
    eval 'sub T_ATM_CAUSE_NO_USER_RESPONDING () {18;}' unless defined(&T_ATM_CAUSE_NO_USER_RESPONDING);
    eval 'sub T_ATM_CAUSE_CALL_REJECTED () {21;}' unless defined(&T_ATM_CAUSE_CALL_REJECTED);
    eval 'sub T_ATM_CAUSE_NUMBER_CHANGED () {22;}' unless defined(&T_ATM_CAUSE_NUMBER_CHANGED);
    eval 'sub T_ATM_CAUSE_ALL_CALLS_WITHOUT_CALLER_ID_REJECTED () {23;}' unless defined(&T_ATM_CAUSE_ALL_CALLS_WITHOUT_CALLER_ID_REJECTED);
    eval 'sub T_ATM_CAUSE_DESTINATION_OUT_OF_ORDER () {27;}' unless defined(&T_ATM_CAUSE_DESTINATION_OUT_OF_ORDER);
    eval 'sub T_ATM_CAUSE_INVALID_NUMBER_FORMAT () {28;}' unless defined(&T_ATM_CAUSE_INVALID_NUMBER_FORMAT);
    eval 'sub T_ATM_CAUSE_RESPONSE_TO_STATUS_ENQUIRY () {30;}' unless defined(&T_ATM_CAUSE_RESPONSE_TO_STATUS_ENQUIRY);
    eval 'sub T_ATM_CAUSE_UNSPECIFIED_NORMAL () {31;}' unless defined(&T_ATM_CAUSE_UNSPECIFIED_NORMAL);
    eval 'sub T_ATM_CAUSE_REQUESTED_VPCI_VCI_NOT_AVAILABLE () {35;}' unless defined(&T_ATM_CAUSE_REQUESTED_VPCI_VCI_NOT_AVAILABLE);
    eval 'sub T_ATM_CAUSE_VPCI_VCI_ASSIGNMENT_FAILURE () {36;}' unless defined(&T_ATM_CAUSE_VPCI_VCI_ASSIGNMENT_FAILURE);
    eval 'sub T_ATM_CAUSE_USER_CELL_RATE_NOT_AVAILABLE () {37;}' unless defined(&T_ATM_CAUSE_USER_CELL_RATE_NOT_AVAILABLE);
    eval 'sub T_ATM_CAUSE_NETWORK_OUT_OF_ORDER () {38;}' unless defined(&T_ATM_CAUSE_NETWORK_OUT_OF_ORDER);
    eval 'sub T_ATM_CAUSE_TEMPORARY_FAILURE () {41;}' unless defined(&T_ATM_CAUSE_TEMPORARY_FAILURE);
    eval 'sub T_ATM_CAUSE_ACCESS_INFO_DISCARDED () {43;}' unless defined(&T_ATM_CAUSE_ACCESS_INFO_DISCARDED);
    eval 'sub T_ATM_CAUSE_NO_VPCI_VCI_AVAILABLE () {45;}' unless defined(&T_ATM_CAUSE_NO_VPCI_VCI_AVAILABLE);
    eval 'sub T_ATM_CAUSE_UNSPECIFIED_RESOURCE_UNAVAILABLE () {47;}' unless defined(&T_ATM_CAUSE_UNSPECIFIED_RESOURCE_UNAVAILABLE);
    eval 'sub T_ATM_CAUSE_QUALITY_OF_SERVICE_UNAVAILABLE () {49;}' unless defined(&T_ATM_CAUSE_QUALITY_OF_SERVICE_UNAVAILABLE);
    eval 'sub T_ATM_CAUSE_BEARER_CAPABILITY_NOT_AUTHORIZED () {57;}' unless defined(&T_ATM_CAUSE_BEARER_CAPABILITY_NOT_AUTHORIZED);
    eval 'sub T_ATM_CAUSE_BEARER_CAPABILITY_UNAVAILABLE () {58;}' unless defined(&T_ATM_CAUSE_BEARER_CAPABILITY_UNAVAILABLE);
    eval 'sub T_ATM_CAUSE_SERVICE_OR_OPTION_UNAVAILABLE () {63;}' unless defined(&T_ATM_CAUSE_SERVICE_OR_OPTION_UNAVAILABLE);
    eval 'sub T_ATM_CAUSE_BEARER_CAPABILITY_NOT_IMPLEMENTED () {65;}' unless defined(&T_ATM_CAUSE_BEARER_CAPABILITY_NOT_IMPLEMENTED);
    eval 'sub T_ATM_CAUSE_INVALID_TRAFFIC_PARAMETERS () {73;}' unless defined(&T_ATM_CAUSE_INVALID_TRAFFIC_PARAMETERS);
    eval 'sub T_ATM_CAUSE_AAL_PARAMETERS_NOT_SUPPORTED () {78;}' unless defined(&T_ATM_CAUSE_AAL_PARAMETERS_NOT_SUPPORTED);
    eval 'sub T_ATM_CAUSE_INVALID_CALL_REFERENCE_VALUE () {81;}' unless defined(&T_ATM_CAUSE_INVALID_CALL_REFERENCE_VALUE);
    eval 'sub T_ATM_CAUSE_IDENTIFIED_CHANNEL_DOES_NOT_EXIST () {82;}' unless defined(&T_ATM_CAUSE_IDENTIFIED_CHANNEL_DOES_NOT_EXIST);
    eval 'sub T_ATM_CAUSE_INCOMPATIBLE_DESTINATION () {88;}' unless defined(&T_ATM_CAUSE_INCOMPATIBLE_DESTINATION);
    eval 'sub T_ATM_CAUSE_INVALID_ENDPOINT_REFERENCE () {89;}' unless defined(&T_ATM_CAUSE_INVALID_ENDPOINT_REFERENCE);
    eval 'sub T_ATM_CAUSE_INVALID_TRANSIT_NETWORK_SELECTION () {91;}' unless defined(&T_ATM_CAUSE_INVALID_TRANSIT_NETWORK_SELECTION);
    eval 'sub T_ATM_CAUSE_TOO_MANY_PENDING_ADD_PARTY_REQUESTS () {92;}' unless defined(&T_ATM_CAUSE_TOO_MANY_PENDING_ADD_PARTY_REQUESTS);
    eval 'sub T_ATM_CAUSE_MANDITORY_INFO_ELEMENT_MISSING () {96;}' unless defined(&T_ATM_CAUSE_MANDITORY_INFO_ELEMENT_MISSING);
    eval 'sub T_ATM_CAUSE_MESSAGE_TYPE_NOT_IMPLEMENTED () {97;}' unless defined(&T_ATM_CAUSE_MESSAGE_TYPE_NOT_IMPLEMENTED);
    eval 'sub T_ATM_CAUSE_INFO_ELEMENT_NOT_IMPLEMENTED () {99;}' unless defined(&T_ATM_CAUSE_INFO_ELEMENT_NOT_IMPLEMENTED);
    eval 'sub T_ATM_CAUSE_INVALID_INFO_ELEMENT_CONTENTS () {100;}' unless defined(&T_ATM_CAUSE_INVALID_INFO_ELEMENT_CONTENTS);
    eval 'sub T_ATM_CAUSE_MESSAGE_INCOMPATIBLE_WITH_CALL_STATE () {101;}' unless defined(&T_ATM_CAUSE_MESSAGE_INCOMPATIBLE_WITH_CALL_STATE);
    eval 'sub T_ATM_CAUSE_RECOVERY_ON_TIMER_EXPIRY () {102;}' unless defined(&T_ATM_CAUSE_RECOVERY_ON_TIMER_EXPIRY);
    eval 'sub T_ATM_CAUSE_INCORRECT_MESSAGE_LENGTH () {104;}' unless defined(&T_ATM_CAUSE_INCORRECT_MESSAGE_LENGTH);
    eval 'sub T_ATM_CAUSE_UNSPECIFIED_PROTOCOL_ERROR () {111;}' unless defined(&T_ATM_CAUSE_UNSPECIFIED_PROTOCOL_ERROR);
    eval 'sub T_ATM_QOS_CLASS_0 () {0;}' unless defined(&T_ATM_QOS_CLASS_0);
    eval 'sub T_ATM_QOS_CLASS_1 () {1;}' unless defined(&T_ATM_QOS_CLASS_1);
    eval 'sub T_ATM_QOS_CLASS_2 () {2;}' unless defined(&T_ATM_QOS_CLASS_2);
    eval 'sub T_ATM_QOS_CLASS_3 () {3;}' unless defined(&T_ATM_QOS_CLASS_3);
    eval 'sub T_ATM_QOS_CLASS_4 () {4;}' unless defined(&T_ATM_QOS_CLASS_4);
    eval 'sub T_ATM_MAX_NET_ID () {4;}' unless defined(&T_ATM_MAX_NET_ID);
    eval 'sub T_LEAF_NOCHANGE () {0;}' unless defined(&T_LEAF_NOCHANGE);
    eval 'sub T_LEAF_CONNECTED () {1;}' unless defined(&T_LEAF_CONNECTED);
    eval 'sub T_LEAF_DISCONNECTED () {2;}' unless defined(&T_LEAF_DISCONNECTED);
    eval 'sub T_ATM_LLC_MIN_LEN () {3;}' unless defined(&T_ATM_LLC_MIN_LEN);
    eval 'sub T_ATM_LLC_MAX_LEN () {8;}' unless defined(&T_ATM_LLC_MAX_LEN);
    eval 'sub T_ATM_LLC_SHARING () {0x01;}' unless defined(&T_ATM_LLC_SHARING);
    eval 'sub T_ATM_APP_NAME_LEN () {8;}' unless defined(&T_ATM_APP_NAME_LEN);
}
1;
