require '_h2ph_pre.ph';

unless(defined(&_NETATM_KERN_INCLUDE_H)) {
    eval 'sub _NETATM_KERN_INCLUDE_H () {1;}' unless defined(&_NETATM_KERN_INCLUDE_H);
    eval 'sub ATM_KERNEL () {1;}' unless defined(&ATM_KERNEL);
    require 'sys/param.ph';
    require 'sys/systm.ph';
    require 'sys/types.ph';
    require 'sys/errno.ph';
    require 'sys/malloc.ph';
    require 'sys/proc.ph';
    require 'sys/sockio.ph';
    require 'sys/time.ph';
    require 'sys/kernel.ph';
    require 'sys/conf.ph';
    require 'sys/domain.ph';
    require 'sys/protosw.ph';
    require 'sys/socket.ph';
    require 'sys/socketvar.ph';
    require 'sys/syslog.ph';
    if(defined(&sun)) {
	require 'machine/cpu.ph';
	require 'machine/mmu.ph';
	require 'machine/psl.ph';
	require 'sun/openprom.ph';
	require 'sun/vddrv.ph';
	require 'sundev/mbvar.ph';
    }
    if(defined(&__FreeBSD__)) {
	require 'machine/clock.ph';
	require 'vm/vm.ph';
	require 'vm/pmap.ph';
    }
    require 'net/if.ph';
    if((defined( &BSD)  && ((defined(&BSD) ? &BSD : 0) >= 199103))) {
	require 'net/if_types.ph';
	require 'net/if_dl.ph';
    }
    require 'net/netisr.ph';
    require 'net/route.ph';
    require 'netinet/in.ph';
    require 'netinet/in_var.ph';
    require 'netinet/if_ether.ph';
    require 'netatm/port.ph';
    require 'netatm/queue.ph';
    require 'netatm/atm.ph';
    require 'netatm/atm_sys.ph';
    require 'netatm/atm_sap.ph';
    require 'netatm/atm_cm.ph';
    require 'netatm/atm_if.ph';
    require 'netatm/atm_vc.ph';
    require 'netatm/atm_ioctl.ph';
    require 'netatm/atm_sigmgr.ph';
    require 'netatm/atm_stack.ph';
    require 'netatm/atm_pcb.ph';
    require 'netatm/atm_var.ph';
}
1;
