require '_h2ph_pre.ph';

unless(defined(&_NETGRAPH_NETGRAPH_H_)) {
    eval 'sub _NETGRAPH_NETGRAPH_H_ () {1;}' unless defined(&_NETGRAPH_NETGRAPH_H_);
    require 'sys/queue.ph';
    require 'sys/malloc.ph';
    require 'sys/module.ph';
    unless(defined(&KERNEL)) {
	die("This file should not be included in user level programs");
    }
    eval 'sub HK_INVALID () {0x0001;}' unless defined(&HK_INVALID);
    eval 'sub NG_INVALID () {0x001;}' unless defined(&NG_INVALID);
    eval 'sub NG_BUSY () {0x002;}' unless defined(&NG_BUSY);
    eval 'sub NG_TOUCHED () {0x004;}' unless defined(&NG_TOUCHED);
    eval 'sub NGF_TYPE1 () {0x10000000;}' unless defined(&NGF_TYPE1);
    eval 'sub NGF_TYPE2 () {0x20000000;}' unless defined(&NGF_TYPE2);
    eval 'sub NGF_TYPE3 () {0x40000000;}' unless defined(&NGF_TYPE3);
    eval 'sub NGF_TYPE4 () {0x80000000;}' unless defined(&NGF_TYPE4);
    eval 'sub NGM_INVALID_COOKIE () {865455152;}' unless defined(&NGM_INVALID_COOKIE);
    eval 'sub NGMF_TEST () {0x01;}' unless defined(&NGMF_TEST);
    eval 'sub NGMF_TRACE () {0x02;}' unless defined(&NGMF_TRACE);
    eval 'sub NG_SEND_DATA {
        local($error, $hook, $m, $a) = @_;
	    eval q( &do { ($error) =  &ng_send_data(($hook), ($m), ($a)); ($m) =  &NULL; ($a) =  &NULL; }  &while (0));
    }' unless defined(&NG_SEND_DATA);
    eval 'sub NG_SEND_DATAQ {
        local($error, $hook, $m, $a) = @_;
	    eval q( &do { ($error) =  &ng_send_dataq(($hook), ($m), ($a)); ($m) =  &NULL; ($a) =  &NULL; }  &while (0));
    }' unless defined(&NG_SEND_DATAQ);
    eval 'sub NG_FREE_META {
        local($a) = @_;
	    eval q( &do {  &if (($a)) {  &FREE(($a),  &M_NETGRAPH); $a =  &NULL; } }  &while (0));
    }' unless defined(&NG_FREE_META);
    eval 'sub NG_FREE_DATA {
        local($m, $a) = @_;
	    eval q( &do {  &if (($m)) {  &m_freem(($m)); $m =  &NULL; }  &NG_FREE_META(($a)); }  &while (0));
    }' unless defined(&NG_FREE_DATA);
    eval 'sub NETGRAPH_INIT_ORDERED {
        local($typename, $typestructp, $sub, $order) = @_;
	    eval q( &static  &moduledata_t  &ng_$typename &_mod = { \\"ng_\\" $typename,  &ng_mod_event, ($typestructp) };  &DECLARE_MODULE( &ng_$typename,  &ng_$typename &_mod, $sub, $order));
    }' unless defined(&NETGRAPH_INIT_ORDERED);
    eval 'sub NETGRAPH_INIT {
        local($tn, $tp) = @_;
	    eval q( &NETGRAPH_INIT_ORDERED($tn, $tp,  &SI_SUB_PSEUDO,  &SI_ORDER_ANY));
    }' unless defined(&NETGRAPH_INIT);
}
1;
