require '_h2ph_pre.ph';

unless(defined(&_NETGRAPH_NG_MESSAGE_H_)) {
    eval 'sub _NETGRAPH_NG_MESSAGE_H_ () {1;}' unless defined(&_NETGRAPH_NG_MESSAGE_H_);
    eval 'sub NG_TYPELEN () {15;}' unless defined(&NG_TYPELEN);
    eval 'sub NG_HOOKLEN () {15;}' unless defined(&NG_HOOKLEN);
    eval 'sub NG_NODELEN () {15;}' unless defined(&NG_NODELEN);
    eval 'sub NG_PATHLEN () {511;}' unless defined(&NG_PATHLEN);
    eval 'sub NG_CMDSTRLEN () {15;}' unless defined(&NG_CMDSTRLEN);
    eval 'sub NG_TEXTRESPONSE () {1024;}' unless defined(&NG_TEXTRESPONSE);
    eval 'sub NG_GENERIC_NG_MESG_INFO {
        local($dtype) = @_;
	    eval q({ { { \\"version\\",  &ng_parse_int8_type }, { \\"spare\\",  &ng_parse_int8_type }, { \\"arglen\\",  &ng_parse_int16_type }, { \\"flags\\",  &ng_parse_int32_type }, { \\"token\\",  &ng_parse_int32_type }, { \\"typecookie\\",  &ng_parse_int32_type }, { \\"cmd\\",  &ng_parse_int32_type }, { \\"cmdstr\\",  &ng_parse_cmdbuf_type }, { \\"data\\", ($dtype) }, {  &NULL }, } });
    }' unless defined(&NG_GENERIC_NG_MESG_INFO);
    eval 'sub NG_VERSION () {2;}' unless defined(&NG_VERSION);
    eval 'sub NGF_ORIG () {0x0000;}' unless defined(&NGF_ORIG);
    eval 'sub NGF_RESP () {0x0001;}' unless defined(&NGF_RESP);
    eval 'sub ng_ID_t () {\'unsigned int\';}' unless defined(&ng_ID_t);
    eval 'sub NGM_GENERIC_COOKIE () {851672668;}' unless defined(&NGM_GENERIC_COOKIE);
    eval 'sub NGM_SHUTDOWN () {1;}' unless defined(&NGM_SHUTDOWN);
    eval 'sub NGM_MKPEER () {2;}' unless defined(&NGM_MKPEER);
    eval 'sub NGM_CONNECT () {3;}' unless defined(&NGM_CONNECT);
    eval 'sub NGM_NAME () {4;}' unless defined(&NGM_NAME);
    eval 'sub NGM_RMHOOK () {5;}' unless defined(&NGM_RMHOOK);
    eval 'sub NGM_NODEINFO () {6;}' unless defined(&NGM_NODEINFO);
    eval 'sub NGM_LISTHOOKS () {7;}' unless defined(&NGM_LISTHOOKS);
    eval 'sub NGM_LISTNAMES () {8;}' unless defined(&NGM_LISTNAMES);
    eval 'sub NGM_LISTNODES () {9;}' unless defined(&NGM_LISTNODES);
    eval 'sub NGM_LISTTYPES () {10;}' unless defined(&NGM_LISTTYPES);
    eval 'sub NGM_TEXT_STATUS () {11;}' unless defined(&NGM_TEXT_STATUS);
    eval 'sub NGM_BINARY2ASCII () {12;}' unless defined(&NGM_BINARY2ASCII);
    eval 'sub NGM_ASCII2BINARY () {13;}' unless defined(&NGM_ASCII2BINARY);
    eval 'sub NG_GENERIC_MKPEER_INFO () {
        eval q({ { { \\"type\\",  &ng_parse_typebuf_type }, { \\"ourhook\\",  &ng_parse_hookbuf_type }, { \\"peerhook\\",  &ng_parse_hookbuf_type }, {  &NULL }, } });
    }' unless defined(&NG_GENERIC_MKPEER_INFO);
    eval 'sub NG_GENERIC_CONNECT_INFO () {
        eval q({ { { \\"path\\",  &ng_parse_pathbuf_type }, { \\"ourhook\\",  &ng_parse_hookbuf_type }, { \\"peerhook\\",  &ng_parse_hookbuf_type }, {  &NULL }, } });
    }' unless defined(&NG_GENERIC_CONNECT_INFO);
    eval 'sub NG_GENERIC_NAME_INFO () {
        eval q({ { { \\"name\\",  &ng_parse_nodebuf_type }, {  &NULL }, } });
    }' unless defined(&NG_GENERIC_NAME_INFO);
    eval 'sub NG_GENERIC_RMHOOK_INFO () {
        eval q({ { { \\"hook\\",  &ng_parse_hookbuf_type }, {  &NULL }, } });
    }' unless defined(&NG_GENERIC_RMHOOK_INFO);
    eval 'sub NG_GENERIC_NODEINFO_INFO () {
        eval q({ { { \\"name\\",  &ng_parse_nodebuf_type }, { \\"type\\",  &ng_parse_typebuf_type }, { \\"id\\",  &ng_parse_int32_type }, { \\"hooks\\",  &ng_parse_int32_type }, {  &NULL }, } });
    }' unless defined(&NG_GENERIC_NODEINFO_INFO);
    eval 'sub NG_GENERIC_LINKINFO_INFO {
        local($nitype) = @_;
	    eval q({ { { \\"ourhook\\",  &ng_parse_hookbuf_type }, { \\"peerhook\\",  &ng_parse_hookbuf_type }, { \\"nodeinfo\\", ($nitype) }, {  &NULL }, } });
    }' unless defined(&NG_GENERIC_LINKINFO_INFO);
    eval 'sub NG_GENERIC_HOOKLIST_INFO {
        local($nitype,$litype) = @_;
	    eval q({ { { \\"nodeinfo\\", ($nitype) }, { \\"linkinfo\\", ($litype) }, {  &NULL }, } });
    }' unless defined(&NG_GENERIC_HOOKLIST_INFO);
    eval 'sub NG_GENERIC_LISTNODES_INFO {
        local($niarraytype) = @_;
	    eval q({ { { \\"numnames\\",  &ng_parse_int32_type }, { \\"nodeinfo\\", ($niarraytype) }, {  &NULL }, } });
    }' unless defined(&NG_GENERIC_LISTNODES_INFO);
    eval 'sub NG_GENERIC_TYPEINFO_INFO () {
        eval q({ { { \\"typename\\",  &ng_parse_typebuf_type }, { \\"typeinfo\\",  &ng_parse_int32_type }, {  &NULL }, } });
    }' unless defined(&NG_GENERIC_TYPEINFO_INFO);
    eval 'sub NG_GENERIC_TYPELIST_INFO {
        local($tiarraytype) = @_;
	    eval q({ { { \\"numtypes\\",  &ng_parse_int32_type }, { \\"typeinfo\\", ($tiarraytype) }, {  &NULL }, } });
    }' unless defined(&NG_GENERIC_TYPELIST_INFO);
    eval 'sub NGIOCGINFO () { &_IOR(ord(\'N\'), 40, \'struct nodeinfo\');}' unless defined(&NGIOCGINFO);
    eval 'sub NGIOCSETNAME () { &_IOW(ord(\'N\'), 41, \'struct ngm_name\');}' unless defined(&NGIOCSETNAME);
    if(defined(&KERNEL)) {
	eval 'sub NG_MKMESSAGE {
	    local($msg, $cookie, $cmdid, $len, $how) = @_;
    	    eval q( &do {  &MALLOC(($msg), \'struct ng_mesg\' *, $sizeof{\'struct ng_mesg\'} + ($len),  &M_NETGRAPH, ($how));  &if (($msg) ==  &NULL)  &break;  &bzero(($msg), $sizeof{\'struct ng_mesg\'} + ($len)); ($msg)-> ($header->{version}) =  &NG_VERSION; ($msg)-> ($header->{typecookie}) = ($cookie); ($msg)-> ($header->{cmd}) = ($cmdid); ($msg)-> ($header->{arglen}) = ($len);  &strncpy(($msg)-> ($header->{cmdstr}), $cmdid, $sizeof{($msg)-> ($header->{cmdstr})} - 1); }  &while (0));
	}' unless defined(&NG_MKMESSAGE);
	eval 'sub NG_MKRESPONSE {
	    local($rsp, $msg, $len, $how) = @_;
    	    eval q( &do {  &MALLOC(($rsp), \'struct ng_mesg\' *, $sizeof{\'struct ng_mesg\'} + ($len),  &M_NETGRAPH, ($how));  &if (($rsp) ==  &NULL)  &break;  &bzero(($rsp), $sizeof{\'struct ng_mesg\'} + ($len)); ($rsp)-> ($header->{version}) =  &NG_VERSION; ($rsp)-> ($header->{arglen}) = ($len); ($rsp)-> ($header->{token}) = ($msg)-> ($header->{token}); ($rsp)-> ($header->{typecookie}) = ($msg)-> ($header->{typecookie}); ($rsp)-> ($header->{cmd}) = ($msg)-> ($header->{cmd});  &bcopy(($msg)-> ($header->{cmdstr}), ($rsp)-> ($header->{cmdstr}), $sizeof{($rsp)-> ($header->{cmdstr})}); ($rsp)-> ($header->{flags}) |=  &NGF_RESP; }  &while (0));
	}' unless defined(&NG_MKRESPONSE);
    }
}
1;
