require '_h2ph_pre.ph';

unless(defined(&_NETINET_IN_VAR_H_)) {
    eval 'sub _NETINET_IN_VAR_H_ () {1;}' unless defined(&_NETINET_IN_VAR_H_);
    require 'sys/queue.ph';
    eval 'sub ia_ifp () { ($ia_ifa->{ifa_ifp});}' unless defined(&ia_ifp);
    eval 'sub ia_flags () { ($ia_ifa->{ifa_flags});}' unless defined(&ia_flags);
    eval 'sub ia_broadaddr () { &ia_dstaddr;}' unless defined(&ia_broadaddr);
    eval 'sub ifra_dstaddr () { &ifra_broadaddr;}' unless defined(&ifra_dstaddr);
    eval 'sub IA_SIN {
        local($ia) = @_;
	    eval q((((($ia))-> &ia_addr)));
    }' unless defined(&IA_SIN);
    eval 'sub IA_DSTSIN {
        local($ia) = @_;
	    eval q((((($ia))-> &ia_dstaddr)));
    }' unless defined(&IA_DSTSIN);
    eval 'sub IN_LNAOF {
        local($in, $ifa) = @_;
	    eval q((( &ntohl(. &s_addr) & ~(($ifa)-> &ia_subnetmask)));
    }' unless defined(&IN_LNAOF);
    if(defined(&KERNEL)) {
	eval 'sub INADDR_TO_IFP {
	    local($addr, $ifp) = @_;
    	    eval q({  &register \'struct in_ifaddr\' * &ia;  &for ( &ia =  ($in_ifaddrhead->{tqh_first});  &ia !=  &NULL  && (( ($ia->{ia_ifp}->{if_flags}) &  &IFF_POINTOPOINT)?  &IA_DSTSIN( &ia): &IA_SIN( &ia))-> ($sin_addr->{s_addr}) != ($addr). &s_addr;  &ia =  ($ia->{ia_link}->{tqe_next}))  &continue;  &if ( &ia ==  &NULL)  &for ( &ia =  ($in_ifaddrhead->{tqh_first});  &ia !=  &NULL;  &ia =  ($ia->{ia_link}->{tqe_next}))  &if ( ($ia->{ia_ifp}->{if_flags}) &  &IFF_POINTOPOINT  &&  &IA_SIN( &ia)-> ($sin_addr->{s_addr}) == ($addr). &s_addr)  &break; ($ifp) = ( &ia ==  &NULL) ?  &NULL :  ($ia->{ia_ifp}); });
	}' unless defined(&INADDR_TO_IFP);
	eval 'sub IFP_TO_IA {
	    local($ifp, $ia) = @_;
    	    eval q({  &for (($ia) =  ($in_ifaddrhead->{tqh_first}); ($ia) !=  &NULL  && ($ia)-> &ia_ifp != ($ifp); ($ia) = ($ia)-> ($ia_link->{tqe_next}))  &continue; });
	}' unless defined(&IFP_TO_IA);
    }
    if(defined(&KERNEL)) {
	eval 'sub IN_LOOKUP_MULTI {
	    local($addr, $ifp, $inm) = @_;
    	    eval q( &do {  &register \'struct ifmultiaddr\' * &ifma;  &for ( &ifma = -> ($if_multiaddrs->{lh_first});  &ifma;  &ifma =  ($ifma->{ifma_link}->{le_next})) {  &if ( ($ifma->{ifma_addr}->{sa_family}) ==  &AF_INET  && ( ($ifma->{ifma_addr}))-> ($sin_addr->{s_addr}) == ($addr). &s_addr)  &break; } ($inm) =  &ifma ?  ($ifma->{ifma_protospec}) : 0; }  &while(0));
	}' unless defined(&IN_LOOKUP_MULTI);
	eval 'sub IN_NEXT_MULTI {
	    local($step, $inm) = @_;
    	    eval q( &do {  &if ((($inm) = ($step). &i_inm) !=  &NULL) ($step). &i_inm = ($step). ($i_inm->{inm_link}->{le_next}); }  &while(0));
	}' unless defined(&IN_NEXT_MULTI);
	eval 'sub IN_FIRST_MULTI {
	    local($step, $inm) = @_;
    	    eval q( &do { ($step). &i_inm =  ($in_multihead->{lh_first});  &IN_NEXT_MULTI(($step), ($inm)); }  &while(0));
	}' unless defined(&IN_FIRST_MULTI);
    }
}
1;
