require '_h2ph_pre.ph';

unless(defined(&_NETNS_SPP_VAR_H_)) {
    eval 'sub _NETNS_SPP_VAR_H_ () {1;}' unless defined(&_NETNS_SPP_VAR_H_);
    eval 'sub SF_ACKNOW () {0x01;}' unless defined(&SF_ACKNOW);
    eval 'sub SF_DELACK () {0x02;}' unless defined(&SF_DELACK);
    eval 'sub SF_HI () {0x04;}' unless defined(&SF_HI);
    eval 'sub SF_HO () {0x08;}' unless defined(&SF_HO);
    eval 'sub SF_PI () {0x10;}' unless defined(&SF_PI);
    eval 'sub SF_WIN () {0x20;}' unless defined(&SF_WIN);
    eval 'sub SF_RXT () {0x40;}' unless defined(&SF_RXT);
    eval 'sub SF_RVD () {0x80;}' unless defined(&SF_RVD);
    eval 'sub s_cc () { ($s_shdr->{sp_cc});}' unless defined(&s_cc);
    eval 'sub s_dt () { ($s_shdr->{sp_dt});}' unless defined(&s_dt);
    eval 'sub s_sid () { ($s_shdr->{sp_sid});}' unless defined(&s_sid);
    eval 'sub s_did () { ($s_shdr->{sp_did});}' unless defined(&s_did);
    eval 'sub s_seq () { ($s_shdr->{sp_seq});}' unless defined(&s_seq);
    eval 'sub s_ack () { ($s_shdr->{sp_ack});}' unless defined(&s_ack);
    eval 'sub s_alo () { ($s_shdr->{sp_alo});}' unless defined(&s_alo);
    eval 'sub s_dport () { ($s_idp->{idp_dna}->{x_port});}' unless defined(&s_dport);
    eval 'sub CUNIT () {1024;}' unless defined(&CUNIT);
    eval 'sub SF_SOOB () {0x08;}' unless defined(&SF_SOOB);
    eval 'sub SF_IOOB () {0x10;}' unless defined(&SF_IOOB);
    eval 'sub SF_NEWCALL () {0x100;}' unless defined(&SF_NEWCALL);
    eval 'sub SO_NEWCALL () {10;}' unless defined(&SO_NEWCALL);
    eval 'sub nstosppcb {
        local($np) = @_;
	    eval q((($np)-> &nsp_pcb));
    }' unless defined(&nstosppcb);
    eval 'sub sotosppcb {
        local($so) = @_;
	    eval q(( &nstosppcb( &sotonspcb($so))));
    }' unless defined(&sotosppcb);
    if(defined(&KERNEL)) {
	unless(defined(&sppstat)) {
	    eval 'sub sppstat () { ($spp_istat->{newstats});}' unless defined(&sppstat);
	}
    }
    eval 'sub SPP_ISSINCR () {128;}' unless defined(&SPP_ISSINCR);
    if(defined(&sun)) {
	eval 'sub SSEQ_LT {
	    local($a,$b) = @_;
    	    eval q((( &xnsCbug = (($a)-($b))) < 0));
	}' unless defined(&SSEQ_LT);
	eval 'sub SSEQ_LEQ {
	    local($a,$b) = @_;
    	    eval q((( &xnsCbug = (($a)-($b))) <= 0));
	}' unless defined(&SSEQ_LEQ);
	eval 'sub SSEQ_GT {
	    local($a,$b) = @_;
    	    eval q((( &xnsCbug = (($a)-($b))) > 0));
	}' unless defined(&SSEQ_GT);
	eval 'sub SSEQ_GEQ {
	    local($a,$b) = @_;
    	    eval q((( &xnsCbug = (($a)-($b))) >= 0));
	}' unless defined(&SSEQ_GEQ);
    } else {
	eval 'sub SSEQ_LT {
	    local($a,$b) = @_;
    	    eval q((((($a)-($b))) < 0));
	}' unless defined(&SSEQ_LT);
	eval 'sub SSEQ_LEQ {
	    local($a,$b) = @_;
    	    eval q((((($a)-($b))) <= 0));
	}' unless defined(&SSEQ_LEQ);
	eval 'sub SSEQ_GT {
	    local($a,$b) = @_;
    	    eval q((((($a)-($b))) > 0));
	}' unless defined(&SSEQ_GT);
	eval 'sub SSEQ_GEQ {
	    local($a,$b) = @_;
    	    eval q((((($a)-($b))) >= 0));
	}' unless defined(&SSEQ_GEQ);
    }
}
1;
