require '_h2ph_pre.ph';

unless(defined(&_STDIO_H_)) {
    eval 'sub _STDIO_H_ () {1;}' unless defined(&_STDIO_H_);
    require 'sys/cdefs.ph';
    require 'machine/ansi.ph';
    if(defined(&_BSD_SIZE_T_)) {
	undef(&_BSD_SIZE_T_) if defined(&_BSD_SIZE_T_);
    }
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    eval 'sub _FSTDIO () {1;}' unless defined(&_FSTDIO);
    eval 'sub __SLBF () {0x0001;}' unless defined(&__SLBF);
    eval 'sub __SNBF () {0x0002;}' unless defined(&__SNBF);
    eval 'sub __SRD () {0x0004;}' unless defined(&__SRD);
    eval 'sub __SWR () {0x0008;}' unless defined(&__SWR);
    eval 'sub __SRW () {0x0010;}' unless defined(&__SRW);
    eval 'sub __SEOF () {0x0020;}' unless defined(&__SEOF);
    eval 'sub __SERR () {0x0040;}' unless defined(&__SERR);
    eval 'sub __SMBF () {0x0080;}' unless defined(&__SMBF);
    eval 'sub __SAPP () {0x0100;}' unless defined(&__SAPP);
    eval 'sub __SSTR () {0x0200;}' unless defined(&__SSTR);
    eval 'sub __SOPT () {0x0400;}' unless defined(&__SOPT);
    eval 'sub __SNPT () {0x0800;}' unless defined(&__SNPT);
    eval 'sub __SOFF () {0x1000;}' unless defined(&__SOFF);
    eval 'sub __SMOD () {0x2000;}' unless defined(&__SMOD);
    eval 'sub __SALC () {0x4000;}' unless defined(&__SALC);
    eval 'sub _IOFBF () {0;}' unless defined(&_IOFBF);
    eval 'sub _IOLBF () {1;}' unless defined(&_IOLBF);
    eval 'sub _IONBF () {2;}' unless defined(&_IONBF);
    eval 'sub BUFSIZ () {1024;}' unless defined(&BUFSIZ);
    eval 'sub EOF () {(-1);}' unless defined(&EOF);
    eval 'sub FOPEN_MAX () {20;}' unless defined(&FOPEN_MAX);
    eval 'sub FILENAME_MAX () {1024;}' unless defined(&FILENAME_MAX);
    unless(defined(&_ANSI_SOURCE)) {
	eval 'sub P_tmpdir () {"/var/tmp/";}' unless defined(&P_tmpdir);
    }
    eval 'sub L_tmpnam () {1024;}' unless defined(&L_tmpnam);
    eval 'sub TMP_MAX () {308915776;}' unless defined(&TMP_MAX);
    unless(defined(&SEEK_SET)) {
	eval 'sub SEEK_SET () {0;}' unless defined(&SEEK_SET);
    }
    unless(defined(&SEEK_CUR)) {
	eval 'sub SEEK_CUR () {1;}' unless defined(&SEEK_CUR);
    }
    unless(defined(&SEEK_END)) {
	eval 'sub SEEK_END () {2;}' unless defined(&SEEK_END);
    }
    eval 'sub stdin () {(& $__sF[0]);}' unless defined(&stdin);
    eval 'sub stdout () {(& $__sF[1]);}' unless defined(&stdout);
    eval 'sub stderr () {(& $__sF[2]);}' unless defined(&stderr);
    if(!defined( &_ANSI_SOURCE)  && !defined( &_POSIX_SOURCE)) {
    }
    unless(defined(&_ANSI_SOURCE)) {
	eval 'sub L_cuserid () {17;}' unless defined(&L_cuserid);
	eval 'sub L_ctermid () {1024;}' unless defined(&L_ctermid);
    }
    if(!defined ( &_ANSI_SOURCE)  && !defined( &_POSIX_SOURCE)) {
	unless(defined(&_FTRUNCATE_DECLARED)) {
	    eval 'sub _FTRUNCATE_DECLARED () {1;}' unless defined(&_FTRUNCATE_DECLARED);
	}
	unless(defined(&_LSEEK_DECLARED)) {
	    eval 'sub _LSEEK_DECLARED () {1;}' unless defined(&_LSEEK_DECLARED);
	}
	unless(defined(&_MMAP_DECLARED)) {
	    eval 'sub _MMAP_DECLARED () {1;}' unless defined(&_MMAP_DECLARED);
	}
	unless(defined(&_TRUNCATE_DECLARED)) {
	    eval 'sub _TRUNCATE_DECLARED () {1;}' unless defined(&_TRUNCATE_DECLARED);
	}
    }
    if(!defined ( &_ANSI_SOURCE)  && !defined( &_POSIX_SOURCE)) {
	eval 'sub vfscanf () { &__svfscanf;}' unless defined(&vfscanf);
	eval 'sub fropen {
	    local($cookie, $fn) = @_;
    	    eval q( &funopen($cookie, $fn, 0, 0, 0));
	}' unless defined(&fropen);
	eval 'sub fwopen {
	    local($cookie, $fn) = @_;
    	    eval q( &funopen($cookie, 0, $fn, 0, 0));
	}' unless defined(&fwopen);
    }
    eval 'sub __sgetc {
        local($p) = @_;
	    eval q((---> &_r < 0?  &__srget : (*($p)-> &_p++)));
    }' unless defined(&__sgetc);
    if(defined( &__GNUC__)  && defined( &__STDC__)) {
    } else {
	eval 'sub __sputc {
	    local($c, $p) = @_;
    	    eval q((---> &_w < 0? -> &_w >= -> &_lbfsize ? (*-> &_p = ), *-> &_p != ord(\'\\\\n\' ? 				*->_p++ : 				__swbuf(\'\\\\n\'), $p) :  &__swbuf(($c), $p) : (*($p)-> &_p = ($c), *($p)-> &_p++)));
	}' unless defined(&__sputc);
    }
    eval 'sub __sfeof {
        local($p) = @_;
	    eval q(((($p)-> &_flags &  &__SEOF) != 0));
    }' unless defined(&__sfeof);
    eval 'sub __sferror {
        local($p) = @_;
	    eval q(((($p)-> &_flags &  &__SERR) != 0));
    }' unless defined(&__sferror);
    eval 'sub __sclearerr {
        local($p) = @_;
	    eval q(((($p)-> &_flags &= ~( &__SERR| &__SEOF))));
    }' unless defined(&__sclearerr);
    eval 'sub __sfileno {
        local($p) = @_;
	    eval q((($p)-> &_file));
    }' unless defined(&__sfileno);
    eval 'sub feof_unlocked {
        local($p) = @_;
	    eval q( &__sfeof($p));
    }' unless defined(&feof_unlocked);
    eval 'sub ferror_unlocked {
        local($p) = @_;
	    eval q( &__sferror($p));
    }' unless defined(&ferror_unlocked);
    eval 'sub clearerr_unlocked {
        local($p) = @_;
	    eval q( &__sclearerr($p));
    }' unless defined(&clearerr_unlocked);
    unless(defined(&_ANSI_SOURCE)) {
	eval 'sub fileno_unlocked {
	    local($p) = @_;
    	    eval q( &__sfileno($p));
	}' unless defined(&fileno_unlocked);
    }
    unless(defined(&_THREAD_SAFE)) {
	eval 'sub feof {
	    local($p) = @_;
    	    eval q( &feof_unlocked($p));
	}' unless defined(&feof);
	eval 'sub ferror {
	    local($p) = @_;
    	    eval q( &ferror_unlocked($p));
	}' unless defined(&ferror);
	eval 'sub clearerr {
	    local($p) = @_;
    	    eval q( &clearerr_unlocked($p));
	}' unless defined(&clearerr);
	unless(defined(&_ANSI_SOURCE)) {
	    eval 'sub fileno {
	        local($p) = @_;
    		eval q( &fileno_unlocked($p));
	    }' unless defined(&fileno);
	}
    }
    unless(defined(&lint)) {
	eval 'sub getc_unlocked {
	    local($fp) = @_;
    	    eval q( &__sgetc($fp));
	}' unless defined(&getc_unlocked);
	eval 'sub putc_unlocked {
	    local($x, $fp) = @_;
    	    eval q( &__sputc($x, $fp));
	}' unless defined(&putc_unlocked);
	if(defined(&_THREAD_SAFE)) {
	    if(defined(&_FLOCK_DEBUG)) {
		eval 'sub _FLOCKFILE {
		    local($x) = @_;
    		    eval q( &_flockfile_debug($x,  &__FILE__,  &__LINE__));
		}' unless defined(&_FLOCKFILE);
	    } else {
		eval 'sub _FLOCKFILE {
		    local($x) = @_;
    		    eval q( &flockfile($x));
		}' unless defined(&_FLOCKFILE);
	    }
	    eval 'sub getc {
	        local($fp) = @_;
    		eval q( &__getc_locked($fp));
	    }' unless defined(&getc);
	    eval 'sub putc {
	        local($x, $fp) = @_;
    		eval q( &__putc_locked($x, $fp));
	    }' unless defined(&putc);
	} else {
	    eval 'sub getc {
	        local($fp) = @_;
    		eval q( &getc_unlocked($fp));
	    }' unless defined(&getc);
	    eval 'sub putc {
	        local($x, $fp) = @_;
    		eval q( &putc_unlocked($x, $fp));
	    }' unless defined(&putc);
	}
    }
    eval 'sub getchar () {
        eval q( &getc( &stdin));
    }' unless defined(&getchar);
    eval 'sub getchar_unlocked () {
        eval q( &getc_unlocked( &stdin));
    }' unless defined(&getchar_unlocked);
    eval 'sub putchar {
        local($x) = @_;
	    eval q( &putc($x,  &stdout));
    }' unless defined(&putchar);
    eval 'sub putchar_unlocked {
        local($x) = @_;
	    eval q( &putc_unlocked($x,  &stdout));
    }' unless defined(&putchar_unlocked);
}
1;
