require '_h2ph_pre.ph';

unless(defined(&_SYS_BUS_H_)) {
    eval 'sub _SYS_BUS_H_ () {1;}' unless defined(&_SYS_BUS_H_);
    if(defined(&KERNEL)) {
	eval("sub DRIVER_TYPE_TTY () { 1; }") unless defined(&DRIVER_TYPE_TTY);
	eval("sub DRIVER_TYPE_BIO () { 2; }") unless defined(&DRIVER_TYPE_BIO);
	eval("sub DRIVER_TYPE_NET () { 4; }") unless defined(&DRIVER_TYPE_NET);
	eval("sub DRIVER_TYPE_CAM () { 8; }") unless defined(&DRIVER_TYPE_CAM);
	eval("sub DRIVER_TYPE_MISC () { 16; }") unless defined(&DRIVER_TYPE_MISC);
	eval("sub DRIVER_TYPE_FAST () { 128; }") unless defined(&DRIVER_TYPE_FAST);
	eval("sub DS_NOTPRESENT () { 0; }") unless defined(&DS_NOTPRESENT);
	eval("sub DS_ALIVE () { 1; }") unless defined(&DS_ALIVE);
	eval("sub DS_ATTACHED () { 2; }") unless defined(&DS_ATTACHED);
	eval("sub DS_BUSY () { 3; }") unless defined(&DS_BUSY);
	eval 'sub DEVMETHOD {
	    local($NAME, $FUNC) = @_;
    	    eval q({ $NAME &_desc, $FUNC });
	}' unless defined(&DEVMETHOD);
	require 'device_if.ph';
	require 'bus_if.ph';
	eval 'sub DRIVER_MODULE {
	    local($name, $busname, $driver, $devclass, $evh, $arg) = @_;
    	    eval q( &static  &driver_t *$name &_$busname $_driver_list[] = { $driver };  &static \'struct driver_module_data\' $name &_$busname &_driver_mod = { $evh, $arg, $busname, $name &_$busname &_driver_list, ( &sizeof $name &_$busname &_driver_list) / ( &sizeof $name &_$busname $_driver_list[0]), $devclass };  &static  &moduledata_t $name &_$busname &_mod = { $busname \\"/\\" $name,  &driver_module_handler, $name &_$busname &_driver_mod };  &DECLARE_MODULE($name &_$busname, $name &_$busname &_mod,  &SI_SUB_DRIVERS,  &SI_ORDER_MIDDLE));
	}' unless defined(&DRIVER_MODULE);
	eval 'sub MULTI_DRIVER_MODULE {
	    local($name, $busname, $drivers, $devclass, $evh, $arg) = @_;
    	    eval q( &static  &driver_t $name &_$busname $_driver_list[] = $drivers;  &static \'struct driver_module_data\' $name &_$busname &_driver_mod = { $evh, $arg, $busname, $name &_$busname &_driver_list, ( &sizeof $name &_$busname &_driver_list) / ( &sizeof $name &_$busname $_driver_list[0]), $devclass };  &static  &moduledata_t $name &_$busname &_mod = { $busname \\"/\\" $name,  &driver_module_handler, $name &_$busname &_driver_mod };  &DECLARE_MODULE($name &_$busname, $name &_$busname &_mod,  &SI_SUB_DRIVERS,  &SI_ORDER_MIDDLE));
	}' unless defined(&MULTI_DRIVER_MODULE);
	eval 'sub CDEV_DRIVER_MODULE {
	    local($name, $busname, $driver, $devclass,					   $major, $devsw, $evh, $arg) = @_;
    	    eval q( &static \'struct cdevsw_module_data\' $name &_$busname &_cdevsw_mod = { $evh, $arg,  &makedev($major, 0), $devsw };  &DRIVER_MODULE($name, $busname, $driver, $devclass,  &cdevsw_module_handler, $name &_$busname &_cdevsw_mod));
	}' unless defined(&CDEV_DRIVER_MODULE);
	eval 'sub BDEV_DRIVER_MODULE {
	    local($name, $busname, $driver, $devclass,					   $bmajor, $cmajor, $devsw, $evh, $arg) = @_;
    	    eval q( &static \'struct bdevsw_module_data\' $name &_$busname &_bdevsw_mod = { $evh, $arg,  &makedev($bmajor, 0),  &makedev($cmajor, 0), $devsw };  &DRIVER_MODULE($name, $busname, $driver, $devclass,  &bdevsw_module_handler, $name &_$busname &_bdevsw_mod));
	}' unless defined(&BDEV_DRIVER_MODULE);
    }
}
1;
