require '_h2ph_pre.ph';

unless(defined(&_SYS_DISKLABEL_H_)) {
    eval 'sub _SYS_DISKLABEL_H_ () {1;}' unless defined(&_SYS_DISKLABEL_H_);
    unless(defined(&KERNEL)) {
	require 'sys/types.ph';
    }
    require 'sys/ioccom.ph';
    eval 'sub _PATH_DISKTAB () {"/etc/disktab";}' unless defined(&_PATH_DISKTAB);
    eval 'sub DISKTAB () {"/etc/disktab";}' unless defined(&DISKTAB);
    if(defined(&__i386__)) {
	eval 'sub LABELSECTOR () {1;}' unless defined(&LABELSECTOR);
	eval 'sub LABELOFFSET () {0;}' unless defined(&LABELOFFSET);
    }
    if(defined(&__alpha__)) {
	eval 'sub LABELSECTOR () {0;}' unless defined(&LABELSECTOR);
	eval 'sub LABELOFFSET () {64;}' unless defined(&LABELOFFSET);
    }
    unless(defined(&LABELSECTOR)) {
	eval 'sub LABELSECTOR () {0;}' unless defined(&LABELSECTOR);
    }
    unless(defined(&LABELOFFSET)) {
	eval 'sub LABELOFFSET () {64;}' unless defined(&LABELOFFSET);
    }
    eval 'sub DISKMAGIC () {(0x82564557);}' unless defined(&DISKMAGIC);
    unless(defined(&MAXPARTITIONS)) {
	eval 'sub MAXPARTITIONS () {8;}' unless defined(&MAXPARTITIONS);
    }
    eval 'sub LABEL_PART () {2;}' unless defined(&LABEL_PART);
    eval 'sub RAW_PART () {2;}' unless defined(&RAW_PART);
    eval 'sub SWAP_PART () {1;}' unless defined(&SWAP_PART);
    unless(defined(&LOCORE)) {
	eval 'sub d_packname () { ($d_un->{un_d_packname});}' unless defined(&d_packname);
	eval 'sub d_boot0 () { ($d_un->{un_b}->{un_d_boot0});}' unless defined(&d_boot0);
	eval 'sub d_boot1 () { ($d_un->{un_b}->{un_d_boot1});}' unless defined(&d_boot1);
	eval 'sub NDDATA () {5;}' unless defined(&NDDATA);
	eval 'sub NSPARE () {5;}' unless defined(&NSPARE);
	eval 'sub p_cpg () { ($__partition_u1->{cpg});}' unless defined(&p_cpg);
	eval 'sub p_sgs () { ($__partition_u1->{sgs});}' unless defined(&p_sgs);
    } else {
    }
    eval 'sub DTYPE_SMD () {1;}' unless defined(&DTYPE_SMD);
    eval 'sub DTYPE_MSCP () {2;}' unless defined(&DTYPE_MSCP);
    eval 'sub DTYPE_DEC () {3;}' unless defined(&DTYPE_DEC);
    eval 'sub DTYPE_SCSI () {4;}' unless defined(&DTYPE_SCSI);
    eval 'sub DTYPE_ESDI () {5;}' unless defined(&DTYPE_ESDI);
    eval 'sub DTYPE_ST506 () {6;}' unless defined(&DTYPE_ST506);
    eval 'sub DTYPE_HPIB () {7;}' unless defined(&DTYPE_HPIB);
    eval 'sub DTYPE_HPFL () {8;}' unless defined(&DTYPE_HPFL);
    eval 'sub DTYPE_FLOPPY () {10;}' unless defined(&DTYPE_FLOPPY);
    eval 'sub DTYPE_CCD () {11;}' unless defined(&DTYPE_CCD);
    eval 'sub DTYPE_VINUM () {12;}' unless defined(&DTYPE_VINUM);
    eval 'sub DTYPE_DOC2K () {13;}' unless defined(&DTYPE_DOC2K);
    if(defined(&PC98)) {
	eval 'sub DSTYPE_SEC256 () {0x80;}' unless defined(&DSTYPE_SEC256);
    }
    if(defined(&DKTYPENAMES)) {
	eval 'sub DKMAXTYPES () {($sizeof{ &dktypenames} / $sizeof{ $dktypenames[0]} - 1);}' unless defined(&DKMAXTYPES);
    }
    eval 'sub FS_UNUSED () {0;}' unless defined(&FS_UNUSED);
    eval 'sub FS_SWAP () {1;}' unless defined(&FS_SWAP);
    eval 'sub FS_V6 () {2;}' unless defined(&FS_V6);
    eval 'sub FS_V7 () {3;}' unless defined(&FS_V7);
    eval 'sub FS_SYSV () {4;}' unless defined(&FS_SYSV);
    eval 'sub FS_V71K () {5;}' unless defined(&FS_V71K);
    eval 'sub FS_V8 () {6;}' unless defined(&FS_V8);
    eval 'sub FS_BSDFFS () {7;}' unless defined(&FS_BSDFFS);
    eval 'sub FS_MSDOS () {8;}' unless defined(&FS_MSDOS);
    eval 'sub FS_BSDLFS () {9;}' unless defined(&FS_BSDLFS);
    eval 'sub FS_OTHER () {10;}' unless defined(&FS_OTHER);
    eval 'sub FS_HPFS () {11;}' unless defined(&FS_HPFS);
    eval 'sub FS_ISO9660 () {12;}' unless defined(&FS_ISO9660);
    eval 'sub FS_BOOT () {13;}' unless defined(&FS_BOOT);
    eval 'sub FS_VINUM () {14;}' unless defined(&FS_VINUM);
    if(defined(&DKTYPENAMES)) {
	eval 'sub FSMAXTYPES () {($sizeof{ &fstypenames} / $sizeof{ $fstypenames[0]} - 1);}' unless defined(&FSMAXTYPES);
    }
    eval 'sub D_REMOVABLE () {0x01;}' unless defined(&D_REMOVABLE);
    eval 'sub D_ECC () {0x02;}' unless defined(&D_ECC);
    eval 'sub D_BADSECT () {0x04;}' unless defined(&D_BADSECT);
    eval 'sub D_RAMDISK () {0x08;}' unless defined(&D_RAMDISK);
    eval 'sub D_CHAIN () {0x10;}' unless defined(&D_CHAIN);
    eval 'sub d_smdflags () { $d_drivedata[0];}' unless defined(&d_smdflags);
    eval 'sub D_SSE () {0x1;}' unless defined(&D_SSE);
    eval 'sub d_mindist () { $d_drivedata[1];}' unless defined(&d_mindist);
    eval 'sub d_maxdist () { $d_drivedata[2];}' unless defined(&d_maxdist);
    eval 'sub d_sdist () { $d_drivedata[3];}' unless defined(&d_sdist);
    eval 'sub d_precompcyl () { $d_drivedata[0];}' unless defined(&d_precompcyl);
    eval 'sub d_gap3 () { $d_drivedata[1];}' unless defined(&d_gap3);
    eval 'sub d_blind () { $d_drivedata[0];}' unless defined(&d_blind);
    unless(defined(&LOCORE)) {
	if(defined(&PC98)) {
	    eval 'sub DOSBBSECTOR () {0;}' unless defined(&DOSBBSECTOR);
	    eval 'sub DOSLABELSECTOR () {1;}' unless defined(&DOSLABELSECTOR);
	    eval 'sub DOSPARTOFF () {0;}' unless defined(&DOSPARTOFF);
	    eval 'sub NDOSPART () {16;}' unless defined(&NDOSPART);
	    eval 'sub DOSPTYP_386BSD () {0x94;}' unless defined(&DOSPTYP_386BSD);
	    eval 'sub MBR_PTYPE_FreeBSD () {0x94;}' unless defined(&MBR_PTYPE_FreeBSD);
	    eval 'sub DOSMID_386BSD () {(0x14|0x80);}' unless defined(&DOSMID_386BSD);
	    eval 'sub DOSSID_386BSD () {(0x44|0x80);}' unless defined(&DOSSID_386BSD);
	} else {
	    eval 'sub DOSBBSECTOR () {0;}' unless defined(&DOSBBSECTOR);
	    eval 'sub DOSPARTOFF () {446;}' unless defined(&DOSPARTOFF);
	    eval 'sub NDOSPART () {4;}' unless defined(&NDOSPART);
	    eval 'sub DOSPTYP_386BSD () {0xa5;}' unless defined(&DOSPTYP_386BSD);
	}
	eval 'sub DPSECT {
	    local($s) = @_;
    	    eval q((($s) & 0x3f));
	}' unless defined(&DPSECT);
	eval 'sub DPCYL {
	    local($c, $s) = @_;
    	    eval q((($c) + ((($s) & 0xc0)<<2)));
	}' unless defined(&DPCYL);
	eval 'sub DIOCGDINFO () { &_IOR(ord(\'d\'), 101, \'struct disklabel\');}' unless defined(&DIOCGDINFO);
	eval 'sub DIOCSDINFO () { &_IOW(ord(\'d\'), 102, \'struct disklabel\');}' unless defined(&DIOCSDINFO);
	eval 'sub DIOCWDINFO () { &_IOW(ord(\'d\'), 103, \'struct disklabel\');}' unless defined(&DIOCWDINFO);
	eval 'sub DIOCGPART () { &_IOW(ord(\'d\'), 104, \'struct partinfo\');}' unless defined(&DIOCGPART);
	eval 'sub DIOCRFORMAT () { &_IOWR(ord(\'d\'), 105, \'struct format_op\');}' unless defined(&DIOCRFORMAT);
	eval 'sub DIOCWFORMAT () { &_IOWR(ord(\'d\'), 106, \'struct format_op\');}' unless defined(&DIOCWFORMAT);
	eval 'sub DIOCSSTEP () { &_IOW(ord(\'d\'), 107, \'int\');}' unless defined(&DIOCSSTEP);
	eval 'sub DIOCSRETRIES () { &_IOW(ord(\'d\'), 108, \'int\');}' unless defined(&DIOCSRETRIES);
	eval 'sub DIOCWLABEL () { &_IOW(ord(\'d\'), 109, \'int\');}' unless defined(&DIOCWLABEL);
	eval 'sub DIOCSBAD () { &_IOW(ord(\'d\'), 110, \'struct dkbad\');}' unless defined(&DIOCSBAD);
	eval 'sub DIOCSBADSCAN () { &_IOW(ord(\'d\'), 111, \'int\');}' unless defined(&DIOCSBADSCAN);
	eval 'sub dkmakeminor {
	    local($unit, $slice, $part) = @_;
    	    eval q(((($slice) << 16) | ((($unit) & 0x1e0) << 16) | ((($unit) & 0x1f) << 3) | ($part)));
	}' unless defined(&dkmakeminor);
	eval 'sub dkmodpart {
	    local($dev, $part) = @_;
    	    eval q((( & ~7) | ($part)));
	}' unless defined(&dkmodpart);
	eval 'sub dkmodslice {
	    local($dev, $slice) = @_;
    	    eval q((( & ~0x1f0000) | (($slice) << 16)));
	}' unless defined(&dkmodslice);
	eval 'sub dkpart {
	    local($dev) = @_;
    	    eval q(( &minor($dev) & 7));
	}' unless defined(&dkpart);
	eval 'sub dkslice {
	    local($dev) = @_;
    	    eval q((( &minor($dev) >> 16) & 0x1f));
	}' unless defined(&dkslice);
	eval 'sub dktype {
	    local($dev) = @_;
    	    eval q((( &minor($dev) >> 25) & 0x7f));
	}' unless defined(&dktype);
	eval 'sub dkunit {
	    local($dev) = @_;
    	    eval q((((($dev) >> 16) & 0x1e0) | ((($dev) >> 3) & 0x1f)));
	}' unless defined(&dkunit);
	if(defined(&KERNEL)) {
	}
    }
    unless(defined(&KERNEL)) {
    }
}
1;
