require '_h2ph_pre.ph';

unless(defined(&_SYS_ELF64_H_)) {
    eval 'sub _SYS_ELF64_H_ () {1;}' unless defined(&_SYS_ELF64_H_);
    require 'sys/elf_common.ph';
    eval 'sub ELF64_R_SYM {
        local($info) = @_;
	    eval q((($info) >> 32));
    }' unless defined(&ELF64_R_SYM);
    eval 'sub ELF64_R_TYPE {
        local($info) = @_;
	    eval q((($info)));
    }' unless defined(&ELF64_R_TYPE);
    eval 'sub ELF64_R_INFO {
        local($sym, $type) = @_;
	    eval q((( << 32) + ($type)));
    }' unless defined(&ELF64_R_INFO);
    eval 'sub ELF64_ST_BIND {
        local($info) = @_;
	    eval q((($info) >> 4));
    }' unless defined(&ELF64_ST_BIND);
    eval 'sub ELF64_ST_TYPE {
        local($info) = @_;
	    eval q((($info) & 0xf));
    }' unless defined(&ELF64_ST_TYPE);
    eval 'sub ELF64_ST_INFO {
        local($bind, $type) = @_;
	    eval q(((($bind) << 4) + (($type) & 0xf)));
    }' unless defined(&ELF64_ST_INFO);
}
1;
