require '_h2ph_pre.ph';

unless(defined(&_SYS_LINKER_H_)) {
    eval 'sub _SYS_LINKER_H_ () {1;}' unless defined(&_SYS_LINKER_H_);
    if(defined(&KERNEL)) {
	require 'machine/elf.ph';
	if(defined(&MALLOC_DECLARE)) {
	}
	eval 'sub LINKER_FILE_LINKED () {0x1;}' unless defined(&LINKER_FILE_LINKED);
    }
    eval 'sub MODINFO_END () {0x0000;}' unless defined(&MODINFO_END);
    eval 'sub MODINFO_NAME () {0x0001;}' unless defined(&MODINFO_NAME);
    eval 'sub MODINFO_TYPE () {0x0002;}' unless defined(&MODINFO_TYPE);
    eval 'sub MODINFO_ADDR () {0x0003;}' unless defined(&MODINFO_ADDR);
    eval 'sub MODINFO_SIZE () {0x0004;}' unless defined(&MODINFO_SIZE);
    eval 'sub MODINFO_EMPTY () {0x0005;}' unless defined(&MODINFO_EMPTY);
    eval 'sub MODINFO_METADATA () {0x8000;}' unless defined(&MODINFO_METADATA);
    eval 'sub MODINFOMD_AOUTEXEC () {0x0001;}' unless defined(&MODINFOMD_AOUTEXEC);
    eval 'sub MODINFOMD_ELFHDR () {0x0002;}' unless defined(&MODINFOMD_ELFHDR);
    eval 'sub MODINFOMD_SSYM () {0x0003;}' unless defined(&MODINFOMD_SSYM);
    eval 'sub MODINFOMD_ESYM () {0x0004;}' unless defined(&MODINFOMD_ESYM);
    eval 'sub MODINFOMD_DYNAMIC () {0x0005;}' unless defined(&MODINFOMD_DYNAMIC);
    eval 'sub MODINFOMD_NOCOPY () {0x8000;}' unless defined(&MODINFOMD_NOCOPY);
    eval 'sub MODINFOMD_DEPLIST () {(0x4001 |  &MODINFOMD_NOCOPY);}' unless defined(&MODINFOMD_DEPLIST);
    if(defined(&KERNEL)) {
	if(defined(&KLD_DEBUG)) {
	    eval 'sub KLD_DEBUG_FILE () {1;}' unless defined(&KLD_DEBUG_FILE);
	    eval 'sub KLD_DEBUG_SYM () {2;}' unless defined(&KLD_DEBUG_SYM);
	    eval 'sub KLD_DPF {
	        local($cat, $args) = @_;
    		eval q( &do {  &if ( &kld_debug &  &KLD_DEBUG_$cat)  &printf $args; }  &while (0));
	    }' unless defined(&KLD_DPF);
	} else {
	    eval 'sub KLD_DPF {
	        local($cat, $args) = @_;
    		eval q();
	    }' unless defined(&KLD_DPF);
	}
	eval 'sub ELF_RELOC_REL () {1;}' unless defined(&ELF_RELOC_REL);
	eval 'sub ELF_RELOC_RELA () {2;}' unless defined(&ELF_RELOC_RELA);
    }
    eval 'sub KLDSYM_LOOKUP () {1;}' unless defined(&KLDSYM_LOOKUP);
    unless(defined(&KERNEL)) {
	require 'sys/cdefs.ph';
    }
}
1;
