require '_h2ph_pre.ph';

unless(defined(&_SYS_TYPES_H_)) {
    eval 'sub _SYS_TYPES_H_ () {1;}' unless defined(&_SYS_TYPES_H_);
    require 'sys/cdefs.ph';
    require 'sys/inttypes.ph';
    require 'machine/types.ph';
    unless(defined(&_POSIX_SOURCE)) {
    }
    if(defined(&__alpha__)) {
    } else {
    }
    if(defined(&KERNEL)) {
    }
    unless(defined(&_POSIX_SOURCE)) {
	eval 'sub major {
	    local($x) = @_;
    	    eval q((((($x) >> 8)&0xff)));
	}' unless defined(&major);
	eval 'sub minor {
	    local($x) = @_;
    	    eval q(((($x)&0xffff00ff)));
	}' unless defined(&minor);
	eval 'sub makedev {
	    local($x,$y) = @_;
    	    eval q((((($x) << 8) | ($y))));
	}' unless defined(&makedev);
    }
    require 'machine/endian.ph';
    if(defined(&_BSD_CLOCK_T_)) {
	undef(&_BSD_CLOCK_T_) if defined(&_BSD_CLOCK_T_);
    }
    if(defined(&_BSD_CLOCKID_T_)) {
	undef(&_BSD_CLOCKID_T_) if defined(&_BSD_CLOCKID_T_);
    }
    if(defined(&_BSD_SIZE_T_)) {
	undef(&_BSD_SIZE_T_) if defined(&_BSD_SIZE_T_);
    }
    if(defined(&_BSD_SSIZE_T_)) {
	undef(&_BSD_SSIZE_T_) if defined(&_BSD_SSIZE_T_);
    }
    if(defined(&_BSD_TIME_T_)) {
	undef(&_BSD_TIME_T_) if defined(&_BSD_TIME_T_);
    }
    if(defined(&_BSD_TIMER_T_)) {
	undef(&_BSD_TIMER_T_) if defined(&_BSD_TIMER_T_);
    }
    unless(defined(&_POSIX_SOURCE)) {
	eval 'sub NBBY () {8;}' unless defined(&NBBY);
	unless(defined(&FD_SETSIZE)) {
	    eval 'sub FD_SETSIZE () {1024;}' unless defined(&FD_SETSIZE);
	}
	eval 'sub NFDBITS () {($sizeof{ &fd_mask} *  &NBBY);}' unless defined(&NFDBITS);
	unless(defined(&howmany)) {
	    eval 'sub howmany {
	        local($x, $y) = @_;
    		eval q(((($x) + (($y) - 1)) / ($y)));
	    }' unless defined(&howmany);
	}
	eval 'sub FD_SET {
	    local($n, $p) = @_;
    	    eval q((($p)-> $fds_bits[($n)/ &NFDBITS] |= (1<< (($n) %  &NFDBITS))));
	}' unless defined(&FD_SET);
	eval 'sub FD_CLR {
	    local($n, $p) = @_;
    	    eval q((($p)-> $fds_bits[($n)/ &NFDBITS] &= ~(1<< (($n) %  &NFDBITS))));
	}' unless defined(&FD_CLR);
	eval 'sub FD_ISSET {
	    local($n, $p) = @_;
    	    eval q((($p)-> $fds_bits[($n)/ &NFDBITS] & (1<< (($n) %  &NFDBITS))));
	}' unless defined(&FD_ISSET);
	eval 'sub FD_COPY {
	    local($f, $t) = @_;
    	    eval q( &bcopy($f, $t, $sizeof{($f)}));
	}' unless defined(&FD_COPY);
	eval 'sub FD_ZERO {
	    local($p) = @_;
    	    eval q( &bzero($p, $sizeof{($p)}));
	}' unless defined(&FD_ZERO);
	unless(defined(&KERNEL)) {
	    unless(defined(&_FTRUNCATE_DECLARED)) {
		eval 'sub _FTRUNCATE_DECLARED () {1;}' unless defined(&_FTRUNCATE_DECLARED);
	    }
	    unless(defined(&_LSEEK_DECLARED)) {
		eval 'sub _LSEEK_DECLARED () {1;}' unless defined(&_LSEEK_DECLARED);
	    }
	    unless(defined(&_MMAP_DECLARED)) {
		eval 'sub _MMAP_DECLARED () {1;}' unless defined(&_MMAP_DECLARED);
	    }
	    unless(defined(&_TRUNCATE_DECLARED)) {
		eval 'sub _TRUNCATE_DECLARED () {1;}' unless defined(&_TRUNCATE_DECLARED);
	    }
	}
    }
}
1;
