require '_h2ph_pre.ph';

unless(defined(&_SYS_USER_H_)) {
    eval 'sub _SYS_USER_H_ () {1;}' unless defined(&_SYS_USER_H_);
    require 'machine/pcb.ph';
    unless(defined(&KERNEL)) {
	require 'sys/errno.ph';
	require 'sys/time.ph';
	require 'sys/resource.ph';
	require 'sys/ucred.ph';
	require 'sys/uio.ph';
	require 'sys/proc.ph';
	require 'vm/vm.ph';
	require 'vm/vm_param.ph';
	require 'vm/pmap.ph';
	require 'sys/lock.ph';
	require 'vm/vm_map.ph';
    }
    unless(defined(&_SYS_RESOURCEVAR_H_)) {
	require 'sys/resourcevar.ph';
    }
    unless(defined(&_SYS_SIGNALVAR_H_)) {
	require 'sys/signalvar.ph';
    }
    eval 'sub WMESGLEN () {7;}' unless defined(&WMESGLEN);
    eval 'sub EPROC_CTTY () {0x01;}' unless defined(&EPROC_CTTY);
    eval 'sub EPROC_SLEADER () {0x02;}' unless defined(&EPROC_SLEADER);
    if(defined(&__i386__)) {
	eval 'sub U_ar0 () { ($u_kproc->{kp_proc}->{p_md}->{md_regs});}' unless defined(&U_ar0);
    }
    if(defined(&__alpha__)) {
	eval 'sub U_ar0 () { ($u_kproc->{kp_proc}->{p_md}->{md_tf});}' unless defined(&U_ar0);
    }
    eval 'sub U_tsize () { ($u_kproc->{kp_eproc}->{e_vm}->{vm_tsize});}' unless defined(&U_tsize);
    eval 'sub U_dsize () { ($u_kproc->{kp_eproc}->{e_vm}->{vm_dsize});}' unless defined(&U_dsize);
    eval 'sub U_ssize () { ($u_kproc->{kp_eproc}->{e_vm}->{vm_ssize});}' unless defined(&U_ssize);
    eval 'sub U_sig () { ($u_kproc->{kp_proc}->{p_sig});}' unless defined(&U_sig);
    eval 'sub U_code () { ($u_kproc->{kp_proc}->{p_code});}' unless defined(&U_code);
    unless(defined(&KERNEL)) {
	eval 'sub u_ar0 () { &U_ar0;}' unless defined(&u_ar0);
	eval 'sub u_tsize () { &U_tsize;}' unless defined(&u_tsize);
	eval 'sub u_dsize () { &U_dsize;}' unless defined(&u_dsize);
	eval 'sub u_ssize () { &U_ssize;}' unless defined(&u_ssize);
	eval 'sub u_sig () { &U_sig;}' unless defined(&u_sig);
	eval 'sub u_code () { &U_code;}' unless defined(&u_code);
    }
}
1;
