require '_h2ph_pre.ph';

unless(defined(&_VM_PAGE_)) {
    eval 'sub _VM_PAGE_ () {1;}' unless defined(&_VM_PAGE_);
    require 'opt_vmpage.ph';
    require 'vm/pmap.ph';
    require 'machine/atomic.ph';
    if((defined(&PAGE_SIZE) ? &PAGE_SIZE : 0) == 4096) {
    }
 elsif((defined(&PAGE_SIZE) ? &PAGE_SIZE : 0) == 8192) {
    }
    if(defined( &PQ_HUGECACHE)) {
	eval 'sub PQ_PRIME1 () {31;}' unless defined(&PQ_PRIME1);
	eval 'sub PQ_PRIME2 () {23;}' unless defined(&PQ_PRIME2);
	eval 'sub PQ_PRIME3 () {17;}' unless defined(&PQ_PRIME3);
	eval 'sub PQ_L2_SIZE () {256;}' unless defined(&PQ_L2_SIZE);
	eval 'sub PQ_L1_SIZE () {4;}' unless defined(&PQ_L1_SIZE);
    }
    if(defined( &PQ_LARGECACHE)) {
	eval 'sub PQ_PRIME1 () {31;}' unless defined(&PQ_PRIME1);
	eval 'sub PQ_PRIME2 () {23;}' unless defined(&PQ_PRIME2);
	eval 'sub PQ_PRIME3 () {17;}' unless defined(&PQ_PRIME3);
	eval 'sub PQ_L2_SIZE () {128;}' unless defined(&PQ_L2_SIZE);
	eval 'sub PQ_L1_SIZE () {4;}' unless defined(&PQ_L1_SIZE);
    }
    if(defined( &PQ_NOOPT)) {
	eval 'sub PQ_PRIME1 () {1;}' unless defined(&PQ_PRIME1);
	eval 'sub PQ_PRIME2 () {1;}' unless defined(&PQ_PRIME2);
	eval 'sub PQ_PRIME3 () {1;}' unless defined(&PQ_PRIME3);
	eval 'sub PQ_L2_SIZE () {1;}' unless defined(&PQ_L2_SIZE);
	eval 'sub PQ_L1_SIZE () {1;}' unless defined(&PQ_L1_SIZE);
    }
    if(defined( &PQ_NORMALCACHE)) {
	eval 'sub PQ_PRIME1 () {5;}' unless defined(&PQ_PRIME1);
	eval 'sub PQ_PRIME2 () {3;}' unless defined(&PQ_PRIME2);
	eval 'sub PQ_PRIME3 () {11;}' unless defined(&PQ_PRIME3);
	eval 'sub PQ_L2_SIZE () {16;}' unless defined(&PQ_L2_SIZE);
	eval 'sub PQ_L1_SIZE () {2;}' unless defined(&PQ_L1_SIZE);
    }
    if(defined( &PQ_MEDIUMCACHE) || !defined( &PQ_L2_SIZE)) {
	eval 'sub PQ_PRIME1 () {13;}' unless defined(&PQ_PRIME1);
	eval 'sub PQ_PRIME2 () {7;}' unless defined(&PQ_PRIME2);
	eval 'sub PQ_PRIME3 () {5;}' unless defined(&PQ_PRIME3);
	eval 'sub PQ_L2_SIZE () {64;}' unless defined(&PQ_L2_SIZE);
	eval 'sub PQ_L1_SIZE () {2;}' unless defined(&PQ_L1_SIZE);
    }
    eval 'sub PQ_L2_MASK () {( &PQ_L2_SIZE - 1);}' unless defined(&PQ_L2_MASK);
    eval 'sub PQ_NONE () {0;}' unless defined(&PQ_NONE);
    eval 'sub PQ_FREE () {1;}' unless defined(&PQ_FREE);
    eval 'sub PQ_ZERO () {(1+  &PQ_L2_SIZE);}' unless defined(&PQ_ZERO);
    eval 'sub PQ_INACTIVE () {(1+ 2* &PQ_L2_SIZE);}' unless defined(&PQ_INACTIVE);
    eval 'sub PQ_ACTIVE () {(2+ 2* &PQ_L2_SIZE);}' unless defined(&PQ_ACTIVE);
    eval 'sub PQ_CACHE () {(3+ 2* &PQ_L2_SIZE);}' unless defined(&PQ_CACHE);
    eval 'sub PQ_COUNT () {(3+ 3* &PQ_L2_SIZE);}' unless defined(&PQ_COUNT);
    eval 'sub PG_BUSY () {0x01;}' unless defined(&PG_BUSY);
    eval 'sub PG_WANTED () {0x02;}' unless defined(&PG_WANTED);
    eval 'sub PG_FICTITIOUS () {0x08;}' unless defined(&PG_FICTITIOUS);
    eval 'sub PG_WRITEABLE () {0x10;}' unless defined(&PG_WRITEABLE);
    eval 'sub PG_MAPPED () {0x20;}' unless defined(&PG_MAPPED);
    eval 'sub PG_ZERO () {0x40;}' unless defined(&PG_ZERO);
    eval 'sub PG_REFERENCED () {0x80;}' unless defined(&PG_REFERENCED);
    eval 'sub PG_CLEANCHK () {0x100;}' unless defined(&PG_CLEANCHK);
    eval 'sub ACT_DECLINE () {1;}' unless defined(&ACT_DECLINE);
    eval 'sub ACT_ADVANCE () {3;}' unless defined(&ACT_ADVANCE);
    eval 'sub ACT_INIT () {5;}' unless defined(&ACT_INIT);
    eval 'sub ACT_MAX () {64;}' unless defined(&ACT_MAX);
    eval 'sub PFCLUSTER_BEHIND () {3;}' unless defined(&PFCLUSTER_BEHIND);
    eval 'sub PFCLUSTER_AHEAD () {3;}' unless defined(&PFCLUSTER_AHEAD);
    if(defined(&KERNEL)) {
	eval 'sub VM_PAGE_TO_PHYS {
	    local($entry) = @_;
    	    eval q((($entry)-> &phys_addr));
	}' unless defined(&VM_PAGE_TO_PHYS);
	eval 'sub IS_VM_PHYSADDR {
	    local($pa) = @_;
    	    eval q((($pa) >=  &first_phys_addr  && ($pa) <=  &last_phys_addr));
	}' unless defined(&IS_VM_PHYSADDR);
	eval 'sub PHYS_TO_VM_PAGE {
	    local($pa) = @_;
    	    eval q(( $vm_page_array[ &atop($pa) -  &first_page ]));
	}' unless defined(&PHYS_TO_VM_PAGE);
	if(0) {
	}
	if((defined(&PAGE_SIZE) ? &PAGE_SIZE : 0) == 4096) {
	    eval 'sub VM_PAGE_BITS_ALL () {0xff;}' unless defined(&VM_PAGE_BITS_ALL);
	}
	if((defined(&PAGE_SIZE) ? &PAGE_SIZE : 0) == 8192) {
	    eval 'sub VM_PAGE_BITS_ALL () {0xffff;}' unless defined(&VM_PAGE_BITS_ALL);
	}
	eval 'sub VM_ALLOC_NORMAL () {0;}' unless defined(&VM_ALLOC_NORMAL);
	eval 'sub VM_ALLOC_INTERRUPT () {1;}' unless defined(&VM_ALLOC_INTERRUPT);
	eval 'sub VM_ALLOC_SYSTEM () {2;}' unless defined(&VM_ALLOC_SYSTEM);
	eval 'sub VM_ALLOC_ZERO () {3;}' unless defined(&VM_ALLOC_ZERO);
	eval 'sub VM_ALLOC_RETRY () {0x80;}' unless defined(&VM_ALLOC_RETRY);
    }
}
1;
