require '_h2ph_pre.ph';

unless(defined(&_VM_PARAM_)) {
    eval 'sub _VM_PARAM_ () {1;}' unless defined(&_VM_PARAM_);
    require 'machine/vmparam.ph';
    eval 'sub DEFAULT_PAGE_SIZE () {4096;}' unless defined(&DEFAULT_PAGE_SIZE);
    if(0) {
	unless(defined(&PAGE_SIZE)) {
	    eval 'sub PAGE_SIZE () { ($cnt->{v_page_size});}' unless defined(&PAGE_SIZE);
	}
	unless(defined(&PAGE_MASK)) {
	    eval 'sub PAGE_MASK () { &page_mask;}' unless defined(&PAGE_MASK);
	}
	unless(defined(&PAGE_SHIFT)) {
	    eval 'sub PAGE_SHIFT () { &page_shift;}' unless defined(&PAGE_SHIFT);
	}
    }
    if(defined(&KERNEL)) {
    }
    eval 'sub VM_METER () {1;}' unless defined(&VM_METER);
    eval 'sub VM_LOADAVG () {2;}' unless defined(&VM_LOADAVG);
    eval 'sub VM_V_FREE_MIN () {3;}' unless defined(&VM_V_FREE_MIN);
    eval 'sub VM_V_FREE_TARGET () {4;}' unless defined(&VM_V_FREE_TARGET);
    eval 'sub VM_V_FREE_RESERVED () {5;}' unless defined(&VM_V_FREE_RESERVED);
    eval 'sub VM_V_INACTIVE_TARGET () {6;}' unless defined(&VM_V_INACTIVE_TARGET);
    eval 'sub VM_V_CACHE_MIN () {7;}' unless defined(&VM_V_CACHE_MIN);
    eval 'sub VM_V_CACHE_MAX () {8;}' unless defined(&VM_V_CACHE_MAX);
    eval 'sub VM_V_PAGEOUT_FREE_MIN () {9;}' unless defined(&VM_V_PAGEOUT_FREE_MIN);
    eval 'sub VM_PAGEOUT_ALGORITHM () {10;}' unless defined(&VM_PAGEOUT_ALGORITHM);
    eval 'sub VM_SWAPPING_ENABLED () {11;}' unless defined(&VM_SWAPPING_ENABLED);
    eval 'sub VM_MAXID () {12;}' unless defined(&VM_MAXID);
    eval 'sub CTL_VM_NAMES () {{ { 0, 0}, { "vmmeter",  &CTLTYPE_STRUCT }, { "loadavg",  &CTLTYPE_STRUCT }, { "v_free_min",  &CTLTYPE_INT }, { "v_free_target",  &CTLTYPE_INT }, { "v_free_reserved",  &CTLTYPE_INT }, { "v_inactive_target",  &CTLTYPE_INT }, { "v_cache_min",  &CTLTYPE_INT }, { "v_cache_max",  &CTLTYPE_INT }, { "v_pageout_free_min",  &CTLTYPE_INT}, { "pageout_algorithm",  &CTLTYPE_INT}, { "swapping_enabled",  &CTLTYPE_INT},};}' unless defined(&CTL_VM_NAMES);
    eval 'sub KERN_SUCCESS () {0;}' unless defined(&KERN_SUCCESS);
    eval 'sub KERN_INVALID_ADDRESS () {1;}' unless defined(&KERN_INVALID_ADDRESS);
    eval 'sub KERN_PROTECTION_FAILURE () {2;}' unless defined(&KERN_PROTECTION_FAILURE);
    eval 'sub KERN_NO_SPACE () {3;}' unless defined(&KERN_NO_SPACE);
    eval 'sub KERN_INVALID_ARGUMENT () {4;}' unless defined(&KERN_INVALID_ARGUMENT);
    eval 'sub KERN_FAILURE () {5;}' unless defined(&KERN_FAILURE);
    eval 'sub KERN_RESOURCE_SHORTAGE () {6;}' unless defined(&KERN_RESOURCE_SHORTAGE);
    eval 'sub KERN_NOT_RECEIVER () {7;}' unless defined(&KERN_NOT_RECEIVER);
    eval 'sub KERN_NO_ACCESS () {8;}' unless defined(&KERN_NO_ACCESS);
    unless(defined(&ASSEMBLER)) {
	if(defined(&KERNEL)) {
	    eval 'sub num_pages {
	        local($x) = @_;
    		eval q(((((($x)) +  &PAGE_MASK) >>  &PAGE_SHIFT)));
	    }' unless defined(&num_pages);
	}
    }
}
1;
