require '_h2ph_pre.ph';

unless(defined(&_MACHINE_ENDIAN_H_)) {
    eval 'sub _MACHINE_ENDIAN_H_ () {1;}' unless defined(&_MACHINE_ENDIAN_H_);
    eval 'sub _QUAD_HIGHWORD () {1;}' unless defined(&_QUAD_HIGHWORD);
    eval 'sub _QUAD_LOWWORD () {0;}' unless defined(&_QUAD_LOWWORD);
    unless(defined(&_POSIX_SOURCE)) {
	eval 'sub LITTLE_ENDIAN () {1234;}' unless defined(&LITTLE_ENDIAN);
	eval 'sub BIG_ENDIAN () {4321;}' unless defined(&BIG_ENDIAN);
	eval 'sub PDP_ENDIAN () {3412;}' unless defined(&PDP_ENDIAN);
	eval 'sub BYTE_ORDER () { &LITTLE_ENDIAN;}' unless defined(&BYTE_ORDER);
	unless(defined(&KERNEL)) {
	    require 'sys/cdefs.ph';
	}
	eval 'sub __word_swap_long {
	    local($x) = @_;
    	    eval q( &__extension__ ({  &register \'u_long __X\' = ($x);  &__asm (\\"rorl $16, %1\\" : \\"=r\\" ( &__X) : \\"0\\" ( &__X));  &__X; }));
	}' unless defined(&__word_swap_long);
	if(defined( &KERNEL)  && (defined( &I486_CPU) || defined( &I586_CPU) || defined( &I686_CPU))  && !defined( &I386_CPU)) {
	    eval 'sub __byte_swap_long {
	        local($x) = @_;
    		eval q( &__extension__ ({  &register \'u_long __X\' = ($x);  &__asm (\\"bswap %0\\" : \\"=r\\" ( &__X) : \\"0\\" ( &__X));  &__X; }));
	    }' unless defined(&__byte_swap_long);
	} else {
	    eval 'sub __byte_swap_long {
	        local($x) = @_;
    		eval q( &__extension__ ({  &register \'u_long __X\' = ($x);  &__asm (\\"xchgb %h1, %b1\\\\n\\\\trorl $16, %1\\\\n\\\\txchgb %h1, %b1\\" : \\"=q\\" ( &__X) : \\"0\\" ( &__X));  &__X; }));
	    }' unless defined(&__byte_swap_long);
	}
	eval 'sub __byte_swap_word {
	    local($x) = @_;
    	    eval q( &__extension__ ({  &register \'u_short __X\' = ($x);  &__asm (\\"xchgb %h1, %b1\\" : \\"=q\\" ( &__X) : \\"0\\" ( &__X));  &__X; }));
	}' unless defined(&__byte_swap_word);
	if(defined(&__GNUC__)) {
	    eval 'sub ntohl () {\'__byte_swap_long\';}' unless defined(&ntohl);
	    eval 'sub ntohs () { &__byte_swap_word;}' unless defined(&ntohs);
	    eval 'sub htonl () {\'__byte_swap_long\';}' unless defined(&htonl);
	    eval 'sub htons () { &__byte_swap_word;}' unless defined(&htons);
	}
	eval 'sub NTOHL {
	    local($x) = @_;
    	    eval q(( =  &ntohl(($x))));
	}' unless defined(&NTOHL);
	eval 'sub NTOHS {
	    local($x) = @_;
    	    eval q(( =  &ntohs(($x))));
	}' unless defined(&NTOHS);
	eval 'sub HTONL {
	    local($x) = @_;
    	    eval q(( =  &htonl(($x))));
	}' unless defined(&HTONL);
	eval 'sub HTONS {
	    local($x) = @_;
    	    eval q(( =  &htons(($x))));
	}' unless defined(&HTONS);
    }
}
1;
