require '_h2ph_pre.ph';

unless(defined(&_MACHINE_SMPTESTS_H_)) {
    eval 'sub _MACHINE_SMPTESTS_H_ () {1;}' unless defined(&_MACHINE_SMPTESTS_H_);
    eval 'sub BETTER_CLOCK () {1;}' unless defined(&BETTER_CLOCK);
    eval 'sub PUSHDOWN_LEVEL_1 () {1;}' unless defined(&PUSHDOWN_LEVEL_1);
    eval 'sub PUSHDOWN_LEVEL_2 () {1;}' unless defined(&PUSHDOWN_LEVEL_2);
    eval 'sub PUSHDOWN_LEVEL_3_NOT () {1;}' unless defined(&PUSHDOWN_LEVEL_3_NOT);
    eval 'sub PUSHDOWN_LEVEL_4_NOT () {1;}' unless defined(&PUSHDOWN_LEVEL_4_NOT);
    if(defined(&PUSHDOWN_LEVEL_2)) {
	eval 'sub REAL_ECPL () {1;}' unless defined(&REAL_ECPL);
	eval 'sub REAL_ICPL () {1;}' unless defined(&REAL_ICPL);
	eval 'sub REAL_AICPL () {1;}' unless defined(&REAL_AICPL);
	eval 'sub REAL_AVCPL () {1;}' unless defined(&REAL_AVCPL);
	eval 'sub REAL_IFCPL () {1;}' unless defined(&REAL_IFCPL);
    }
    if(defined(&REAL_ECPL)) {
	eval 'sub ECPL_LOCK () { &SCPL_LOCK;}' unless defined(&ECPL_LOCK);
	eval 'sub ECPL_UNLOCK () { &SCPL_UNLOCK;}' unless defined(&ECPL_UNLOCK);
    } else {
	eval 'sub ECPL_LOCK () {1;}' unless defined(&ECPL_LOCK);
	eval 'sub ECPL_UNLOCK () {1;}' unless defined(&ECPL_UNLOCK);
    }
    if(defined(&REAL_ICPL)) {
	eval 'sub ICPL_LOCK () { &CPL_LOCK;}' unless defined(&ICPL_LOCK);
	eval 'sub ICPL_UNLOCK () { &CPL_UNLOCK;}' unless defined(&ICPL_UNLOCK);
	eval 'sub FAST_ICPL_UNLOCK () { &movl $0,  &_cpl_lock;}' unless defined(&FAST_ICPL_UNLOCK);
    } else {
	eval 'sub ICPL_LOCK () {1;}' unless defined(&ICPL_LOCK);
	eval 'sub ICPL_UNLOCK () {1;}' unless defined(&ICPL_UNLOCK);
	eval 'sub FAST_ICPL_UNLOCK () {1;}' unless defined(&FAST_ICPL_UNLOCK);
    }
    if(defined(&REAL_AICPL)) {
	eval 'sub AICPL_LOCK () { &SCPL_LOCK;}' unless defined(&AICPL_LOCK);
	eval 'sub AICPL_UNLOCK () { &SCPL_UNLOCK;}' unless defined(&AICPL_UNLOCK);
    } else {
	eval 'sub AICPL_LOCK () {1;}' unless defined(&AICPL_LOCK);
	eval 'sub AICPL_UNLOCK () {1;}' unless defined(&AICPL_UNLOCK);
    }
    if(defined(&REAL_AVCPL)) {
	eval 'sub AVCPL_LOCK () { &CPL_LOCK;}' unless defined(&AVCPL_LOCK);
	eval 'sub AVCPL_UNLOCK () { &CPL_UNLOCK;}' unless defined(&AVCPL_UNLOCK);
    } else {
	eval 'sub AVCPL_LOCK () {1;}' unless defined(&AVCPL_LOCK);
	eval 'sub AVCPL_UNLOCK () {1;}' unless defined(&AVCPL_UNLOCK);
    }
    if(defined(&REAL_IFCPL)) {
	eval 'sub IFCPL_LOCK () {
	    eval q( &SCPL_LOCK());
	}' unless defined(&IFCPL_LOCK);
	eval 'sub IFCPL_UNLOCK () {
	    eval q( &SCPL_UNLOCK());
	}' unless defined(&IFCPL_UNLOCK);
    } else {
	eval 'sub IFCPL_LOCK () {
	    eval q();
	}' unless defined(&IFCPL_LOCK);
	eval 'sub IFCPL_UNLOCK () {
	    eval q();
	}' unless defined(&IFCPL_UNLOCK);
    }
    eval 'sub SL_DEBUG () {1;}' unless defined(&SL_DEBUG);
    if(defined(&PUSHDOWN_LEVEL_1)) {
	eval 'sub FAST_HI () {1;}' unless defined(&FAST_HI);
    }
    if(defined(&PUSHDOWN_LEVEL_1)) {
	eval 'sub USE_MPINTRLOCK () {1;}' unless defined(&USE_MPINTRLOCK);
	eval 'sub USE_COMLOCK () {1;}' unless defined(&USE_COMLOCK);
	eval 'sub USE_CLOCKLOCK () {1;}' unless defined(&USE_CLOCKLOCK);
    }
    if(defined(&PUSHDOWN_LEVEL_4)) {
	eval 'sub INTR_SIMPLELOCK () {1;}' unless defined(&INTR_SIMPLELOCK);
    }
    if(defined(&PUSHDOWN_LEVEL_3)) {
	eval 'sub CPL_AND_CML () {1;}' unless defined(&CPL_AND_CML);
    }
    if(defined(&PUSHDOWN_LEVEL_3)) {
	eval 'sub INTR_SPL () {1;}' unless defined(&INTR_SPL);
	eval 'sub SPL_DEBUG () {1;}' unless defined(&SPL_DEBUG);
    }
    if(defined(&PUSHDOWN_LEVEL_1)) {
	eval 'sub FAST_WITHOUTCPL () {1;}' unless defined(&FAST_WITHOUTCPL);
    }
    if(defined(&PUSHDOWN_LEVEL_1)) {
	eval 'sub FAST_SIMPLELOCK () {1;}' unless defined(&FAST_SIMPLELOCK);
    }
    eval 'sub GRAB_LOPRIO () {1;}' unless defined(&GRAB_LOPRIO);
    eval 'sub CPUSTOP_ON_DDBBREAK () {1;}' unless defined(&CPUSTOP_ON_DDBBREAK);
    eval 'sub GIANT_LOCK () {1;}' unless defined(&GIANT_LOCK);
    if(defined(&APIC_IO)) {
	undef(&APIC_INTR_DIAGNOSTIC) if defined(&APIC_INTR_DIAGNOSTIC);
	if(defined(&APIC_INTR_DIAGNOSTIC)) {
	    eval 'sub APIC_INTR_DIAGNOSTIC_IRQ () {17;}' unless defined(&APIC_INTR_DIAGNOSTIC_IRQ);
	}
	eval 'sub APIC_INTR_REORDER () {1;}' unless defined(&APIC_INTR_REORDER);
	eval 'sub APIC_INTR_HIGHPRI_CLOCK () {1;}' unless defined(&APIC_INTR_HIGHPRI_CLOCK);
    }
    if(defined(&POST_ADDR)) {
	eval 'sub ASMPOSTCODE_INC () { &pushl % &eax ;  &movl  &_current_postcode, % &eax ;  &incl % &eax ;  &andl $0xff, % &eax ;  &movl % &eax,  &_current_postcode ;  &outb % &al, $ &POST_ADDR ;  &popl % &eax;}' unless defined(&ASMPOSTCODE_INC);
	eval 'sub ASMPOSTCODE {
	    local($X) = @_;
    	    eval q( &pushl % &eax ;  &movl $$X, % &eax ;  &movl % &eax,  &_current_postcode ;  &outb % &al, $ &POST_ADDR ;  &popl % &eax);
	}' unless defined(&ASMPOSTCODE);
	eval 'sub ASMPOSTCODE_LO {
	    local($X) = @_;
    	    eval q( &pushl % &eax ;  &movl  &_current_postcode, % &eax ;  &andl $0xf0, % &eax ;  &orl $$X, % &eax ;  &movl % &eax,  &_current_postcode ;  &outb % &al, $ &POST_ADDR ;  &popl % &eax);
	}' unless defined(&ASMPOSTCODE_LO);
	eval 'sub ASMPOSTCODE_HI {
	    local($X) = @_;
    	    eval q( &pushl % &eax ;  &movl  &_current_postcode, % &eax ;  &andl $0x0f, % &eax ;  &orl $($X<<4), % &eax ;  &movl % &eax,  &_current_postcode ;  &outb % &al, $ &POST_ADDR ;  &popl % &eax);
	}' unless defined(&ASMPOSTCODE_HI);
    } else {
	eval 'sub ASMPOSTCODE_INC () {1;}' unless defined(&ASMPOSTCODE_INC);
	eval 'sub ASMPOSTCODE {
	    local($X) = @_;
    	    eval q();
	}' unless defined(&ASMPOSTCODE);
	eval 'sub ASMPOSTCODE_LO {
	    local($X) = @_;
    	    eval q();
	}' unless defined(&ASMPOSTCODE_LO);
	eval 'sub ASMPOSTCODE_HI {
	    local($X) = @_;
    	    eval q();
	}' unless defined(&ASMPOSTCODE_HI);
    }
    if(defined(&GUARD_INTS)) {
	eval 'sub GUARD_CPU () {1;}' unless defined(&GUARD_CPU);
	eval 'sub MAYBE_PANIC {
	    local($irq_num) = @_;
    	    eval q( &cmpl $ &GUARD_CPU,  &_cpuid ;  &jne 9 &f ;  &cmpl $1,  &_ok_test1 ;  &jne 9 &f ;  &pushl  &lapic_isr3 ;  &pushl  &lapic_isr2 ;  &pushl  &lapic_isr1 ;  &pushl  &lapic_isr0 ;  &pushl  &lapic_irr3 ;  &pushl  &lapic_irr2 ;  &pushl  &lapic_irr1 ;  &pushl  &lapic_irr0 ;  &pushl $$irq_num ;  &pushl  &_cpuid ;  &pushl $ &panic_msg ;  &call  &_printf ;  &addl $44, % &esp ; 9:);
	}' unless defined(&MAYBE_PANIC);
    } else {
	eval 'sub MAYBE_PANIC {
	    local($irq_num) = @_;
    	    eval q();
	}' unless defined(&MAYBE_PANIC);
    }
}
1;
