require '_h2ph_pre.ph';

unless(defined(&SLOT_EMPTY)) {
    sub SLOT_EMPTY () {	0x00;}
}
unless(defined(&SLOT_E5)) {
    sub SLOT_E5 () {	0x05;}
}
unless(defined(&SLOT_DELETED)) {
    sub SLOT_DELETED () {	0xe5;}
}
unless(defined(&ATTR_NORMAL)) {
    sub ATTR_NORMAL () {	0x00;}
}
unless(defined(&ATTR_READONLY)) {
    sub ATTR_READONLY () {	0x01;}
}
unless(defined(&ATTR_HIDDEN)) {
    sub ATTR_HIDDEN () {	0x02;}
}
unless(defined(&ATTR_SYSTEM)) {
    sub ATTR_SYSTEM () {	0x04;}
}
unless(defined(&ATTR_VOLUME)) {
    sub ATTR_VOLUME () {	0x08;}
}
unless(defined(&ATTR_DIRECTORY)) {
    sub ATTR_DIRECTORY () {	0x10;}
}
unless(defined(&ATTR_ARCHIVE)) {
    sub ATTR_ARCHIVE () {	0x20;}
}
unless(defined(&LCASE_BASE)) {
    sub LCASE_BASE () {	0x08;}
}
unless(defined(&LCASE_EXT)) {
    sub LCASE_EXT () {	0x10;}
}
unless(defined(&WIN_LAST)) {
    sub WIN_LAST () {	0x40;}
}
unless(defined(&WIN_CNT)) {
    sub WIN_CNT () {	0x3f;}
}
unless(defined(&ATTR_WIN95)) {
    sub ATTR_WIN95 () {	0x0f;}
}
unless(defined(&WIN_CHARS)) {
    sub WIN_CHARS () {	13;}
}
unless(defined(&WIN_MAXLEN)) {
    sub WIN_MAXLEN () {	255;}
}
unless(defined(&DT_2SECONDS_MASK)) {
    sub DT_2SECONDS_MASK () {	0x1f;}
}
unless(defined(&DT_2SECONDS_SHIFT)) {
    sub DT_2SECONDS_SHIFT () {	0;}
}
unless(defined(&DT_MINUTES_MASK)) {
    sub DT_MINUTES_MASK () {	0x7e0;}
}
unless(defined(&DT_MINUTES_SHIFT)) {
    sub DT_MINUTES_SHIFT () {	5;}
}
unless(defined(&DT_HOURS_MASK)) {
    sub DT_HOURS_MASK () {	0xf800;}
}
unless(defined(&DT_HOURS_SHIFT)) {
    sub DT_HOURS_SHIFT () {	11;}
}
unless(defined(&DD_DAY_MASK)) {
    sub DD_DAY_MASK () {	0x1f;}
}
unless(defined(&DD_DAY_SHIFT)) {
    sub DD_DAY_SHIFT () {	0;}
}
unless(defined(&DD_MONTH_MASK)) {
    sub DD_MONTH_MASK () {	0x1e0;}
}
unless(defined(&DD_MONTH_SHIFT)) {
    sub DD_MONTH_SHIFT () {	5;}
}
unless(defined(&DD_YEAR_MASK)) {
    sub DD_YEAR_MASK () {	0xfe00;}
}
unless(defined(&DD_YEAR_SHIFT)) {
    sub DD_YEAR_SHIFT () {	9;}
}
if(defined(&KERNEL)) {
}
1;
