require '_h2ph_pre.ph';

unless(defined(&_MSDOSFS_MSDOSFSMOUNT_H_)) {
    eval 'sub _MSDOSFS_MSDOSFSMOUNT_H_ () {1;}' unless defined(&_MSDOSFS_MSDOSFSMOUNT_H_);
    if(defined(&KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
	eval 'sub FATOFS {
	    local($pmp, $cn) = @_;
    	    eval q((($cn) * ($pmp)-> &pm_fatmult / ($pmp)-> &pm_fatdiv));
	}' unless defined(&FATOFS);
	eval 'sub VFSTOMSDOSFS {
	    local($mp) = @_;
    	    eval q(( ($mp->{mnt_data})));
	}' unless defined(&VFSTOMSDOSFS);
	eval 'sub N_INUSEBITS () {(8* $sizeof{\'u_int\'});}' unless defined(&N_INUSEBITS);
	eval 'sub pm_BytesPerSec () { ($pm_bpb->{bpbBytesPerSec});}' unless defined(&pm_BytesPerSec);
	eval 'sub pm_ResSectors () { ($pm_bpb->{bpbResSectors});}' unless defined(&pm_ResSectors);
	eval 'sub pm_FATs () { ($pm_bpb->{bpbFATs});}' unless defined(&pm_FATs);
	eval 'sub pm_RootDirEnts () { ($pm_bpb->{bpbRootDirEnts});}' unless defined(&pm_RootDirEnts);
	eval 'sub pm_Sectors () { ($pm_bpb->{bpbSectors});}' unless defined(&pm_Sectors);
	eval 'sub pm_Media () { ($pm_bpb->{bpbMedia});}' unless defined(&pm_Media);
	eval 'sub pm_SecPerTrack () { ($pm_bpb->{bpbSecPerTrack});}' unless defined(&pm_SecPerTrack);
	eval 'sub pm_Heads () { ($pm_bpb->{bpbHeads});}' unless defined(&pm_Heads);
	eval 'sub pm_HiddenSects () { ($pm_bpb->{bpbHiddenSecs});}' unless defined(&pm_HiddenSects);
	eval 'sub pm_HugeSectors () { ($pm_bpb->{bpbHugeSectors});}' unless defined(&pm_HugeSectors);
	eval 'sub bptoep {
	    local($pmp, $bp, $dirofs) = @_;
    	    eval q((((($bp)-> &b_data) + (($dirofs) & ($pmp)-> &pm_crbomask))));
	}' unless defined(&bptoep);
	eval 'sub de_bn2cn {
	    local($pmp, $bn) = @_;
    	    eval q((($bn) >> (($pmp)-> &pm_cnshift - ($pmp)-> &pm_bnshift)));
	}' unless defined(&de_bn2cn);
	eval 'sub de_cn2bn {
	    local($pmp, $cn) = @_;
    	    eval q((($cn) << (($pmp)-> &pm_cnshift - ($pmp)-> &pm_bnshift)));
	}' unless defined(&de_cn2bn);
	eval 'sub de_cluster {
	    local($pmp, $off) = @_;
    	    eval q((($off) >> ($pmp)-> &pm_cnshift));
	}' unless defined(&de_cluster);
	eval 'sub de_clcount {
	    local($pmp, $size) = @_;
    	    eval q(((($size) + ($pmp)-> &pm_bpcluster - 1) >> ($pmp)-> &pm_cnshift));
	}' unless defined(&de_clcount);
	eval 'sub de_blk {
	    local($pmp, $off) = @_;
    	    eval q(( &de_cn2bn($pmp,  &de_cluster(($pmp), ($off)))));
	}' unless defined(&de_blk);
	eval 'sub de_cn2off {
	    local($pmp, $cn) = @_;
    	    eval q((($cn) << ($pmp)-> &pm_cnshift));
	}' unless defined(&de_cn2off);
	eval 'sub de_bn2off {
	    local($pmp, $bn) = @_;
    	    eval q((($bn) << ($pmp)-> &pm_bnshift));
	}' unless defined(&de_bn2off);
	eval 'sub cntobn {
	    local($pmp, $cn) = @_;
    	    eval q(( &de_cn2bn(($pmp), ($cn)- &CLUST_FIRST) + ($pmp)-> &pm_firstcluster));
	}' unless defined(&cntobn);
	eval 'sub roottobn {
	    local($pmp, $dirofs) = @_;
    	    eval q(( &de_blk(($pmp), ($dirofs)) + ($pmp)-> &pm_rootdirblk));
	}' unless defined(&roottobn);
	eval 'sub detobn {
	    local($pmp, $dirclu, $dirofs) = @_;
    	    eval q((($dirclu) ==  &MSDOSFSROOT ?  &roottobn(($pmp), ($dirofs)) :  &cntobn(($pmp), ($dirclu))));
	}' unless defined(&detobn);
	eval 'sub fsi_size {
	    local($pmp) = @_;
    	    eval q((1024<< (($pmp)-> &pm_BlkPerSec >> 2)));
	}' unless defined(&fsi_size);
    }
    eval 'sub MSDOSFSMNT_SHORTNAME () {1;}' unless defined(&MSDOSFSMNT_SHORTNAME);
    eval 'sub MSDOSFSMNT_LONGNAME () {2;}' unless defined(&MSDOSFSMNT_LONGNAME);
    eval 'sub MSDOSFSMNT_NOWIN95 () {4;}' unless defined(&MSDOSFSMNT_NOWIN95);
    unless(defined(&__FreeBSD__)) {
	eval 'sub MSDOSFSMNT_GEMDOSFS () {8;}' unless defined(&MSDOSFSMNT_GEMDOSFS);
    }
    eval 'sub MSDOSFSMNT_U2WTABLE () {0x10;}' unless defined(&MSDOSFSMNT_U2WTABLE);
    eval 'sub MSDOSFSMNT_ULTABLE () {0x20;}' unless defined(&MSDOSFSMNT_ULTABLE);
    eval 'sub MSDOSFSMNT_MNTOPT () {( &MSDOSFSMNT_SHORTNAME| &MSDOSFSMNT_LONGNAME| &MSDOSFSMNT_NOWIN95 | &MSDOSFSMNT_U2WTABLE| &MSDOSFSMNT_ULTABLE);}' unless defined(&MSDOSFSMNT_MNTOPT);
    eval 'sub MSDOSFSMNT_RONLY () {0x80000000;}' unless defined(&MSDOSFSMNT_RONLY);
    eval 'sub MSDOSFSMNT_WAITONFAT () {0x40000000;}' unless defined(&MSDOSFSMNT_WAITONFAT);
    eval 'sub MSDOSFS_FATMIRROR () {0x20000000;}' unless defined(&MSDOSFS_FATMIRROR);
    eval 'sub MSDOSFS_ARGSMAGIC () {0xe4eff300;}' unless defined(&MSDOSFS_ARGSMAGIC);
}
1;
