require '_h2ph_pre.ph';

unless(defined(&BDG_MAX_PORTS)) {
    sub BDG_MAX_PORTS () {	128;}
}
unless(defined(&HASH_SIZE)) {
    sub HASH_SIZE () {	8192;}
}
unless(defined(&HASH_FN)) {
    sub HASH_FN {
	local($addr) = @_;
	eval q((  &ntohs( [1] ^ ($addr)[2] ) & ( &HASH_SIZE -1)));
    }
}
if(defined(&__i386__)) {
    eval 'sub BDG_MATCH {
        local($a,$b) = @_;
	    eval q(( ()[2] == ()[2]  && *() == *(($b)) ));
    }' unless defined(&BDG_MATCH);
    eval 'sub IS_ETHER_BROADCAST {
        local($a) = @_;
	    eval q(( *() == 0xffffffff  && (($a))[2] == 0xffff ));
    }' unless defined(&IS_ETHER_BROADCAST);
} else {
    eval 'sub BDG_MATCH {
        local($a,$b) = @_;
	    eval q((! &bcmp($a, $b,  &ETHER_ADDR_LEN) ));
    }' unless defined(&BDG_MATCH);
}
unless(defined(&BDG_BCAST)) {
    sub BDG_BCAST () {	( 1);}
}
unless(defined(&BDG_MCAST)) {
    sub BDG_MCAST () {	( 2);}
}
unless(defined(&BDG_LOCAL)) {
    sub BDG_LOCAL () {	( 3);}
}
unless(defined(&BDG_DROP)) {
    sub BDG_DROP () {	( 4);}
}
unless(defined(&BDG_UNKNOWN)) {
    sub BDG_UNKNOWN () {	( 5);}
}
unless(defined(&BDG_IN)) {
    sub BDG_IN () {	( 7);}
}
unless(defined(&BDG_OUT)) {
    sub BDG_OUT () {	( 8);}
}
unless(defined(&BDG_FORWARD)) {
    sub BDG_FORWARD () {	( 9);}
}
unless(defined(&PF_BDG)) {
    sub PF_BDG () {	3;}
}
unless(defined(&STAT_MAX)) {
    sub STAT_MAX () {	 &BDG_FORWARD;}
}
unless(defined(&BDG_STAT)) {
    sub BDG_STAT {
	local($ifp, $type) = @_;
	eval q( ($bdg_stats->{s[&ifp}->{if_index]}->{p_in[$type]})++);
    }
}
if(defined(&KERNEL)) {
}
1;
