require '_h2ph_pre.ph';

unless(defined(&_NET_ETHERNET_H_)) {
    eval 'sub _NET_ETHERNET_H_ () {1;}' unless defined(&_NET_ETHERNET_H_);
    eval 'sub ETHER_ADDR_LEN () {6;}' unless defined(&ETHER_ADDR_LEN);
    eval 'sub ETHER_TYPE_LEN () {2;}' unless defined(&ETHER_TYPE_LEN);
    eval 'sub ETHER_CRC_LEN () {4;}' unless defined(&ETHER_CRC_LEN);
    eval 'sub ETHER_HDR_LEN () {( &ETHER_ADDR_LEN*2+ &ETHER_TYPE_LEN);}' unless defined(&ETHER_HDR_LEN);
    eval 'sub ETHER_MIN_LEN () {64;}' unless defined(&ETHER_MIN_LEN);
    eval 'sub ETHER_MAX_LEN () {1518;}' unless defined(&ETHER_MAX_LEN);
    eval 'sub ETHER_IS_VALID_LEN {
        local($foo) = @_;
	    eval q((($foo) >=  &ETHER_MIN_LEN  && ($foo) <=  &ETHER_MAX_LEN));
    }' unless defined(&ETHER_IS_VALID_LEN);
    eval 'sub ETHERTYPE_PUP () {0x0200;}' unless defined(&ETHERTYPE_PUP);
    eval 'sub ETHERTYPE_IP () {0x0800;}' unless defined(&ETHERTYPE_IP);
    eval 'sub ETHERTYPE_ARP () {0x0806;}' unless defined(&ETHERTYPE_ARP);
    eval 'sub ETHERTYPE_REVARP () {0x8035;}' unless defined(&ETHERTYPE_REVARP);
    eval 'sub ETHERTYPE_VLAN () {0x8100;}' unless defined(&ETHERTYPE_VLAN);
    eval 'sub ETHERTYPE_LOOPBACK () {0x9000;}' unless defined(&ETHERTYPE_LOOPBACK);
    eval 'sub ETHERTYPE_TRAIL () {0x1000;}' unless defined(&ETHERTYPE_TRAIL);
    eval 'sub ETHERTYPE_NTRAILER () {16;}' unless defined(&ETHERTYPE_NTRAILER);
    eval 'sub ETHERMTU () {( &ETHER_MAX_LEN- &ETHER_HDR_LEN- &ETHER_CRC_LEN);}' unless defined(&ETHERMTU);
    eval 'sub ETHERMIN () {( &ETHER_MIN_LEN- &ETHER_HDR_LEN- &ETHER_CRC_LEN);}' unless defined(&ETHERMIN);
    unless(defined(&KERNEL)) {
	require 'sys/cdefs.ph';
    }
}
1;
