require '_h2ph_pre.ph';

unless(defined(&_NETATM_ATM_IF_H)) {
    eval 'sub _NETATM_ATM_IF_H () {1;}' unless defined(&_NETATM_ATM_IF_H);
    eval 'sub ATM_NIF_MTU () {9180;}' unless defined(&ATM_NIF_MTU);
    eval 'sub ATM_PCR_TAXI100 () {227273;}' unless defined(&ATM_PCR_TAXI100);
    eval 'sub ATM_PCR_TAXI140 () {318181;}' unless defined(&ATM_PCR_TAXI140);
    eval 'sub ATM_PCR_OC3C () {353207;}' unless defined(&ATM_PCR_OC3C);
    eval 'sub ATM_PCR_OC12C () {1416905;}' unless defined(&ATM_PCR_OC12C);
    eval("sub VENDOR_UNKNOWN () { 0; }") unless defined(&VENDOR_UNKNOWN);
    eval("sub VENDOR_FORE () { 1; }") unless defined(&VENDOR_FORE);
    eval("sub VENDOR_ENI () { 2; }") unless defined(&VENDOR_ENI);
    eval("sub VENDAPI_UNKNOWN () { 0; }") unless defined(&VENDAPI_UNKNOWN);
    eval("sub VENDAPI_FORE_1 () { 1; }") unless defined(&VENDAPI_FORE_1);
    eval("sub VENDAPI_ENI_1 () { 2; }") unless defined(&VENDAPI_ENI_1);
    eval("sub DEV_UNKNOWN () { 0; }") unless defined(&DEV_UNKNOWN);
    eval("sub DEV_FORE_SBA200E () { 1; }") unless defined(&DEV_FORE_SBA200E);
    eval("sub DEV_FORE_SBA200 () { 2; }") unless defined(&DEV_FORE_SBA200);
    eval("sub DEV_FORE_PCA200E () { 3; }") unless defined(&DEV_FORE_PCA200E);
    eval("sub DEV_ENI_155P () { 4; }") unless defined(&DEV_ENI_155P);
    eval("sub MEDIA_UNKNOWN () { 0; }") unless defined(&MEDIA_UNKNOWN);
    eval("sub MEDIA_TAXI_100 () { 1; }") unless defined(&MEDIA_TAXI_100);
    eval("sub MEDIA_TAXI_140 () { 2; }") unless defined(&MEDIA_TAXI_140);
    eval("sub MEDIA_OC3C () { 3; }") unless defined(&MEDIA_OC3C);
    eval("sub MEDIA_OC12C () { 4; }") unless defined(&MEDIA_OC12C);
    eval("sub MEDIA_UTP155 () { 5; }") unless defined(&MEDIA_UTP155);
    eval("sub BUS_UNKNOWN () { 0; }") unless defined(&BUS_UNKNOWN);
    eval("sub BUS_SBUS_B16 () { 1; }") unless defined(&BUS_SBUS_B16);
    eval("sub BUS_SBUS_B32 () { 2; }") unless defined(&BUS_SBUS_B32);
    eval("sub BUS_PCI () { 3; }") unless defined(&BUS_PCI);
    eval 'sub VERSION_LEN () {16;}' unless defined(&VERSION_LEN);
    if(defined(&ATM_KERNEL)) {
	eval 'sub PIF_UP () {0x01;}' unless defined(&PIF_UP);
	eval 'sub PIF_LOOPBACK () {0x02;}' unless defined(&PIF_LOOPBACK);
	eval 'sub CVS_FREE () {0;}' unless defined(&CVS_FREE);
	eval 'sub CVS_INST () {1;}' unless defined(&CVS_INST);
	eval 'sub CVS_INITED () {2;}' unless defined(&CVS_INITED);
	eval 'sub CVS_ACTIVE () {3;}' unless defined(&CVS_ACTIVE);
	eval 'sub CVS_PTERM () {4;}' unless defined(&CVS_PTERM);
	eval 'sub CVS_TERM () {5;}' unless defined(&CVS_TERM);
	eval 'sub CVF_RSVD () {0x0f;}' unless defined(&CVF_RSVD);
	eval 'sub CUF_REGISTER () {0x01;}' unless defined(&CUF_REGISTER);
	eval 'sub CUF_INITED () {0x02;}' unless defined(&CUF_INITED);
	eval 'sub NCM_ATTACH () {1;}' unless defined(&NCM_ATTACH);
	eval 'sub NCM_DETACH () {2;}' unless defined(&NCM_DETACH);
	eval 'sub NCM_SETADDR () {3;}' unless defined(&NCM_SETADDR);
	eval 'sub NCM_SIGATTACH () {4;}' unless defined(&NCM_SIGATTACH);
	eval 'sub NCM_SIGDETACH () {5;}' unless defined(&NCM_SIGDETACH);
	eval 'sub ATM_DEV_NONCACHE () {1;}' unless defined(&ATM_DEV_NONCACHE);
	if(defined( &BSD)) {
	    eval 'sub ATM_DEV_CMPR_LG () { &MCLBYTES;}' unless defined(&ATM_DEV_CMPR_LG);
	    eval 'sub ATM_DEV_CMPR_SM () { &MLEN;}' unless defined(&ATM_DEV_CMPR_SM);
	}
	if(defined( &sun4c)) {
	    eval 'sub DMA_INIT () {
	        eval q();
	    }' unless defined(&DMA_INIT);
	    eval 'sub DMA_GET_ADDR {
	        local($addr,$len,$align,$flags) = @_;
    		eval q((($addr)));
	    }' unless defined(&DMA_GET_ADDR);
	    eval 'sub DMA_FREE_ADDR {
	        local($addr,$daddr,$len,$flags) = @_;
    		eval q();
	    }' unless defined(&DMA_FREE_ADDR);
	    eval 'sub DMA_RELEASE () {
	        eval q();
	    }' unless defined(&DMA_RELEASE);
	}
 elsif(defined( &sun4m)) {
	    eval 'sub DMA_INIT () {
	        eval q();
	    }' unless defined(&DMA_INIT);
	    eval 'sub DMA_GET_ADDR {
	        local($addr,$len,$align,$flags) = @_;
    		eval q( &atm_dma_map(($addr),($len),($flags)));
	    }' unless defined(&DMA_GET_ADDR);
	    eval 'sub DMA_FREE_ADDR {
	        local($addr,$daddr,$len,$flags) = @_;
    		eval q( &atm_dma_free(($daddr),($flags)));
	    }' unless defined(&DMA_FREE_ADDR);
	    eval 'sub DMA_RELEASE () {
	        eval q();
	    }' unless defined(&DMA_RELEASE);
	}
 elsif(defined( &BSD)  && defined( &__i386__)) {
	    eval 'sub DMA_INIT () {
	        eval q();
	    }' unless defined(&DMA_INIT);
	    eval 'sub DMA_GET_ADDR {
	        local($addr,$len,$align,$flags) = @_;
    		eval q(( &vtophys($addr)));
	    }' unless defined(&DMA_GET_ADDR);
	    eval 'sub DMA_FREE_ADDR {
	        local($addr,$daddr,$len,$flags) = @_;
    		eval q();
	    }' unless defined(&DMA_FREE_ADDR);
	    eval 'sub DMA_RELEASE () {
	        eval q();
	    }' unless defined(&DMA_RELEASE);
	} else {
	    die("\-\ Must\ define\ hardware\-specific\ requirements\ here");
	}
	if(defined( &sun)) {
	    eval 'sub DEVICE_LOCK {
	        local($u) = @_;
    		eval q((($u)-> &cu_savepri =  &splr(($u)-> &cu_intrpri)));
	    }' unless defined(&DEVICE_LOCK);
	}
	if(defined( &__FreeBSD__)) {
	    eval 'sub DEVICE_LOCK {
	        local($u) = @_;
    		eval q((($u)-> &cu_savepri =  &splimp()));
	    }' unless defined(&DEVICE_LOCK);
	}
	eval 'sub DEVICE_UNLOCK {
	    local($u) = @_;
    	    eval q((  &splx(($u)-> &cu_savepri)));
	}' unless defined(&DEVICE_UNLOCK);
	if(defined( &sun)) {
	    eval 'sub SBUS_BURST32 () {0x20;}' unless defined(&SBUS_BURST32);
	}
	if(defined(&sun)) {
	    eval 'sub SCHED_ATM () { &schednetisr( &atm_intr);}' unless defined(&SCHED_ATM);
	}
	if(defined(&__FreeBSD__)) {
	    eval 'sub NETISR_ATM () { &AF_ATM;}' unless defined(&NETISR_ATM);
	    eval 'sub SCHED_ATM () { &schednetisr( &NETISR_ATM);}' unless defined(&SCHED_ATM);
	}
	if(defined(&sgi)) {
	    eval 'sub SCHED_ATM () { &schednetisr( &atm_intr_index);}' unless defined(&SCHED_ATM);
	}
    }
}
1;
