require '_h2ph_pre.ph';

unless(defined(&_NETATM_ATM_SYS_H)) {
    eval 'sub _NETATM_ATM_SYS_H () {1;}' unless defined(&_NETATM_ATM_SYS_H);
    eval 'sub ATM_VERSION () {0x00030000;}' unless defined(&ATM_VERSION);
    eval 'sub ATM_VERS_MAJ {
        local($v) = @_;
	    eval q((($v) >> 16));
    }' unless defined(&ATM_VERS_MAJ);
    eval 'sub ATM_VERS_MIN {
        local($v) = @_;
	    eval q((($v) & 0xffff));
    }' unless defined(&ATM_VERS_MIN);
    eval 'sub ATM_CALLQ_MAX () {100;}' unless defined(&ATM_CALLQ_MAX);
    eval 'sub ATM_INTRQ_MAX () {1000;}' unless defined(&ATM_INTRQ_MAX);
    eval 'sub ATM_ADDR_EQUAL {
        local($a1, $a2) = @_;
	    eval q(((-> &address_format == -> &address_format)  && (-> &address_length == -> &address_length)  && ( &bcmp(-> &address, ($a2)-> &address, ($a1)-> &address_length) == 0)));
    }' unless defined(&ATM_ADDR_EQUAL);
    eval 'sub ATM_ADDR_SEL_EQUAL {
        local($a1, $s1, $a2) = @_;
	    eval q(((-> &address_format == -> &address_format)  && (-> &address_length == -> &address_length)  && ((((-> &address_format ==  &T_ATM_ENDSYS_ADDR) || (-> &address_format ==  &T_ATM_NSAP_ADDR))  && ( &bcmp(-> &address, -> &address, -> &address_length - 1) == 0)  && ( == (-> &address)-> &aan_sel)) || ((-> &address_format !=  &T_ATM_ENDSYS_ADDR)  && (-> &address_format !=  &T_ATM_NSAP_ADDR)  && ( &bcmp(-> &address, ($a2)-> &address, ($a1)-> &address_length) == 0)))));
    }' unless defined(&ATM_ADDR_SEL_EQUAL);
    eval 'sub ATM_ADDR_COPY {
        local($a1, $a2) = @_;
	    eval q({ -> &address_format = -> &address_format; -> &address_length = -> &address_length;  &XM_COPY(-> &address, ($a2)-> &address, ($a1)-> &address_length); });
    }' unless defined(&ATM_ADDR_COPY);
    eval 'sub ATM_ADDR_SEL_COPY {
        local($a1, $s1, $a2) = @_;
	    eval q({ -> &address_format = -> &address_format; -> &address_length = -> &address_length;  &if ((-> &address_format ==  &T_ATM_ENDSYS_ADDR) || (-> &address_format ==  &T_ATM_NSAP_ADDR)) {  &XM_COPY(-> &address, -> &address, -> &address_length - 1); (-> &address)-> &aan_sel = ; }  &else {  &XM_COPY(-> &address, ($a2)-> &address, ($a1)-> &address_length); } });
    }' unless defined(&ATM_ADDR_SEL_COPY);
    eval 'sub ATM_HDR_SET_VPI {
        local($vpi) = @_;
	    eval q(((($vpi) & 0xff) << 20));
    }' unless defined(&ATM_HDR_SET_VPI);
    eval 'sub ATM_HDR_SET_VCI {
        local($vci) = @_;
	    eval q(((($vci) & 0xffff) << 4));
    }' unless defined(&ATM_HDR_SET_VCI);
    eval 'sub ATM_HDR_SET_PT {
        local($pt) = @_;
	    eval q(((($pt) & 0x7) << 1));
    }' unless defined(&ATM_HDR_SET_PT);
    eval 'sub ATM_HDR_SET_CLP {
        local($clp) = @_;
	    eval q((($clp) & 0x1));
    }' unless defined(&ATM_HDR_SET_CLP);
    eval 'sub ATM_HDR_SET {
        local($vpi,$vci,$pt,$clp) = @_;
	    eval q(( &ATM_HDR_SET_VPI($vpi) |  &ATM_HDR_SET_VCI($vci) |  &ATM_HDR_SET_PT($pt) |  &ATM_HDR_SET_CLP($clp)));
    }' unless defined(&ATM_HDR_SET);
    eval 'sub ATM_HDR_GET_VPI {
        local($hdr) = @_;
	    eval q(((($hdr) >> 20) & 0xff));
    }' unless defined(&ATM_HDR_GET_VPI);
    eval 'sub ATM_HDR_GET_VCI {
        local($hdr) = @_;
	    eval q(((($hdr) >> 4) & 0xffff));
    }' unless defined(&ATM_HDR_GET_VCI);
    eval 'sub ATM_HDR_GET_PT {
        local($hdr) = @_;
	    eval q(((($hdr) >> 1) & 0x7));
    }' unless defined(&ATM_HDR_GET_PT);
    eval 'sub ATM_HDR_GET_CLP {
        local($hdr) = @_;
	    eval q((($hdr) & 0x1));
    }' unless defined(&ATM_HDR_GET_CLP);
    eval 'sub ATM_PT_USER_SDU0 () {0x0;}' unless defined(&ATM_PT_USER_SDU0);
    eval 'sub ATM_PT_USER_SDU1 () {0x1;}' unless defined(&ATM_PT_USER_SDU1);
    eval 'sub ATM_PT_USER_CONG_SDU0 () {0x2;}' unless defined(&ATM_PT_USER_CONG_SDU0);
    eval 'sub ATM_PT_USER_CONG_SDU1 () {0x3;}' unless defined(&ATM_PT_USER_CONG_SDU1);
    eval 'sub ATM_PT_NONUSER () {0x4;}' unless defined(&ATM_PT_NONUSER);
    eval 'sub ATM_PT_OAMF5_SEG () {0x4;}' unless defined(&ATM_PT_OAMF5_SEG);
    eval 'sub ATM_PT_OAMF5_E2E () {0x5;}' unless defined(&ATM_PT_OAMF5_E2E);
    eval 'sub ATM_AAL0 () {0;}' unless defined(&ATM_AAL0);
    eval 'sub ATM_AAL1 () {1;}' unless defined(&ATM_AAL1);
    eval 'sub ATM_AAL2 () {2;}' unless defined(&ATM_AAL2);
    eval 'sub ATM_AAL3_4 () {3;}' unless defined(&ATM_AAL3_4);
    eval 'sub ATM_AAL5 () {5;}' unless defined(&ATM_AAL5);
    eval 'sub ATM_ENC_NULL () {1;}' unless defined(&ATM_ENC_NULL);
    eval 'sub ATM_ENC_LLC () {2;}' unless defined(&ATM_ENC_LLC);
    if(defined(&ATM_KERNEL)) {
	eval 'sub TIF_QUEUED () {0x01;}' unless defined(&TIF_QUEUED);
	eval 'sub ATM_HZ () {2;}' unless defined(&ATM_HZ);
	eval 'sub SPOOL_MAGIC () {0x73d4b69c;}' unless defined(&SPOOL_MAGIC);
	eval 'sub SPOOL_MIN_CHUNK () {2;}' unless defined(&SPOOL_MIN_CHUNK);
	eval 'sub SPOOL_ROUNDUP () {16;}' unless defined(&SPOOL_ROUNDUP);
	eval 'sub SPOOL_COMPACT () {(300*  &ATM_HZ);}' unless defined(&SPOOL_COMPACT);
	if(defined(&DIAGNOSTIC)) {
	    eval 'sub ATM_TIME () {\'struct timeval\'  &now,  &delta;  &KT_TIME( &now);  ($delta->{tv_sec}) =  ($now->{tv_sec}) -  ($atm_debugtime->{tv_sec});  ($delta->{tv_usec}) =  ($now->{tv_usec}) -  ($atm_debugtime->{tv_usec});  &atm_debugtime =  &now;  &if ( ($delta->{tv_usec}) < 0) {  ($delta->{tv_sec})--;  ($delta->{tv_usec}) += 1000000; }  &printf("%3ld.%6ld: ",  ($delta->{tv_sec}),  ($delta->{tv_usec}));;}' unless defined(&ATM_TIME);
	    eval 'sub ATM_DEBUG0 {
	        local($f) = @_;
    		eval q( &if ( &atm_debug) { &ATM_TIME;  &printf($f);});
	    }' unless defined(&ATM_DEBUG0);
	    eval 'sub ATM_DEBUGN0 {
	        local($f) = @_;
    		eval q( &if ( &atm_debug) { &printf($f);});
	    }' unless defined(&ATM_DEBUGN0);
	    eval 'sub ATM_DEBUG1 {
	        local($f,$a1) = @_;
    		eval q( &if ( &atm_debug) { &ATM_TIME;  &printf($f, $a1);});
	    }' unless defined(&ATM_DEBUG1);
	    eval 'sub ATM_DEBUGN1 {
	        local($f,$a1) = @_;
    		eval q( &if ( &atm_debug) { &printf($f, $a1);});
	    }' unless defined(&ATM_DEBUGN1);
	    eval 'sub ATM_DEBUG2 {
	        local($f,$a1,$a2) = @_;
    		eval q( &if ( &atm_debug) { &ATM_TIME;  &printf($f, $a1, $a2);});
	    }' unless defined(&ATM_DEBUG2);
	    eval 'sub ATM_DEBUGN2 {
	        local($f,$a1,$a2) = @_;
    		eval q( &if ( &atm_debug) { &printf($f, $a1, $a2);});
	    }' unless defined(&ATM_DEBUGN2);
	    eval 'sub ATM_DEBUG3 {
	        local($f,$a1,$a2,$a3) = @_;
    		eval q( &if ( &atm_debug) { &ATM_TIME;  &printf($f, $a1, $a2, $a3);});
	    }' unless defined(&ATM_DEBUG3);
	    eval 'sub ATM_DEBUGN3 {
	        local($f,$a1,$a2,$a3) = @_;
    		eval q( &if ( &atm_debug) { &printf($f, $a1, $a2, $a3);});
	    }' unless defined(&ATM_DEBUGN3);
	    eval 'sub ATM_DEBUG4 {
	        local($f,$a1,$a2,$a3,$a4) = @_;
    		eval q( &if ( &atm_debug) { &ATM_TIME;  &printf($f, $a1, $a2, $a3, $a4);});
	    }' unless defined(&ATM_DEBUG4);
	    eval 'sub ATM_DEBUGN4 {
	        local($f,$a1,$a2,$a3,$a4) = @_;
    		eval q( &if ( &atm_debug) { &printf($f, $a1, $a2, $a3, $a4);});
	    }' unless defined(&ATM_DEBUGN4);
	    eval 'sub ATM_DEBUG5 {
	        local($f,$a1,$a2,$a3,$a4,$a5) = @_;
    		eval q( &if ( &atm_debug) { &ATM_TIME;  &printf($f, $a1, $a2, $a3, $a4, $a5);});
	    }' unless defined(&ATM_DEBUG5);
	    eval 'sub ATM_DEBUGN5 {
	        local($f,$a1,$a2,$a3,$a4,$a5) = @_;
    		eval q( &if ( &atm_debug) { &printf($f, $a1, $a2, $a3, $a4, $a5);});
	    }' unless defined(&ATM_DEBUGN5);
	} else {
	    eval 'sub ATM_DEBUG0 {
	        local($f) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUG0);
	    eval 'sub ATM_DEBUGN0 {
	        local($f) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUGN0);
	    eval 'sub ATM_DEBUG1 {
	        local($f,$a1) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUG1);
	    eval 'sub ATM_DEBUGN1 {
	        local($f,$a1) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUGN1);
	    eval 'sub ATM_DEBUG2 {
	        local($f,$a1,$a2) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUG2);
	    eval 'sub ATM_DEBUGN2 {
	        local($f,$a1,$a2) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUGN2);
	    eval 'sub ATM_DEBUG3 {
	        local($f,$a1,$a2,$a3) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUG3);
	    eval 'sub ATM_DEBUGN3 {
	        local($f,$a1,$a2,$a3) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUGN3);
	    eval 'sub ATM_DEBUG4 {
	        local($f,$a1,$a2,$a3,$a4) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUG4);
	    eval 'sub ATM_DEBUGN4 {
	        local($f,$a1,$a2,$a3,$a4) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUGN4);
	    eval 'sub ATM_DEBUG5 {
	        local($f,$a1,$a2,$a3,$a4,$a5) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUG5);
	    eval 'sub ATM_DEBUGN5 {
	        local($f,$a1,$a2,$a3,$a4,$a5) = @_;
    		eval q();
	    }' unless defined(&ATM_DEBUGN5);
	}
    }
}
1;
