require '_h2ph_pre.ph';

unless(defined(&_NETATM_PORT_H)) {
    eval 'sub _NETATM_PORT_H () {1;}' unless defined(&_NETATM_PORT_H);
    if((defined( &BSD)  && ((defined(&BSD) ? &BSD : 0) >= 199103))) {
    }
 elsif(defined( &sun)) {
    } else {
	die("Undefined/unsupported system type");
    }
    if(defined(&ATM_KERNEL)) {
	if((defined( &BSD)  && ((defined(&BSD) ? &BSD : 0) >= 199103))) {
	    require 'sys/malloc.ph';
	    eval 'sub KM_ALLOC {
	        local($size, $type, $flags) = @_;
    		eval q( &malloc(($size), ($type), ($flags)));
	    }' unless defined(&KM_ALLOC);
	    eval 'sub KM_FREE {
	        local($addr, $size, $type) = @_;
    		eval q( &free(($addr), ($type)));
	    }' unless defined(&KM_FREE);
	}
 elsif(defined( &sun)) {
	    require 'sys/kmem_alloc.ph';
	    eval 'sub KM_ALLOC {
	        local($size, $type, $flags) = @_;
    		eval q( &kmem_alloc($size));
	    }' unless defined(&KM_ALLOC);
	    eval 'sub KM_FREE {
	        local($addr, $size, $type) = @_;
    		eval q( &kmem_free(($addr), ($size)));
	    }' unless defined(&KM_FREE);
	}
	if(defined( &BSD)) {
	    eval 'sub KM_CMP {
	        local($b1, $b2, $len) = @_;
    		eval q( &bcmp(, ($b2), ($len)));
	    }' unless defined(&KM_CMP);
	    eval 'sub KM_COPY {
	        local($from, $to, $len) = @_;
    		eval q( &bcopy(, ($to), ($len)));
	    }' unless defined(&KM_COPY);
	    eval 'sub KM_ZERO {
	        local($addr, $len) = @_;
    		eval q( &bzero(($addr), ($len)));
	    }' unless defined(&KM_ZERO);
	}
	eval 'sub XM_COPY {
	    local($f, $t, $l) = @_;
    	    eval q( &KM_COPY(($f), ($t), ($l)));
	}' unless defined(&XM_COPY);
    } else {
	if((defined( &BSD)  && ((defined(&BSD) ? &BSD : 0) >= 199103))) {
	    eval 'sub UM_ALLOC {
	        local($size) = @_;
    		eval q( &malloc(($size)));
	    }' unless defined(&UM_ALLOC);
	    eval 'sub UM_FREE {
	        local($addr) = @_;
    		eval q( &free(($addr)));
	    }' unless defined(&UM_FREE);
	    eval 'sub UM_COPY {
	        local($from, $to, $len) = @_;
    		eval q( &bcopy(, , ($len)));
	    }' unless defined(&UM_COPY);
	    eval 'sub UM_ZERO {
	        local($addr, $len) = @_;
    		eval q( &bzero(, ($len)));
	    }' unless defined(&UM_ZERO);
	}
 elsif(defined( &sun)) {
	    eval 'sub UM_ALLOC {
	        local($size) = @_;
    		eval q( &malloc($size));
	    }' unless defined(&UM_ALLOC);
	    eval 'sub UM_FREE {
	        local($addr) = @_;
    		eval q( &free(($addr)));
	    }' unless defined(&UM_FREE);
	    eval 'sub UM_COPY {
	        local($from, $to, $len) = @_;
    		eval q( &bcopy(, ($to), ($len)));
	    }' unless defined(&UM_COPY);
	    eval 'sub UM_ZERO {
	        local($addr, $len) = @_;
    		eval q( &bzero(($addr), ($len)));
	    }' unless defined(&UM_ZERO);
	}
	eval 'sub XM_COPY {
	    local($f, $t, $l) = @_;
    	    eval q( &UM_COPY(($f), ($t), ($l)));
	}' unless defined(&XM_COPY);
    }
    if(defined(&ATM_KERNEL)) {
	if(defined( &BSD)) {
	    require 'sys/mbuf.ph';
	    eval 'sub KB_F_WAIT () { &M_WAIT;}' unless defined(&KB_F_WAIT);
	    eval 'sub KB_F_NOWAIT () { &M_DONTWAIT;}' unless defined(&KB_F_NOWAIT);
	    eval 'sub KB_T_HEADER () { &MT_HEADER;}' unless defined(&KB_T_HEADER);
	    eval 'sub KB_T_DATA () { &MT_DATA;}' unless defined(&KB_T_DATA);
	    eval 'sub KB_COPYALL () { &M_COPYALL;}' unless defined(&KB_COPYALL);
	    if((defined(&BSD) ? &BSD : 0) >= 199103) {
		eval 'sub KB_NEXT {
		    local($bfr) = @_;
    		    eval q(($bfr)-> &m_next);
		}' unless defined(&KB_NEXT);
		eval 'sub KB_LEN {
		    local($bfr) = @_;
    		    eval q(($bfr)-> &m_len);
		}' unless defined(&KB_LEN);
		eval 'sub KB_QNEXT {
		    local($bfr) = @_;
    		    eval q(($bfr)-> &m_nextpkt);
		}' unless defined(&KB_QNEXT);
		eval 'sub KB_ALLOC {
		    local($bfr, $size, $flags, $type) = @_;
    		    eval q({  &if (($size) <=  &MLEN) {  &MGET(($bfr), ($flags), ($type)); }  &else ($bfr) =  &NULL; });
		}' unless defined(&KB_ALLOC);
		eval 'sub KB_ALLOCPKT {
		    local($bfr, $size, $flags, $type) = @_;
    		    eval q({  &if (($size) <=  &MHLEN) {  &MGETHDR(($bfr), ($flags), ($type)); }  &else ($bfr) =  &NULL; });
		}' unless defined(&KB_ALLOCPKT);
		eval 'sub KB_ALLOCEXT {
		    local($bfr, $size, $flags, $type) = @_;
    		    eval q({  &if (($size) <=  &MCLBYTES) {  &MGET(($bfr), ($flags), ($type));  &if (($bfr) !=  &NULL) {  &MCLGET(($bfr), ($flags));  &if ((($bfr)-> &m_flags &  &M_EXT) == 0) {  &m_freem(($bfr)); ($bfr) =  &NULL; } } }  &else ($bfr) =  &NULL; });
		}' unless defined(&KB_ALLOCEXT);
		eval 'sub KB_FREEONE {
		    local($bfr, $nxt) = @_;
    		    eval q({ ($nxt) =  &m_free($bfr); });
		}' unless defined(&KB_FREEONE);
		eval 'sub KB_FREEALL {
		    local($bfr) = @_;
    		    eval q({  &m_freem($bfr); });
		}' unless defined(&KB_FREEALL);
		eval 'sub KB_COPY {
		    local($bfr, $off, $len, $new, $flags) = @_;
    		    eval q({ ($new) =  &m_copym(($bfr), ($off), ($len), ($flags)); });
		}' unless defined(&KB_COPY);
		eval 'sub KB_COPYDATA {
		    local($bfr, $off, $len, $datap) = @_;
    		    eval q(( &m_copydata(($bfr), ($off), ($len), ($datap)), 0));
		}' unless defined(&KB_COPYDATA);
		eval 'sub KB_PULLUP {
		    local($bfr, $n, $new) = @_;
    		    eval q({ ($new) =  &m_pullup(($bfr), ($n)); });
		}' unless defined(&KB_PULLUP);
		eval 'sub KB_LINKHEAD {
		    local($new, $head) = @_;
    		    eval q({  &if (($head)  &&  &KB_ISPKT($new)  &&  &KB_ISPKT($head)) {  &M_COPY_PKTHDR(($new), ($head)); ($head)-> &m_flags &= ~ &M_PKTHDR; } ($new)-> &m_next = ($head); });
		}' unless defined(&KB_LINKHEAD);
		eval 'sub KB_LINK {
		    local($new, $prev) = @_;
    		    eval q({ ($new)-> &m_next = ($prev)-> &m_next; ($prev)-> &m_next = ($new); });
		}' unless defined(&KB_LINK);
		eval 'sub KB_UNLINKHEAD {
		    local($head, $next) = @_;
    		    eval q({  &MFREE(($head), ($next)); });
		}' unless defined(&KB_UNLINKHEAD);
		eval 'sub KB_UNLINK {
		    local($old, $prev, $next) = @_;
    		    eval q({  &MFREE(($old), ($next)); ($prev)-> &m_next = ($next); });
		}' unless defined(&KB_UNLINK);
		eval 'sub KB_ISPKT {
		    local($bfr) = @_;
    		    eval q(((($bfr)-> &m_flags &  &M_PKTHDR) != 0));
		}' unless defined(&KB_ISPKT);
		eval 'sub KB_ISEXT {
		    local($bfr) = @_;
    		    eval q(((($bfr)-> &m_flags &  &M_EXT) != 0));
		}' unless defined(&KB_ISEXT);
		eval 'sub KB_BFRSTART {
		    local($bfr, $x, $t) = @_;
    		    eval q({  &if (-> &m_flags &  &M_EXT) = (-> ($m_ext->{ext_buf}));  &else  &if (-> &m_flags &  &M_PKTHDR) = (&-> &m_pktdat);  &else = (($bfr)-> &m_dat); });
		}' unless defined(&KB_BFRSTART);
		eval 'sub KB_BFREND {
		    local($bfr, $x, $t) = @_;
    		    eval q({  &if (-> &m_flags &  &M_EXT) = (-> ($m_ext->{ext_buf}) + -> ($m_ext->{ext_size}));  &else  &if (-> &m_flags &  &M_PKTHDR) = (&-> &m_pktdat +  &MHLEN);  &else = (($bfr)-> &m_dat +  &MLEN); });
		}' unless defined(&KB_BFREND);
		eval 'sub KB_BFRLEN {
		    local($bfr) = @_;
    		    eval q(((($bfr)-> &m_flags &  &M_EXT) ? ($bfr)-> ($m_ext->{ext_size}) : ((($bfr)-> &m_flags &  &M_PKTHDR) ?  &MHLEN :  &MLEN)));
		}' unless defined(&KB_BFRLEN);
		eval 'sub KB_DATASTART {
		    local($bfr, $x, $t) = @_;
    		    eval q({ ($x) =  &mtod(($bfr), $t); });
		}' unless defined(&KB_DATASTART);
		eval 'sub KB_DATAEND {
		    local($bfr, $x, $t) = @_;
    		    eval q({ = ( &mtod(($bfr), \'caddr_t\') + ($bfr)-> &m_len); });
		}' unless defined(&KB_DATAEND);
		eval 'sub KB_HEADSET {
		    local($bfr, $n) = @_;
    		    eval q({  &if (($bfr)-> &m_flags &  &M_EXT) ($bfr)-> &m_data = ($bfr)-> ($m_ext->{ext_buf}) + ($n);  &else  &if (($bfr)-> &m_flags &  &M_PKTHDR) ($bfr)-> &m_data = ($bfr)-> &m_pktdat + ($n);  &else ($bfr)-> &m_data = ($bfr)-> &m_dat + ($n); });
		}' unless defined(&KB_HEADSET);
		eval 'sub KB_HEADMOVE {
		    local($bfr, $n) = @_;
    		    eval q({ ($bfr)-> &m_data += ($n); });
		}' unless defined(&KB_HEADMOVE);
		eval 'sub KB_HEADADJ {
		    local($bfr, $n) = @_;
    		    eval q({ ($bfr)-> &m_len += ($n); ($bfr)-> &m_data -= ($n); });
		}' unless defined(&KB_HEADADJ);
		eval 'sub KB_TAILADJ {
		    local($bfr, $n) = @_;
    		    eval q({ ($bfr)-> &m_len += ($n); });
		}' unless defined(&KB_TAILADJ);
		eval 'sub KB_TAILALIGN {
		    local($bfr, $n) = @_;
    		    eval q({ -> &m_len = ;  &if (-> &m_flags &  &M_EXT) -> &m_data = ((-> ($m_ext->{ext_buf})	 + -> ($m_ext->{ext_size}) - ) & ~( &sizeof - 1));  &else -> &m_data = ((($bfr)-> &m_dat +  &MLEN - ($n)) & ~($sizeof{\'long\'} - 1)); });
		}' unless defined(&KB_TAILALIGN);
		eval 'sub KB_HEADROOM {
		    local($bfr, $n) = @_;
    		    eval q({ ($n) = (($bfr)-> &m_flags &  &M_EXT ? ($bfr)-> &m_data - ($bfr)-> ($m_ext->{ext_buf}) : ($bfr)-> &m_flags &  &M_PKTHDR ? ($bfr)-> &m_data - ($bfr)-> &m_pktdat : ($bfr)-> &m_data - ($bfr)-> &m_dat); });
		}' unless defined(&KB_HEADROOM);
		eval 'sub KB_TAILROOM {
		    local($bfr, $n) = @_;
    		    eval q({ ($n) =  &M_TRAILINGSPACE($bfr); });
		}' unless defined(&KB_TAILROOM);
		eval 'sub KB_PLENGET {
		    local($bfr, $n) = @_;
    		    eval q({ ($n) = ($bfr)-> ($m_pkthdr->{len}); });
		}' unless defined(&KB_PLENGET);
		eval 'sub KB_PLENSET {
		    local($bfr, $n) = @_;
    		    eval q({ ($bfr)-> ($m_pkthdr->{len}) = ($n); });
		}' unless defined(&KB_PLENSET);
		eval 'sub KB_PLENADJ {
		    local($bfr, $n) = @_;
    		    eval q({ ($bfr)-> ($m_pkthdr->{len}) += ($n); });
		}' unless defined(&KB_PLENADJ);
	    } else {
		eval 'sub KB_NEXT {
		    local($bfr) = @_;
    		    eval q(($bfr)-> &m_next);
		}' unless defined(&KB_NEXT);
		eval 'sub KB_LEN {
		    local($bfr) = @_;
    		    eval q(($bfr)-> &m_len);
		}' unless defined(&KB_LEN);
		eval 'sub KB_QNEXT {
		    local($bfr) = @_;
    		    eval q(($bfr)-> &m_act);
		}' unless defined(&KB_QNEXT);
		eval 'sub KB_ALLOC {
		    local($bfr, $size, $flags, $type) = @_;
    		    eval q({  &if (($size) <=  &MLEN) {  &MGET(($bfr), ($flags), ($type)); }  &else ($bfr) =  &NULL; });
		}' unless defined(&KB_ALLOC);
		eval 'sub KB_ALLOCPKT {
		    local($bfr, $size, $flags, $type) = @_;
    		    eval q({  &if (($size) <=  &MLEN) {  &MGET(($bfr), ($flags), ($type)); }  &else ($bfr) =  &NULL; });
		}' unless defined(&KB_ALLOCPKT);
		eval 'sub KB_ALLOCEXT {
		    local($bfr, $size, $flags, $type) = @_;
    		    eval q({  &if (($size) <=  &MCLBYTES) {  &MGET(($bfr), ($flags), ($type));  &if (($bfr) !=  &NULL) {  &MCLGET($bfr);  &if (($bfr)-> &m_len !=  &MCLBYTES) {  &m_freem(($bfr)); ($bfr) =  &NULL; } } }  &else ($bfr) =  &NULL; });
		}' unless defined(&KB_ALLOCEXT);
		eval 'sub KB_FREEONE {
		    local($bfr, $nxt) = @_;
    		    eval q({ ($nxt) =  &m_free($bfr); });
		}' unless defined(&KB_FREEONE);
		eval 'sub KB_FREEALL {
		    local($bfr) = @_;
    		    eval q({  &m_freem($bfr); });
		}' unless defined(&KB_FREEALL);
		eval 'sub KB_COPY {
		    local($bfr, $off, $len, $new, $flags) = @_;
    		    eval q({ ($new) =  &m_copy(($bfr), ($off), ($len)); });
		}' unless defined(&KB_COPY);
		eval 'sub KB_COPYDATA {
		    local($bfr, $off, $len, $datap) = @_;
    		    eval q( &m_cpytoc(($bfr), ($off), ($len), ($datap)));
		}' unless defined(&KB_COPYDATA);
		eval 'sub KB_PULLUP {
		    local($bfr, $n, $new) = @_;
    		    eval q({ ($new) =  &m_pullup(($bfr), ($n)); });
		}' unless defined(&KB_PULLUP);
		eval 'sub KB_LINKHEAD {
		    local($new, $head) = @_;
    		    eval q({ ($new)-> &m_next = ($head); });
		}' unless defined(&KB_LINKHEAD);
		eval 'sub KB_LINK {
		    local($new, $prev) = @_;
    		    eval q({ ($new)-> &m_next = ($prev)-> &m_next; ($prev)-> &m_next = ($new); });
		}' unless defined(&KB_LINK);
		eval 'sub KB_UNLINKHEAD {
		    local($head, $next) = @_;
    		    eval q({  &MFREE(($head), ($next)); });
		}' unless defined(&KB_UNLINKHEAD);
		eval 'sub KB_UNLINK {
		    local($old, $prev, $next) = @_;
    		    eval q({  &MFREE(($old), ($next)); ($prev)-> &m_next = ($next); });
		}' unless defined(&KB_UNLINK);
		eval 'sub KB_ISPKT {
		    local($bfr) = @_;
    		    eval q((0));
		}' unless defined(&KB_ISPKT);
		eval 'sub KB_ISEXT {
		    local($bfr) = @_;
    		    eval q( &M_HASCL($bfr));
		}' unless defined(&KB_ISEXT);
		eval 'sub KB_BFRSTART {
		    local($bfr, $x, $t) = @_;
    		    eval q({  &if {  &if (-> &m_cltype ==  &MCL_STATIC) = ( &mtod(, \'int\') & ~( &MCLBYTES - 1));  &else =  &NULL; }  &else = (($bfr)-> &m_dat); });
		}' unless defined(&KB_BFRSTART);
		eval 'sub KB_BFREND {
		    local($bfr, $x, $t) = @_;
    		    eval q({  &if {  &if (-> &m_cltype ==  &MCL_STATIC) = (( &mtod(, \'int\') & ~( &MCLBYTES - 1)) +  &MCLBYTES);  &else =  &NULL; }  &else = (($bfr)-> &m_dat +  &MLEN); });
		}' unless defined(&KB_BFREND);
		eval 'sub KB_BFRLEN {
		    local($bfr) = @_;
    		    eval q(( &M_HASCL($bfr) ? ((($bfr)-> &m_cltype ==  &MCL_STATIC) ?  &MCLBYTES : 0) :  &MLEN));
		}' unless defined(&KB_BFRLEN);
		eval 'sub KB_DATASTART {
		    local($bfr, $x, $t) = @_;
    		    eval q({ ($x) =  &mtod(($bfr), $t); });
		}' unless defined(&KB_DATASTART);
		eval 'sub KB_DATAEND {
		    local($bfr, $x, $t) = @_;
    		    eval q({ = ( &mtod(($bfr), \'caddr_t\') + ($bfr)-> &m_len); });
		}' unless defined(&KB_DATAEND);
		eval 'sub KB_HEADSET {
		    local($bfr, $n) = @_;
    		    eval q({  &if ( &M_HASCL($bfr)) { ($bfr)-> &m_off += ($n); }  &else ($bfr)-> &m_off =  &MMINOFF + ($n); });
		}' unless defined(&KB_HEADSET);
		eval 'sub KB_HEADMOVE {
		    local($bfr, $n) = @_;
    		    eval q({ ($bfr)-> &m_off += ($n); });
		}' unless defined(&KB_HEADMOVE);
		eval 'sub KB_HEADADJ {
		    local($bfr, $n) = @_;
    		    eval q({ ($bfr)-> &m_len += ($n); ($bfr)-> &m_off -= ($n); });
		}' unless defined(&KB_HEADADJ);
		eval 'sub KB_TAILADJ {
		    local($bfr, $n) = @_;
    		    eval q({ ($bfr)-> &m_len += ($n); });
		}' unless defined(&KB_TAILADJ);
		eval 'sub KB_TAILALIGN {
		    local($bfr, $n) = @_;
    		    eval q({ -> &m_len = ;  &if {  &if (-> &m_cltype ==  &MCL_STATIC) -> &m_off = ((( &mtod(, \'int\') & ~( &MCLBYTES - 1)) +  &MCLBYTES - ) & ~( &sizeof - 1)) - ($bfr); }  &else ($bfr)-> &m_off = ( &MMAXOFF - ($n)) & ~($sizeof{\'long\'} - 1); });
		}' unless defined(&KB_TAILALIGN);
		eval 'sub KB_HEADROOM {
		    local($bfr, $n) = @_;
    		    eval q({  &if ( &M_HASCL($bfr)) {  &if (($bfr)-> &m_cltype ==  &MCL_STATIC) ($n) =  &mtod(($bfr), \'int\') & ( &MCLBYTES - 1);  &else ($n) = 0; }  &else ($n) = ($bfr)-> &m_off -  &MMINOFF; });
		}' unless defined(&KB_HEADROOM);
		eval 'sub KB_TAILROOM {
		    local($bfr, $n) = @_;
    		    eval q({  &if ( &M_HASCL($bfr)) {  &if (($bfr)-> &m_cltype ==  &MCL_STATIC) ($n) =  &MCLBYTES - (( &mtod(($bfr), \'int\') + ($bfr)-> &m_len) & ( &MCLBYTES - 1));  &else ($n) = 0; }  &else ($n) =  &MMAXOFF - (($bfr)-> &m_off + ($bfr)-> &m_len); });
		}' unless defined(&KB_TAILROOM);
		eval 'sub KB_PLENGET {
		    local($bfr, $n) = @_;
    		    eval q({ \'struct mbuf\' * &zz;  &for (($n) = 0,  &zz = ($bfr);  &zz;  &zz =  ($zz->{m_next})) ($n) +=  ($zz->{m_len}); });
		}' unless defined(&KB_PLENGET);
		eval 'sub KB_PLENSET {
		    local($bfr, $n) = @_;
    		    eval q({ });
		}' unless defined(&KB_PLENSET);
		eval 'sub KB_PLENADJ {
		    local($bfr, $n) = @_;
    		    eval q({ });
		}' unless defined(&KB_PLENADJ);
	    }
	}
	if((defined( &BSD)  && ((defined(&BSD) ? &BSD : 0) >= 199306))) {
	} else {
	}
	if((defined( &BSD)  && ((defined(&BSD) ? &BSD : 0) >= 199103))) {
	    eval 'sub KT_TIME {
	        local($t) = @_;
    		eval q( &microtime($t));
	    }' unless defined(&KT_TIME);
	}
 elsif(defined( &sun)) {
	    eval 'sub KT_TIME {
	        local($t) = @_;
    		eval q( &uniqtime($t));
	    }' unless defined(&KT_TIME);
	} else {
	    eval 'sub KT_TIME {
	        local($t) = @_;
    		eval q((($t) =  &time));
	    }' unless defined(&KT_TIME);
	}
    }
    unless(defined(&NTOHL)) {
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	    eval 'sub NTOHL {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&NTOHL);
	    eval 'sub NTOHS {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&NTOHS);
	    eval 'sub HTONL {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&HTONL);
	    eval 'sub HTONS {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&HTONS);
	} else {
	    eval 'sub NTOHL {
	        local($x) = @_;
    		eval q( =  &ntohl(($x)));
	    }' unless defined(&NTOHL);
	    eval 'sub NTOHS {
	        local($x) = @_;
    		eval q( =  &ntohs(($x)));
	    }' unless defined(&NTOHS);
	    eval 'sub HTONL {
	        local($x) = @_;
    		eval q( =  &htonl(($x)));
	    }' unless defined(&HTONL);
	    eval 'sub HTONS {
	        local($x) = @_;
    		eval q( =  &htons(($x)));
	    }' unless defined(&HTONS);
	}
    }
    unless(defined(&MAX)) {
	eval 'sub MAX {
	    local($a,$b) = @_;
    	    eval q( &max(($a),($b)));
	}' unless defined(&MAX);
    }
    unless(defined(&MIN)) {
	eval 'sub MIN {
	    local($a,$b) = @_;
    	    eval q( &min(($a),($b)));
	}' unless defined(&MIN);
    }
    if((!(defined( &BSD)  && ((defined(&BSD) ? &BSD : 0) >= 199306)))) {
	unless(defined(&__BIT_TYPES_DEFINED__)) {
	    eval 'sub __BIT_TYPES_DEFINED__ () {1;}' unless defined(&__BIT_TYPES_DEFINED__);
	}
    }
}
1;
