require '_h2ph_pre.ph';

unless(defined(&_NETGRAPH_BPF_H_)) {
    eval 'sub _NETGRAPH_BPF_H_ () {1;}' unless defined(&_NETGRAPH_BPF_H_);
    eval 'sub NG_BPF_NODE_TYPE () {"bpf";}' unless defined(&NG_BPF_NODE_TYPE);
    eval 'sub NGM_BPF_COOKIE () {944100792;}' unless defined(&NGM_BPF_COOKIE);
    eval 'sub NG_BPF_HOOKPROG_SIZE {
        local($numInsn) = @_;
	    eval q(($sizeof{\'struct ng_bpf_hookprog\'} + ($numInsn) * $sizeof{\'struct bpf_insn\'}));
    }' unless defined(&NG_BPF_HOOKPROG_SIZE);
    eval 'sub NG_BPF_HOOKPROG_TYPE_INFO {
        local($bptype) = @_;
	    eval q({ { { \\"thisHook\\",  &ng_parse_hookbuf_type }, { \\"ifMatch\\",  &ng_parse_hookbuf_type }, { \\"ifNotMatch\\",  &ng_parse_hookbuf_type }, { \\"bpf_prog_len\\",  &ng_parse_int32_type }, { \\"bpf_prog\\", ($bptype) }, {  &NULL }, } });
    }' unless defined(&NG_BPF_HOOKPROG_TYPE_INFO);
    eval 'sub NG_BPF_HOOKSTAT_TYPE_INFO () {{ { { "recvFrames",  &ng_parse_int64_type }, { "recvOctets",  &ng_parse_int64_type }, { "recvMatchFrames",  &ng_parse_int64_type }, { "recvMatchOctets",  &ng_parse_int64_type }, { "xmitFrames",  &ng_parse_int64_type }, { "xmitOctets",  &ng_parse_int64_type }, {  &NULL }, } };}' unless defined(&NG_BPF_HOOKSTAT_TYPE_INFO);
    eval("sub NGM_BPF_SET_PROGRAM () { 1; }") unless defined(&NGM_BPF_SET_PROGRAM);
    eval("sub NGM_BPF_GET_PROGRAM () { 2; }") unless defined(&NGM_BPF_GET_PROGRAM);
    eval("sub NGM_BPF_GET_STATS () { 3; }") unless defined(&NGM_BPF_GET_STATS);
    eval("sub NGM_BPF_CLR_STATS () { 4; }") unless defined(&NGM_BPF_CLR_STATS);
    eval("sub NGM_BPF_GETCLR_STATS () { 5; }") unless defined(&NGM_BPF_GETCLR_STATS);
}
1;
