require '_h2ph_pre.ph';

unless(defined(&_NFS_NFSNODE_H_)) {
    eval 'sub _NFS_NFSNODE_H_ () {1;}' unless defined(&_NFS_NFSNODE_H_);
    if(!defined( &_NFS_NFS_H_)  && !defined( &KERNEL)) {
	require 'nfs/nfs.ph';
    }
    eval 'sub NFSNUMCOOKIES () {31;}' unless defined(&NFSNUMCOOKIES);
    eval 'sub n_atim () { ($n_un1->{nf_atim});}' unless defined(&n_atim);
    eval 'sub n_mtim () { ($n_un2->{nf_mtim});}' unless defined(&n_mtim);
    eval 'sub n_sillyrename () { ($n_un3->{nf_silly});}' unless defined(&n_sillyrename);
    eval 'sub n_cookieverf () { ($n_un1->{nd_cookieverf});}' unless defined(&n_cookieverf);
    eval 'sub n_direofoffset () { ($n_un2->{nd_direof});}' unless defined(&n_direofoffset);
    eval 'sub n_cookies () { ($n_un3->{nd_cook});}' unless defined(&n_cookies);
    eval 'sub NFLUSHWANT () {0x0001;}' unless defined(&NFLUSHWANT);
    eval 'sub NFLUSHINPROG () {0x0002;}' unless defined(&NFLUSHINPROG);
    eval 'sub NMODIFIED () {0x0004;}' unless defined(&NMODIFIED);
    eval 'sub NWRITEERR () {0x0008;}' unless defined(&NWRITEERR);
    eval 'sub NQNFSNONCACHE () {0x0020;}' unless defined(&NQNFSNONCACHE);
    eval 'sub NQNFSWRITE () {0x0040;}' unless defined(&NQNFSWRITE);
    eval 'sub NQNFSEVICTED () {0x0080;}' unless defined(&NQNFSEVICTED);
    eval 'sub NACC () {0x0100;}' unless defined(&NACC);
    eval 'sub NUPD () {0x0200;}' unless defined(&NUPD);
    eval 'sub NCHG () {0x0400;}' unless defined(&NCHG);
    eval 'sub NLOCKED () {0x0800;}' unless defined(&NLOCKED);
    eval 'sub NWANTED () {0x0100;}' unless defined(&NWANTED);
    eval 'sub VTONFS {
        local($vp) = @_;
	    eval q((($vp)-> &v_data));
    }' unless defined(&VTONFS);
    eval 'sub NFSTOV {
        local($np) = @_;
	    eval q((($np)-> &n_vnode));
    }' unless defined(&NFSTOV);
    if(defined( &KERNEL) || defined( &_KERNEL)) {
	eval 'sub nqnfs_lease_updatetime () { &nfs_lease_updatetime;}' unless defined(&nqnfs_lease_updatetime);
    }
}
1;
