require '_h2ph_pre.ph';

require 'sys/cdefs.ph';
require 'rpc/rpc.ph';
unless(defined(&DES_MAXDATA)) {
    sub DES_MAXDATA () {	8192;}
}
unless(defined(&DES_DIRMASK)) {
    sub DES_DIRMASK () {	(1<< 0);}
}
unless(defined(&DES_ENCRYPT)) {
    sub DES_ENCRYPT () {	(0* &DES_DIRMASK);}
}
unless(defined(&DES_DECRYPT)) {
    sub DES_DECRYPT () {	(1* &DES_DIRMASK);}
}
unless(defined(&DES_DEVMASK)) {
    sub DES_DEVMASK () {	(1<< 1);}
}
unless(defined(&DES_HW)) {
    sub DES_HW () {	(0* &DES_DEVMASK);}
}
unless(defined(&DES_SW)) {
    sub DES_SW () {	(1* &DES_DEVMASK);}
}
unless(defined(&DESERR_NONE)) {
    sub DESERR_NONE () {	0;}
}
unless(defined(&DESERR_NOHWDEVICE)) {
    sub DESERR_NOHWDEVICE () {	1;}
}
unless(defined(&DESERR_HWERROR)) {
    sub DESERR_HWERROR () {	2;}
}
unless(defined(&DESERR_BADPARAM)) {
    sub DESERR_BADPARAM () {	3;}
}
unless(defined(&DES_FAILED)) {
    sub DES_FAILED {
	local($err) = @_;
	eval q((($err) >  &DESERR_NOHWDEVICE));
    }
}
if(defined(&__STDC__)) {
} else {
}
if(defined(&__STDC__)) {
} else {
}
unless(defined(&KERNEL)) {
    if(defined(&__STDC__)) {
    } else {
    }
}
1;
