require '_h2ph_pre.ph';

unless(defined(&_SYS_CDEFS_H_)) {
    eval 'sub _SYS_CDEFS_H_ () {1;}' unless defined(&_SYS_CDEFS_H_);
    if(defined( &__cplusplus)) {
	eval 'sub __BEGIN_DECLS () { &extern "C" {;}' unless defined(&__BEGIN_DECLS);
	eval 'sub __END_DECLS () {};}' unless defined(&__END_DECLS);
    } else {
	eval 'sub __BEGIN_DECLS () {1;}' unless defined(&__BEGIN_DECLS);
	eval 'sub __END_DECLS () {1;}' unless defined(&__END_DECLS);
    }
    if(defined( &__STDC__) || defined( &__cplusplus)) {
	eval 'sub __P {
	    local($protos) = @_;
    	    eval q($protos);
	}' unless defined(&__P);
	eval 'sub __CONCAT1 {
	    local($x,$y) = @_;
    	    eval q($x  $y);
	}' unless defined(&__CONCAT1);
	eval 'sub __CONCAT {
	    local($x,$y) = @_;
    	    eval q( &__CONCAT1($x,$y));
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&__STRING);
	eval 'sub __XSTRING {
	    local($x) = @_;
    	    eval q( &__STRING($x));
	}' unless defined(&__XSTRING);
	eval 'sub __const () { &const;}' unless defined(&__const);
	eval 'sub __signed () {\'signed\';}' unless defined(&__signed);
	eval 'sub __volatile () { &volatile;}' unless defined(&__volatile);
	if(defined( &__cplusplus)) {
	    eval 'sub __inline () { &inline;}' unless defined(&__inline);
	} else {
	    unless(defined(&__GNUC__)) {
		eval 'sub __inline () {1;}' unless defined(&__inline);
	    }
	}
    } else {
	eval 'sub __P {
	    local($protos) = @_;
    	    eval q(());
	}' unless defined(&__P);
	eval 'sub __CONCAT {
	    local($x,$y) = @_;
    	    eval q( &xy);
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    local($x) = @_;
    	    eval q(\\"x\\");
	}' unless defined(&__STRING);
	unless(defined(&__GNUC__)) {
	    eval 'sub __const () {1;}' unless defined(&__const);
	    eval 'sub __inline () {1;}' unless defined(&__inline);
	    eval 'sub __signed () {1;}' unless defined(&__signed);
	    eval 'sub __volatile () {1;}' unless defined(&__volatile);
	    unless(defined(&NO_ANSI_KEYWORDS)) {
		eval 'sub const () {1;}' unless defined(&const);
		eval 'sub inline () {1;}' unless defined(&inline);
		eval 'sub signed () {1;}' unless defined(&signed);
		eval 'sub volatile () {1;}' unless defined(&volatile);
	    }
	}
    }
    if((defined(&__GNUC__) ? &__GNUC__ : 0) < 2|| (defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) < 5) {
	eval 'sub __dead2 () {1;}' unless defined(&__dead2);
	eval 'sub __pure2 () {1;}' unless defined(&__pure2);
	eval 'sub __unused () {1;}' unless defined(&__unused);
    }
    if((defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) >= 5 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) < 7) {
	eval 'sub __dead2 () { &__attribute__(( &__noreturn__));}' unless defined(&__dead2);
	eval 'sub __pure2 () { &__attribute__(( &__const__));}' unless defined(&__pure2);
	eval 'sub __unused () {1;}' unless defined(&__unused);
    }
    if((defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) >= 7) {
	eval 'sub __dead2 () { &__attribute__(( &__noreturn__));}' unless defined(&__dead2);
	eval 'sub __pure2 () { &__attribute__(( &__const__));}' unless defined(&__pure2);
	eval 'sub __unused () { &__attribute__(( &__unused__));}' unless defined(&__unused);
    }
    if((defined(&__GNUC__) ? &__GNUC__ : 0) < 2|| (defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) < 7) {
	eval 'sub __printflike {
	    local($fmtarg, $firstvararg) = @_;
    	    eval q();
	}' unless defined(&__printflike);
	eval 'sub __scanflike {
	    local($fmtarg, $firstvararg) = @_;
    	    eval q();
	}' unless defined(&__scanflike);
    } else {
	eval 'sub __printflike {
	    local($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__printf__, $fmtarg, $firstvararg))));
	}' unless defined(&__printflike);
	eval 'sub __scanflike {
	    local($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__scanf__, $fmtarg, $firstvararg))));
	}' unless defined(&__scanflike);
    }
    if((defined(&__FreeBSD_cc_version) ? &__FreeBSD_cc_version : 0) >= 300001) {
	eval 'sub __printf0like {
	    local($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__printf0__, $fmtarg, $firstvararg))));
	}' unless defined(&__printf0like);
    } else {
	eval 'sub __printf0like {
	    local($fmtarg, $firstvararg) = @_;
    	    eval q();
	}' unless defined(&__printf0like);
    }
    if(defined(&__GNUC__)) {
	if(defined(&__ELF__)) {
	    if(defined(&__STDC__)) {
		eval 'sub __weak_reference {
		    local($sym,$alias) = @_;
    		    eval q( &__asm__(\\".weak \\" $alias);  &__asm__(\\".equ \\" $alias \\", \\" $sym));
		}' unless defined(&__weak_reference);
		eval 'sub __warn_references {
		    local($sym,$msg) = @_;
    		    eval q( &__asm__(\\".section .gnu.warning.\\" $sym);  &__asm__(\\".asciz \\\\\\"\\" $msg \\"\\\\\\"\\");  &__asm__(\\".previous\\"));
		}' unless defined(&__warn_references);
	    } else {
		eval 'sub __weak_reference {
		    local($sym,$alias) = @_;
    		    eval q( &__asm__(\\".weak alias\\");  &__asm__(\\".equ alias, sym\\"));
		}' unless defined(&__weak_reference);
		eval 'sub __warn_references {
		    local($sym,$msg) = @_;
    		    eval q( &__asm__(\\".section .gnu.warning.sym\\");  &__asm__(\\".asciz \\\\\\"msg\\\\\\"\\");  &__asm__(\\".previous\\"));
		}' unless defined(&__warn_references);
	    }
	} else {
	    if(defined(&__STDC__)) {
		eval 'sub __weak_reference {
		    local($sym,$alias) = @_;
    		    eval q( &__asm__(\\".stabs \\\\\\"_\\" $alias \\"\\\\\\",11,0,0,0\\");  &__asm__(\\".stabs \\\\\\"_\\" $sym \\"\\\\\\",1,0,0,0\\"));
		}' unless defined(&__weak_reference);
		eval 'sub __warn_references {
		    local($sym,$msg) = @_;
    		    eval q( &__asm__(\\".stabs \\\\\\"\\" $msg \\"\\\\\\",30,0,0,0\\");  &__asm__(\\".stabs \\\\\\"_\\" $sym \\"\\\\\\",1,0,0,0\\"));
		}' unless defined(&__warn_references);
	    } else {
		eval 'sub __weak_reference {
		    local($sym,$alias) = @_;
    		    eval q( &__asm__(\\".stabs \\\\\\"_alias\\\\\\",11,0,0,0\\");  &__asm__(\\".stabs \\\\\\"_sym\\\\\\",1,0,0,0\\"));
		}' unless defined(&__weak_reference);
		eval 'sub __warn_references {
		    local($sym,$msg) = @_;
    		    eval q( &__asm__(\\".stabs msg,30,0,0,0\\");  &__asm__(\\".stabs \\\\\\"_sym\\\\\\",1,0,0,0\\"));
		}' unless defined(&__warn_references);
	    }
	}
    }
    eval 'sub __IDSTRING {
        local($name,$string) = @_;
	    eval q( &static  &const \'char\' $name->[]  &__unused = $string);
    }' unless defined(&__IDSTRING);
    unless(defined(&__RCSID)) {
	eval 'sub __RCSID {
	    local($s) = @_;
    	    eval q( &__IDSTRING( &rcsid,$s));
	}' unless defined(&__RCSID);
    }
    unless(defined(&__RCSID_SOURCE)) {
	eval 'sub __RCSID_SOURCE {
	    local($s) = @_;
    	    eval q( &__IDSTRING( &rcsid_source,$s));
	}' unless defined(&__RCSID_SOURCE);
    }
    unless(defined(&__COPYRIGHT)) {
	eval 'sub __COPYRIGHT {
	    local($s) = @_;
    	    eval q( &__IDSTRING( &copyright,$s));
	}' unless defined(&__COPYRIGHT);
    }
}
1;
