require '_h2ph_pre.ph';

unless(defined(&_SYS_CONF_H_)) {
    eval 'sub _SYS_CONF_H_ () {1;}' unless defined(&_SYS_CONF_H_);
    eval 'sub D_TAPE () {1;}' unless defined(&D_TAPE);
    eval 'sub D_DISK () {2;}' unless defined(&D_DISK);
    eval 'sub D_TTY () {3;}' unless defined(&D_TTY);
    eval 'sub D_TYPEMASK () {0xffff;}' unless defined(&D_TYPEMASK);
    eval 'sub D_NOCLUSTERR () {0x10000;}' unless defined(&D_NOCLUSTERR);
    eval 'sub D_NOCLUSTERW () {0x20000;}' unless defined(&D_NOCLUSTERW);
    eval 'sub D_NOCLUSTERRW () {( &D_NOCLUSTERR |  &D_NOCLUSTERW);}' unless defined(&D_NOCLUSTERRW);
    eval 'sub D_CANFREE () {0x40000;}' unless defined(&D_CANFREE);
    if(defined(&KERNEL)) {
    }
    if(defined(&KERNEL)) {
	eval 'sub LDISC_LOAD () {-1;}' unless defined(&LDISC_LOAD);
    }
    eval 'sub SW_FREED () {0x01;}' unless defined(&SW_FREED);
    eval 'sub SW_SEQUENTIAL () {0x02;}' unless defined(&SW_SEQUENTIAL);
    eval 'sub sw_freed () { &sw_flags;}' unless defined(&sw_freed);
    if(defined(&KERNEL)) {
	eval 'sub noioc () { &noioctl;}' unless defined(&noioc);
	eval 'sub nostrat () { &nostrategy;}' unless defined(&nostrat);
	eval 'sub zerosize () { &nopsize;}' unless defined(&zerosize);
	eval 'sub nostrategy () {( &NULL);}' unless defined(&nostrategy);
	eval 'sub nopsize () {( &NULL);}' unless defined(&nopsize);
	eval 'sub nullstop () { &nostop;}' unless defined(&nullstop);
	eval 'sub nullreset () { &noreset;}' unless defined(&nullreset);
	eval 'sub CDEV_MODULE {
	    local($name, $major, $devsw, $evh, $arg) = @_;
    	    eval q( &static \'struct cdevsw_module_data\' $name &_cdevsw_mod = { $evh, $arg, $major ==  &NODEV ?  &NODEV :  &makedev($major, 0), $devsw };  &static  &moduledata_t $name &_mod = { $name,  &cdevsw_module_handler, $name &_cdevsw_mod };  &DECLARE_MODULE($name, $name &_mod,  &SI_SUB_DRIVERS,  &SI_ORDER_MIDDLE+$major));
	}' unless defined(&CDEV_MODULE);
	eval 'sub BDEV_MODULE {
	    local($name, $bdev, $cdev, $devsw, $evh, $arg) = @_;
    	    eval q( &static \'struct bdevsw_module_data\' $name &_bdevsw_mod = { $evh, $arg, $bdev ==  &NODEV ?  &NODEV :  &makedev($bdev, 0), $cdev ==  &NODEV ?  &NODEV :  &makedev($cdev, 0), $devsw };  &static  &moduledata_t $name &_mod = { $name,  &bdevsw_module_handler, $name &_bdevsw_mod };  &DECLARE_MODULE($name, $name &_mod,  &SI_SUB_DRIVERS,  &SI_ORDER_MIDDLE+$cdev));
	}' unless defined(&BDEV_MODULE);
	eval 'sub UID_ROOT () {0;}' unless defined(&UID_ROOT);
	eval 'sub UID_BIN () {3;}' unless defined(&UID_BIN);
	eval 'sub UID_UUCP () {66;}' unless defined(&UID_UUCP);
	eval 'sub GID_WHEEL () {0;}' unless defined(&GID_WHEEL);
	eval 'sub GID_KMEM () {2;}' unless defined(&GID_KMEM);
	eval 'sub GID_OPERATOR () {5;}' unless defined(&GID_OPERATOR);
	eval 'sub GID_BIN () {7;}' unless defined(&GID_BIN);
	eval 'sub GID_GAMES () {13;}' unless defined(&GID_GAMES);
	eval 'sub GID_DIALER () {68;}' unless defined(&GID_DIALER);
    }
}
1;
