require '_h2ph_pre.ph';

unless(defined(&_SYS_KERNEL_H_)) {
    eval 'sub _SYS_KERNEL_H_ () {1;}' unless defined(&_SYS_KERNEL_H_);
    require 'sys/linker_set.ph';
    if(defined(&KERNEL)) {
    }
    eval("sub SI_SUB_DUMMY () { 0x0000000; }") unless defined(&SI_SUB_DUMMY);
    eval("sub SI_SUB_DONE () { 0x0000001; }") unless defined(&SI_SUB_DONE);
    eval("sub SI_SUB_CONSOLE () { 0x0800000; }") unless defined(&SI_SUB_CONSOLE);
    eval("sub SI_SUB_COPYRIGHT () { 0x0800001; }") unless defined(&SI_SUB_COPYRIGHT);
    eval("sub SI_SUB_VM () { 0x1000000; }") unless defined(&SI_SUB_VM);
    eval("sub SI_SUB_KMEM () { 0x1800000; }") unless defined(&SI_SUB_KMEM);
    eval("sub SI_SUB_CPU () { 0x2000000; }") unless defined(&SI_SUB_CPU);
    eval("sub SI_SUB_KLD () { 0x2100000; }") unless defined(&SI_SUB_KLD);
    eval("sub SI_SUB_DEVFS () { 0x2200000; }") unless defined(&SI_SUB_DEVFS);
    eval("sub SI_SUB_DRIVERS () { 0x2300000; }") unless defined(&SI_SUB_DRIVERS);
    eval("sub SI_SUB_CONFIGURE () { 0x2400000; }") unless defined(&SI_SUB_CONFIGURE);
    eval("sub SI_SUB_INTRINSIC () { 0x2800000; }") unless defined(&SI_SUB_INTRINSIC);
    eval("sub SI_SUB_RUN_QUEUE () { 0x3000000; }") unless defined(&SI_SUB_RUN_QUEUE);
    eval("sub SI_SUB_VM_CONF () { 0x3800000; }") unless defined(&SI_SUB_VM_CONF);
    eval("sub SI_SUB_VFS () { 0x4000000; }") unless defined(&SI_SUB_VFS);
    eval("sub SI_SUB_CLOCKS () { 0x4800000; }") unless defined(&SI_SUB_CLOCKS);
    eval("sub SI_SUB_MBUF () { 0x5000000; }") unless defined(&SI_SUB_MBUF);
    eval("sub SI_SUB_CLIST () { 0x5800000; }") unless defined(&SI_SUB_CLIST);
    eval("sub SI_SUB_SYSV_SHM () { 0x6400000; }") unless defined(&SI_SUB_SYSV_SHM);
    eval("sub SI_SUB_SYSV_SEM () { 0x6800000; }") unless defined(&SI_SUB_SYSV_SEM);
    eval("sub SI_SUB_SYSV_MSG () { 0x6C00000; }") unless defined(&SI_SUB_SYSV_MSG);
    eval("sub SI_SUB_P1003_1B () { 0x6E00000; }") unless defined(&SI_SUB_P1003_1B);
    eval("sub SI_SUB_PSEUDO () { 0x7000000; }") unless defined(&SI_SUB_PSEUDO);
    eval("sub SI_SUB_EXEC () { 0x7400000; }") unless defined(&SI_SUB_EXEC);
    eval("sub SI_SUB_PROTO_BEGIN () { 0x8000000; }") unless defined(&SI_SUB_PROTO_BEGIN);
    eval("sub SI_SUB_PROTO_IF () { 0x8400000; }") unless defined(&SI_SUB_PROTO_IF);
    eval("sub SI_SUB_PROTO_DOMAIN () { 0x8800000; }") unless defined(&SI_SUB_PROTO_DOMAIN);
    eval("sub SI_SUB_PROTO_END () { 0x8ffffff; }") unless defined(&SI_SUB_PROTO_END);
    eval("sub SI_SUB_KPROF () { 0x9000000; }") unless defined(&SI_SUB_KPROF);
    eval("sub SI_SUB_KICK_SCHEDULER () { 0xa000000; }") unless defined(&SI_SUB_KICK_SCHEDULER);
    eval("sub SI_SUB_INT_CONFIG_HOOKS () { 0xa800000; }") unless defined(&SI_SUB_INT_CONFIG_HOOKS);
    eval("sub SI_SUB_ROOT_CONF () { 0xb000000; }") unless defined(&SI_SUB_ROOT_CONF);
    eval("sub SI_SUB_DUMP_CONF () { 0xb200000; }") unless defined(&SI_SUB_DUMP_CONF);
    eval("sub SI_SUB_VINUM () { 0xb300000; }") unless defined(&SI_SUB_VINUM);
    eval("sub SI_SUB_MOUNT_ROOT () { 0xb400000; }") unless defined(&SI_SUB_MOUNT_ROOT);
    eval("sub SI_SUB_ROOT_FDTAB () { 0xb800000; }") unless defined(&SI_SUB_ROOT_FDTAB);
    eval("sub SI_SUB_SWAP () { 0xc000000; }") unless defined(&SI_SUB_SWAP);
    eval("sub SI_SUB_INTRINSIC_POST () { 0xd000000; }") unless defined(&SI_SUB_INTRINSIC_POST);
    eval("sub SI_SUB_KTHREAD_INIT () { 0xe000000; }") unless defined(&SI_SUB_KTHREAD_INIT);
    eval("sub SI_SUB_KTHREAD_PAGE () { 0xe400000; }") unless defined(&SI_SUB_KTHREAD_PAGE);
    eval("sub SI_SUB_KTHREAD_VM () { 0xe800000; }") unless defined(&SI_SUB_KTHREAD_VM);
    eval("sub SI_SUB_KTHREAD_UPDATE () { 0xec00000; }") unless defined(&SI_SUB_KTHREAD_UPDATE);
    eval("sub SI_SUB_KTHREAD_IDLE () { 0xee00000; }") unless defined(&SI_SUB_KTHREAD_IDLE);
    eval("sub SI_SUB_SMP () { 0xf000000; }") unless defined(&SI_SUB_SMP);
    eval("sub SI_SUB_RUN_SCHEDULER () { 0xfffffff; }") unless defined(&SI_SUB_RUN_SCHEDULER);
    eval("sub SI_ORDER_FIRST () { 0x0000000; }") unless defined(&SI_ORDER_FIRST);
    eval("sub SI_ORDER_SECOND () { 0x0000001; }") unless defined(&SI_ORDER_SECOND);
    eval("sub SI_ORDER_THIRD () { 0x0000002; }") unless defined(&SI_ORDER_THIRD);
    eval("sub SI_ORDER_MIDDLE () { 0x1000000; }") unless defined(&SI_ORDER_MIDDLE);
    eval("sub SI_ORDER_ANY () { 0xfffffff; }") unless defined(&SI_ORDER_ANY);
    eval("sub SI_TYPE_DEFAULT () { 0x00000000; }") unless defined(&SI_TYPE_DEFAULT);
    eval("sub SI_TYPE_KTHREAD () { 0x00000001; }") unless defined(&SI_TYPE_KTHREAD);
    eval("sub SI_TYPE_KPROCESS () { 0x00000002; }") unless defined(&SI_TYPE_KPROCESS);
    eval 'sub SYSINIT {
        local($uniquifier, $subsystem, $order, $func, $ident) = @_;
	    eval q( &static \'struct sysinit\' $uniquifier   &_sys_init = { $subsystem, $order, $func, $ident,  &SI_TYPE_DEFAULT };  &DATA_SET( &sysinit_set,$uniquifier   &_sys_init););
    }' unless defined(&SYSINIT);
    eval 'sub SYSUNINIT {
        local($uniquifier, $subsystem, $order, $func, $ident) = @_;
	    eval q( &static \'struct sysinit\' $uniquifier   &_sys_uninit = { $subsystem, $order, $func, $ident,  &SI_TYPE_DEFAULT };  &DATA_SET( &sysuninit_set,$uniquifier   &_sys_uninit));
    }' unless defined(&SYSUNINIT);
    eval 'sub SYSINIT_KT {
        local($uniquifier, $subsystem, $order, $func, $ident) = @_;
	    eval q( &static \'struct sysinit\' $uniquifier   &_sys_init = { $subsystem, $order, $func, $ident,  &SI_TYPE_KTHREAD };  &DATA_SET( &sysinit_set,$uniquifier   &_sys_init););
    }' unless defined(&SYSINIT_KT);
    eval 'sub SYSINIT_KP {
        local($uniquifier, $subsystem, $order, $func, $ident) = @_;
	    eval q( &static \'struct sysinit\' $uniquifier   &_sys_init = { $subsystem, $order, $func, $ident,  &SI_TYPE_KPROCESS };  &DATA_SET( &sysinit_set,$uniquifier   &_sys_init););
    }' unless defined(&SYSINIT_KP);
    if(defined(&PSEUDO_LKM)) {
	require 'sys/conf.ph';
	require 'sys/exec.ph';
	require 'sys/sysent.ph';
	require 'sys/lkm.ph';
	eval 'sub PSEUDO_SET {
	    local($init, $name) = @_;
    	    eval q( &extern \'struct linker_set\'  &MODVNOPS;  &MOD_MISC;  &static \'int\' $name   &_load(\'struct lkm_table\' * &lkmtp, \'int\'  &cmd) { $init( &NULL );  &return 0; }  &static \'int\' $name   &_unload(\'struct lkm_table\' * &lkmtp, \'int\'  &cmd) {  &return  &EINVAL; } \'int\' $name   &_mod(\'struct lkm_table\' * &lkmtp, \'int\'  &cmd, \'int\'  &ver) {  &MOD_DISPATCH($name,  &lkmtp,  &cmd,  &ver, $name   &_load, $name   &_unload,  &lkm_nullcmd); } \'struct __hack\');
	}' unless defined(&PSEUDO_SET);
    } else {
	require 'sys/module.ph';
	eval 'sub PSEUDO_SET {
	    local($sym, $name) = @_;
    	    eval q( &static \'int\' $name   &_modevent( &module_t  &mod, \'int\'  &type,  &void * &data) {  &void (* &initfunc) = ( &void (*)) &data;  &switch {  &case  &MOD_LOAD:  &initfunc;  &break;  &case  &MOD_UNLOAD:  &printf($name \\" module unload - not possible for this module type\\\\n\\");  &return  &EINVAL; }  &return 0; }  &static  &moduledata_t $name   &_mod = { $name, $name   &_modevent, $sym };  &DECLARE_MODULE($name, $name   &_mod,  &SI_SUB_PSEUDO,  &SI_ORDER_ANY));
	}' unless defined(&PSEUDO_SET);
    }
}
1;
