require '_h2ph_pre.ph';

unless(defined(&_LOCK_H_)) {
    eval 'sub _LOCK_H_ () {1;}' unless defined(&_LOCK_H_);
    require 'machine/lock.ph';
    if(defined(&DEBUG_LOCKS)) {
    }
    eval 'sub LK_TYPE_MASK () {0x0000000f;}' unless defined(&LK_TYPE_MASK);
    eval 'sub LK_SHARED () {0x00000001;}' unless defined(&LK_SHARED);
    eval 'sub LK_EXCLUSIVE () {0x00000002;}' unless defined(&LK_EXCLUSIVE);
    eval 'sub LK_UPGRADE () {0x00000003;}' unless defined(&LK_UPGRADE);
    eval 'sub LK_EXCLUPGRADE () {0x00000004;}' unless defined(&LK_EXCLUPGRADE);
    eval 'sub LK_DOWNGRADE () {0x00000005;}' unless defined(&LK_DOWNGRADE);
    eval 'sub LK_RELEASE () {0x00000006;}' unless defined(&LK_RELEASE);
    eval 'sub LK_DRAIN () {0x00000007;}' unless defined(&LK_DRAIN);
    eval 'sub LK_EXTFLG_MASK () {0x01000070;}' unless defined(&LK_EXTFLG_MASK);
    eval 'sub LK_NOWAIT () {0x00000010;}' unless defined(&LK_NOWAIT);
    eval 'sub LK_SLEEPFAIL () {0x00000020;}' unless defined(&LK_SLEEPFAIL);
    eval 'sub LK_CANRECURSE () {0x00000040;}' unless defined(&LK_CANRECURSE);
    eval 'sub LK_REENABLE () {0x00000080;}' unless defined(&LK_REENABLE);
    eval 'sub LK_NOPAUSE () {0x01000000;}' unless defined(&LK_NOPAUSE);
    eval 'sub LK_WANT_UPGRADE () {0x00000100;}' unless defined(&LK_WANT_UPGRADE);
    eval 'sub LK_WANT_EXCL () {0x00000200;}' unless defined(&LK_WANT_EXCL);
    eval 'sub LK_HAVE_EXCL () {0x00000400;}' unless defined(&LK_HAVE_EXCL);
    eval 'sub LK_WAITDRAIN () {0x00000800;}' unless defined(&LK_WAITDRAIN);
    eval 'sub LK_DRAINING () {0x00004000;}' unless defined(&LK_DRAINING);
    eval 'sub LK_DRAINED () {0x00008000;}' unless defined(&LK_DRAINED);
    eval 'sub LK_INTERLOCK () {0x00010000;}' unless defined(&LK_INTERLOCK);
    eval 'sub LK_RETRY () {0x00020000;}' unless defined(&LK_RETRY);
    eval 'sub LK_NOOBJ () {0x00040000;}' unless defined(&LK_NOOBJ);
    eval 'sub LK_SHARE_NONZERO () {0x00100000;}' unless defined(&LK_SHARE_NONZERO);
    eval 'sub LK_WAIT_NONZERO () {0x00200000;}' unless defined(&LK_WAIT_NONZERO);
    eval 'sub LK_KERNPROC () {(( &pid_t) -2);}' unless defined(&LK_KERNPROC);
    eval 'sub LK_NOPROC () {(( &pid_t) -1);}' unless defined(&LK_NOPROC);
    if(defined(&DEBUG_LOCKS)) {
	eval 'sub lockmgr {
	    local($lockp, $flags, $slockp, $proc) = @_;
    	    eval q( &debuglockmgr(($lockp), ($flags), ($slockp), ($proc), \\"lockmgr\\",  &__FILE__,  &__LINE__));
	}' unless defined(&lockmgr);
    } else {
    }
    if(defined(&SIMPLELOCK_DEBUG)) {
	eval 'sub simple_unlock {
	    local($alp) = @_;
    	    eval q( &_simple_unlock($alp,  &__FILE__,  &__LINE__));
	}' unless defined(&simple_unlock);
	eval 'sub simple_lock_try {
	    local($alp) = @_;
    	    eval q( &_simple_lock_try($alp,  &__FILE__,  &__LINE__));
	}' unless defined(&simple_lock_try);
	eval 'sub simple_lock {
	    local($alp) = @_;
    	    eval q( &_simple_lock($alp,  &__FILE__,  &__LINE__));
	}' unless defined(&simple_lock);
    } else {
	if((defined(&NCPUS) ? &NCPUS : 0) == 1) {
	    eval 'sub NULL_SIMPLELOCKS () {1;}' unless defined(&NULL_SIMPLELOCKS);
	    eval 'sub simple_lock_init {
	        local($alp) = @_;
    		eval q();
	    }' unless defined(&simple_lock_init);
	    eval 'sub simple_lock {
	        local($alp) = @_;
    		eval q();
	    }' unless defined(&simple_lock);
	    eval 'sub simple_lock_try {
	        local($alp) = @_;
    		eval q((1));
	    }' unless defined(&simple_lock_try);
	    eval 'sub simple_unlock {
	        local($alp) = @_;
    		eval q();
	    }' unless defined(&simple_unlock);
	}
    }
}
1;
