require '_h2ph_pre.ph';

unless(defined(&_SYS_MBUF_H_)) {
    eval 'sub _SYS_MBUF_H_ () {1;}' unless defined(&_SYS_MBUF_H_);
    eval 'sub MLEN () {( &MSIZE - $sizeof{\'struct m_hdr\'});}' unless defined(&MLEN);
    eval 'sub MHLEN () {( &MLEN - $sizeof{\'struct pkthdr\'});}' unless defined(&MHLEN);
    eval 'sub MINCLSIZE () {( &MHLEN + 1);}' unless defined(&MINCLSIZE);
    eval 'sub M_MAXCOMPRESS () {( &MHLEN / 2);}' unless defined(&M_MAXCOMPRESS);
    eval 'sub mtod {
        local($m, $t) = @_;
	    eval q(((($m)-> &m_data)));
    }' unless defined(&mtod);
    eval 'sub dtom {
        local($x) = @_;
	    eval q(((($x) & ~( &MSIZE-1))));
    }' unless defined(&dtom);
    eval 'sub mtocl {
        local($x) = @_;
	    eval q((( -  &mbutl) >>  &MCLSHIFT));
    }' unless defined(&mtocl);
    eval 'sub cltom {
        local($x) = @_;
	    eval q((( &mbutl + (($x) <<  &MCLSHIFT))));
    }' unless defined(&cltom);
    eval 'sub m_next () { ($m_hdr->{mh_next});}' unless defined(&m_next);
    eval 'sub m_len () { ($m_hdr->{mh_len});}' unless defined(&m_len);
    eval 'sub m_data () { ($m_hdr->{mh_data});}' unless defined(&m_data);
    eval 'sub m_type () { ($m_hdr->{mh_type});}' unless defined(&m_type);
    eval 'sub m_flags () { ($m_hdr->{mh_flags});}' unless defined(&m_flags);
    eval 'sub m_nextpkt () { ($m_hdr->{mh_nextpkt});}' unless defined(&m_nextpkt);
    eval 'sub m_act () { &m_nextpkt;}' unless defined(&m_act);
    eval 'sub m_pkthdr () { ($M_dat->{MH}->{MH_pkthdr});}' unless defined(&m_pkthdr);
    eval 'sub m_ext () { ($M_dat->{MH}->{MH_dat}->{MH_ext});}' unless defined(&m_ext);
    eval 'sub m_pktdat () { ($M_dat->{MH}->{MH_dat}->{MH_databuf});}' unless defined(&m_pktdat);
    eval 'sub m_dat () { ($M_dat->{M_databuf});}' unless defined(&m_dat);
    eval 'sub M_EXT () {0x0001;}' unless defined(&M_EXT);
    eval 'sub M_PKTHDR () {0x0002;}' unless defined(&M_PKTHDR);
    eval 'sub M_EOR () {0x0004;}' unless defined(&M_EOR);
    eval 'sub M_PROTO1 () {0x0008;}' unless defined(&M_PROTO1);
    eval 'sub M_PROTO2 () {0x0010;}' unless defined(&M_PROTO2);
    eval 'sub M_PROTO3 () {0x0020;}' unless defined(&M_PROTO3);
    eval 'sub M_PROTO4 () {0x0040;}' unless defined(&M_PROTO4);
    eval 'sub M_PROTO5 () {0x0080;}' unless defined(&M_PROTO5);
    eval 'sub M_BCAST () {0x0100;}' unless defined(&M_BCAST);
    eval 'sub M_MCAST () {0x0200;}' unless defined(&M_MCAST);
    eval 'sub M_FRAG () {0x0400;}' unless defined(&M_FRAG);
    eval 'sub M_COPYFLAGS () {( &M_PKTHDR| &M_EOR| &M_PROTO1| &M_PROTO1| &M_PROTO2| &M_PROTO3 |  &M_PROTO4| &M_PROTO5| &M_BCAST| &M_MCAST| &M_FRAG);}' unless defined(&M_COPYFLAGS);
    eval 'sub MT_FREE () {0;}' unless defined(&MT_FREE);
    eval 'sub MT_DATA () {1;}' unless defined(&MT_DATA);
    eval 'sub MT_HEADER () {2;}' unless defined(&MT_HEADER);
    if(0) {
	eval 'sub MT_SOCKET () {3;}' unless defined(&MT_SOCKET);
	eval 'sub MT_PCB () {4;}' unless defined(&MT_PCB);
	eval 'sub MT_RTABLE () {5;}' unless defined(&MT_RTABLE);
	eval 'sub MT_HTABLE () {6;}' unless defined(&MT_HTABLE);
	eval 'sub MT_ATABLE () {7;}' unless defined(&MT_ATABLE);
    }
    eval 'sub MT_SONAME () {8;}' unless defined(&MT_SONAME);
    if(0) {
	eval 'sub MT_SOOPTS () {10;}' unless defined(&MT_SOOPTS);
    }
    eval 'sub MT_FTABLE () {11;}' unless defined(&MT_FTABLE);
    if(0) {
	eval 'sub MT_RIGHTS () {12;}' unless defined(&MT_RIGHTS);
	eval 'sub MT_IFADDR () {13;}' unless defined(&MT_IFADDR);
    }
    eval 'sub MT_CONTROL () {14;}' unless defined(&MT_CONTROL);
    eval 'sub MT_OOBDATA () {15;}' unless defined(&MT_OOBDATA);
    eval 'sub M_DONTWAIT () {1;}' unless defined(&M_DONTWAIT);
    eval 'sub M_WAIT () {0;}' unless defined(&M_WAIT);
    eval 'sub MGETHDR_C () {1;}' unless defined(&MGETHDR_C);
    eval 'sub MGET_C () {2;}' unless defined(&MGET_C);
    eval 'sub MMBWAKEUP () {
        eval q( &do {  &if ( &m_mballoc_wid) {  &m_mballoc_wid--;  &wakeup_one( &m_mballoc_wid); } }  &while (0));
    }' unless defined(&MMBWAKEUP);
    eval 'sub MCLWAKEUP () {
        eval q( &do {  &if ( &m_clalloc_wid) {  &m_clalloc_wid--;  &wakeup_one( &m_clalloc_wid); } }  &while (0));
    }' unless defined(&MCLWAKEUP);
    eval 'sub MBUFLOCK {
        local($code) = @_;
	    eval q( &do { \'int\'  &_ms =  &splimp(); { $code }  &splx( &_ms); }  &while (0));
    }' unless defined(&MBUFLOCK);
    eval 'sub MGET {
        local($m, $how, $type) = @_;
	    eval q( &do { \'struct mbuf\' * &_mm; \'int\'  &_mhow = ; \'int\'  &_mtype = ; \'int\'  &_ms =  &splimp();  &if ( &mmbfree ==  &NULL)  &m_mballoc(1,  &_mhow);  &_mm =  &mmbfree;  &if ( &_mm !=  &NULL) {  &mmbfree =  ($_mm->{m_next});  ($mbstat->{m_mtypes[&MT_FREE]})--;  ($_mm->{m_type}) =  &_mtype;  ($mbstat->{m_mtypes[&_mtype]})++;  ($_mm->{m_next}) =  &NULL;  ($_mm->{m_nextpkt}) =  &NULL;  ($_mm->{m_data}) =  ($_mm->{m_dat});  ($_mm->{m_flags}) = 0; ($m) =  &_mm;  &splx( &_ms); }  &else {  &splx( &_ms);  &_mm =  &m_retry( &_mhow,  &_mtype);  &if ( &_mm ==  &NULL  &&  &_mhow ==  &M_WAIT) ($m) =  &m_mballoc_wait( &MGET_C,  &_mtype);  &else ($m) =  &_mm; } }  &while (0));
    }' unless defined(&MGET);
    eval 'sub MGETHDR {
        local($m, $how, $type) = @_;
	    eval q( &do { \'struct mbuf\' * &_mm; \'int\'  &_mhow = ; \'int\'  &_mtype = ; \'int\'  &_ms =  &splimp();  &if ( &mmbfree ==  &NULL)  &m_mballoc(1,  &_mhow);  &_mm =  &mmbfree;  &if ( &_mm !=  &NULL) {  &mmbfree =  ($_mm->{m_next});  ($mbstat->{m_mtypes[&MT_FREE]})--;  ($_mm->{m_type}) =  &_mtype;  ($mbstat->{m_mtypes[&_mtype]})++;  ($_mm->{m_next}) =  &NULL;  ($_mm->{m_nextpkt}) =  &NULL;  ($_mm->{m_data}) =  ($_mm->{m_pktdat});  ($_mm->{m_flags}) =  &M_PKTHDR;  ($_mm->{m_pkthdr}->{rcvif}) =  &NULL; ($m) =  &_mm;  &splx( &_ms); }  &else {  &splx( &_ms);  &_mm =  &m_retryhdr( &_mhow,  &_mtype);  &if ( &_mm ==  &NULL  &&  &_mhow ==  &M_WAIT) ($m) =  &m_mballoc_wait( &MGETHDR_C,  &_mtype);  &else ($m) =  &_mm; } }  &while (0));
    }' unless defined(&MGETHDR);
    eval 'sub MCLALLOC {
        local($p, $how) = @_;
	    eval q( &do { \'caddr_t\'  &_mp; \'int\'  &_mhow = ; \'int\'  &_ms =  &splimp();  &if ( &mclfree ==  &NULL)  &m_clalloc(1,  &_mhow);  &_mp =  &mclfree;  &if ( &_mp !=  &NULL) {  $mclrefcnt[ &mtocl]++;  ($mbstat->{m_clfree})--;  &mclfree = ( &_mp)-> &mcl_next; ($p) =  &_mp;  &splx( &_ms); }  &else {  &splx( &_ms);  &if ( &_mhow ==  &M_WAIT) ($p) =  &m_clalloc_wait();  &else ($p) =  &NULL; } }  &while (0));
    }' unless defined(&MCLALLOC);
    eval 'sub MCLGET {
        local($m, $how) = @_;
	    eval q( &do { \'struct mbuf\' * &_mm = ($m);  &MCLALLOC( ($_mm->{m_ext}->{ext_buf}), ($how));  &if ( ($_mm->{m_ext}->{ext_buf}) !=  &NULL) {  ($_mm->{m_data}) =  ($_mm->{m_ext}->{ext_buf});  ($_mm->{m_flags}) |=  &M_EXT;  ($_mm->{m_ext}->{ext_free}) =  &NULL;  ($_mm->{m_ext}->{ext_ref}) =  &NULL;  ($_mm->{m_ext}->{ext_size}) =  &MCLBYTES; } }  &while (0));
    }' unless defined(&MCLGET);
    eval 'sub MCLFREE1 {
        local($p) = @_;
	    eval q( &do {  &union  &mcluster * &_mp = ($p);  &KASSERT( $mclrefcnt[ &mtocl( &_mp)] > 0, (\\"freeing free cluster\\"));  &if (-- $mclrefcnt[ &mtocl( &_mp)] == 0) {  ($_mp->{mcl_next}) =  &mclfree;  &mclfree =  &_mp;  ($mbstat->{m_clfree})++;  &MCLWAKEUP(); } }  &while (0));
    }' unless defined(&MCLFREE1);
    eval 'sub MCLFREE {
        local($p) = @_;
	    eval q( &MBUFLOCK(  &MCLFREE1($p); ));
    }' unless defined(&MCLFREE);
    eval 'sub MEXTFREE1 {
        local($m) = @_;
	    eval q( &do { \'struct mbuf\' * &_mm = ($m);  &if ( ($_mm->{m_ext}->{ext_free}) !=  &NULL) (* ($_mm->{m_ext}->{ext_free}))( ($_mm->{m_ext}->{ext_buf}),  ($_mm->{m_ext}->{ext_size}));  &else  &MCLFREE1( ($_mm->{m_ext}->{ext_buf})); }  &while (0));
    }' unless defined(&MEXTFREE1);
    eval 'sub MEXTFREE {
        local($m) = @_;
	    eval q( &MBUFLOCK(  &MEXTFREE1($m); ));
    }' unless defined(&MEXTFREE);
    eval 'sub MFREE {
        local($m, $n) = @_;
	    eval q( &MBUFLOCK( \'struct mbuf\' * &_mm = ($m);  &KASSERT( ($_mm->{m_type}) !=  &MT_FREE, (\\"freeing free mbuf\\"));  ($mbstat->{m_mtypes[&_mm}->{m_type]})--;  &if ( ($_mm->{m_flags}) &  &M_EXT)  &MEXTFREE1($m); ($n) =  ($_mm->{m_next});  ($_mm->{m_type}) =  &MT_FREE;  ($mbstat->{m_mtypes[&MT_FREE]})++;  ($_mm->{m_next}) =  &mmbfree;  &mmbfree =  &_mm;  &MMBWAKEUP(); ));
    }' unless defined(&MFREE);
    eval 'sub M_COPY_PKTHDR {
        local($to, $from) = @_;
	    eval q( &do { \'struct mbuf\' * &_mfrom = ($from); \'struct mbuf\' * &_mto = ($to);  ($_mto->{m_data}) =  ($_mto->{m_pktdat});  ($_mto->{m_flags}) =  ($_mfrom->{m_flags}) &  &M_COPYFLAGS;  ($_mto->{m_pkthdr}) =  ($_mfrom->{m_pkthdr}); }  &while (0));
    }' unless defined(&M_COPY_PKTHDR);
    eval 'sub M_ALIGN {
        local($m, $len) = @_;
	    eval q( &do { ($m)-> &m_data += ( &MLEN - ($len)) & ~($sizeof{\'long\'} - 1); }  &while (0));
    }' unless defined(&M_ALIGN);
    eval 'sub MH_ALIGN {
        local($m, $len) = @_;
	    eval q( &do { ($m)-> &m_data += ( &MHLEN - ($len)) & ~($sizeof{\'long\'} - 1); }  &while (0));
    }' unless defined(&MH_ALIGN);
    eval 'sub M_LEADINGSPACE {
        local($m) = @_;
	    eval q((($m)-> &m_flags &  &M_EXT ? 0: ($m)-> &m_flags &  &M_PKTHDR ? ($m)-> &m_data - ($m)-> &m_pktdat : ($m)-> &m_data - ($m)-> &m_dat));
    }' unless defined(&M_LEADINGSPACE);
    eval 'sub M_TRAILINGSPACE {
        local($m) = @_;
	    eval q((($m)-> &m_flags &  &M_EXT ? ($m)-> ($m_ext->{ext_buf}) + ($m)-> ($m_ext->{ext_size}) - (($m)-> &m_data + ($m)-> &m_len) : ($m)-> $m_dat[ &MLEN] - (($m)-> &m_data + ($m)-> &m_len)));
    }' unless defined(&M_TRAILINGSPACE);
    eval 'sub M_PREPEND {
        local($m, $plen, $how) = @_;
	    eval q( &do { \'struct mbuf\' ** &_mmp = ($m); \'struct mbuf\' * &_mm = * &_mmp; \'int\'  &_mplen = ($plen); \'int\'  &__mhow = ($how);  &if ( &M_LEADINGSPACE( &_mm) >=  &_mplen) {  ($_mm->{m_data}) -=  &_mplen;  ($_mm->{m_len}) +=  &_mplen; }  &else  &_mm =  &m_prepend( &_mm,  &_mplen,  &__mhow);  &if ( &_mm !=  &NULL  &&  ($_mm->{m_flags}) &  &M_PKTHDR)  ($_mm->{m_pkthdr}->{len}) +=  &_mplen; * &_mmp =  &_mm; }  &while (0));
    }' unless defined(&M_PREPEND);
    eval 'sub MCHTYPE {
        local($m, $t) = @_;
	    eval q( &do { \'struct mbuf\' * &_mm = ($m); \'int\'  &_mt = ($t); \'int\'  &_ms =  &splimp();  ($mbstat->{m_mtypes[&_mm}->{m_type]})--;  ($mbstat->{m_mtypes[&_mt]})++;  &splx( &_ms);  ($_mm->{m_type}) = ( &_mt); }  &while (0));
    }' unless defined(&MCHTYPE);
    eval 'sub M_COPYALL () {1000000000;}' unless defined(&M_COPYALL);
    eval 'sub m_copy {
        local($m, $o, $l) = @_;
	    eval q( &m_copym(($m), ($o), ($l),  &M_DONTWAIT));
    }' unless defined(&m_copy);
    if(defined(&KERNEL)) {
    }
}
1;
