require '_h2ph_pre.ph';

unless(defined(&_SYS_MOUNT_H_)) {
    eval 'sub _SYS_MOUNT_H_ () {1;}' unless defined(&_SYS_MOUNT_H_);
    require 'sys/ucred.ph';
    require 'sys/queue.ph';
    require 'sys/lock.ph';
    eval 'sub MAXFIDSZ () {16;}' unless defined(&MAXFIDSZ);
    eval 'sub MFSNAMELEN () {16;}' unless defined(&MFSNAMELEN);
    eval 'sub MNAMELEN () {90;}' unless defined(&MNAMELEN);
    eval 'sub MNT_RDONLY () {0x00000001;}' unless defined(&MNT_RDONLY);
    eval 'sub MNT_SYNCHRONOUS () {0x00000002;}' unless defined(&MNT_SYNCHRONOUS);
    eval 'sub MNT_NOEXEC () {0x00000004;}' unless defined(&MNT_NOEXEC);
    eval 'sub MNT_NOSUID () {0x00000008;}' unless defined(&MNT_NOSUID);
    eval 'sub MNT_NODEV () {0x00000010;}' unless defined(&MNT_NODEV);
    eval 'sub MNT_UNION () {0x00000020;}' unless defined(&MNT_UNION);
    eval 'sub MNT_ASYNC () {0x00000040;}' unless defined(&MNT_ASYNC);
    eval 'sub MNT_SUIDDIR () {0x00100000;}' unless defined(&MNT_SUIDDIR);
    eval 'sub MNT_SOFTDEP () {0x00200000;}' unless defined(&MNT_SOFTDEP);
    eval 'sub MNT_NOSYMFOLLOW () {0x00400000;}' unless defined(&MNT_NOSYMFOLLOW);
    eval 'sub MNT_NOATIME () {0x10000000;}' unless defined(&MNT_NOATIME);
    eval 'sub MNT_NOCLUSTERR () {0x40000000;}' unless defined(&MNT_NOCLUSTERR);
    eval 'sub MNT_NOCLUSTERW () {0x80000000;}' unless defined(&MNT_NOCLUSTERW);
    eval 'sub MNT_EXRDONLY () {0x00000080;}' unless defined(&MNT_EXRDONLY);
    eval 'sub MNT_EXPORTED () {0x00000100;}' unless defined(&MNT_EXPORTED);
    eval 'sub MNT_DEFEXPORTED () {0x00000200;}' unless defined(&MNT_DEFEXPORTED);
    eval 'sub MNT_EXPORTANON () {0x00000400;}' unless defined(&MNT_EXPORTANON);
    eval 'sub MNT_EXKERB () {0x00000800;}' unless defined(&MNT_EXKERB);
    eval 'sub MNT_EXPUBLIC () {0x20000000;}' unless defined(&MNT_EXPUBLIC);
    eval 'sub MNT_LOCAL () {0x00001000;}' unless defined(&MNT_LOCAL);
    eval 'sub MNT_QUOTA () {0x00002000;}' unless defined(&MNT_QUOTA);
    eval 'sub MNT_ROOTFS () {0x00004000;}' unless defined(&MNT_ROOTFS);
    eval 'sub MNT_USER () {0x00008000;}' unless defined(&MNT_USER);
    eval 'sub MNT_VISFLAGMASK () {( &MNT_RDONLY |  &MNT_SYNCHRONOUS |  &MNT_NOEXEC |  &MNT_NOSUID |  &MNT_NODEV |  &MNT_UNION |  &MNT_ASYNC |  &MNT_EXRDONLY |  &MNT_EXPORTED |  &MNT_DEFEXPORTED |  &MNT_EXPORTANON|  &MNT_EXKERB |  &MNT_LOCAL |  &MNT_USER |  &MNT_QUOTA |  &MNT_ROOTFS |  &MNT_NOATIME |  &MNT_NOCLUSTERR|  &MNT_NOCLUSTERW |  &MNT_SUIDDIR |  &MNT_SOFTDEP );}' unless defined(&MNT_VISFLAGMASK);
    eval 'sub MNT_UPDATE () {0x00010000;}' unless defined(&MNT_UPDATE);
    eval 'sub MNT_DELEXPORT () {0x00020000;}' unless defined(&MNT_DELEXPORT);
    eval 'sub MNT_RELOAD () {0x00040000;}' unless defined(&MNT_RELOAD);
    eval 'sub MNT_FORCE () {0x00080000;}' unless defined(&MNT_FORCE);
    eval 'sub MNT_CMDFLAGS () {( &MNT_UPDATE| &MNT_DELEXPORT| &MNT_RELOAD| &MNT_FORCE);}' unless defined(&MNT_CMDFLAGS);
    eval 'sub MNTK_UNMOUNT () {0x01000000;}' unless defined(&MNTK_UNMOUNT);
    eval 'sub MNTK_MWAIT () {0x02000000;}' unless defined(&MNTK_MWAIT);
    eval 'sub MNTK_WANTRDWR () {0x04000000;}' unless defined(&MNTK_WANTRDWR);
    eval 'sub VFS_VFSCONF () {0;}' unless defined(&VFS_VFSCONF);
    eval 'sub VFS_GENERIC () {0;}' unless defined(&VFS_GENERIC);
    eval 'sub VFS_MAXTYPENUM () {1;}' unless defined(&VFS_MAXTYPENUM);
    eval 'sub VFS_CONF () {2;}' unless defined(&VFS_CONF);
    eval 'sub MNT_WAIT () {1;}' unless defined(&MNT_WAIT);
    eval 'sub MNT_NOWAIT () {2;}' unless defined(&MNT_NOWAIT);
    eval 'sub MNT_LAZY () {3;}' unless defined(&MNT_LAZY);
    eval 'sub VFCF_STATIC () {0x00010000;}' unless defined(&VFCF_STATIC);
    eval 'sub VFCF_NETWORK () {0x00020000;}' unless defined(&VFCF_NETWORK);
    eval 'sub VFCF_READONLY () {0x00040000;}' unless defined(&VFCF_READONLY);
    eval 'sub VFCF_SYNTHETIC () {0x00080000;}' unless defined(&VFCF_SYNTHETIC);
    eval 'sub VFCF_LOOPBACK () {0x00100000;}' unless defined(&VFCF_LOOPBACK);
    eval 'sub VFCF_UNICODE () {0x00200000;}' unless defined(&VFCF_UNICODE);
    if(defined(&KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
	if(defined(&__STDC__)) {
	}
	eval 'sub VFS_MOUNT {
	    local($MP, $PATH, $DATA, $NDP, $P) = @_;
    	    eval q((*($MP)-> ($mnt_op->{vfs_mount}))($MP, $PATH, $DATA, $NDP, $P));
	}' unless defined(&VFS_MOUNT);
	eval 'sub VFS_START {
	    local($MP, $FLAGS, $P) = @_;
    	    eval q((*($MP)-> ($mnt_op->{vfs_start}))($MP, $FLAGS, $P));
	}' unless defined(&VFS_START);
	eval 'sub VFS_UNMOUNT {
	    local($MP, $FORCE, $P) = @_;
    	    eval q((*($MP)-> ($mnt_op->{vfs_unmount}))($MP, $FORCE, $P));
	}' unless defined(&VFS_UNMOUNT);
	eval 'sub VFS_ROOT {
	    local($MP, $VPP) = @_;
    	    eval q((*($MP)-> ($mnt_op->{vfs_root}))($MP, $VPP));
	}' unless defined(&VFS_ROOT);
	eval 'sub VFS_QUOTACTL {
	    local($MP,$C,$U,$A,$P) = @_;
    	    eval q((*($MP)-> ($mnt_op->{vfs_quotactl}))($MP, $C, $U, $A, $P));
	}' unless defined(&VFS_QUOTACTL);
	eval 'sub VFS_STATFS {
	    local($MP, $SBP, $P) = @_;
    	    eval q((*($MP)-> ($mnt_op->{vfs_statfs}))($MP, $SBP, $P));
	}' unless defined(&VFS_STATFS);
	eval 'sub VFS_SYNC {
	    local($MP, $WAIT, $C, $P) = @_;
    	    eval q((*($MP)-> ($mnt_op->{vfs_sync}))($MP, $WAIT, $C, $P));
	}' unless defined(&VFS_SYNC);
	eval 'sub VFS_VGET {
	    local($MP, $INO, $VPP) = @_;
    	    eval q((*($MP)-> ($mnt_op->{vfs_vget}))($MP, $INO, $VPP));
	}' unless defined(&VFS_VGET);
	eval 'sub VFS_FHTOVP {
	    local($MP, $FIDP, $NAM, $VPP, $EXFLG, $CRED) = @_;
    	    eval q((*($MP)-> ($mnt_op->{vfs_fhtovp}))($MP, $FIDP, $NAM, $VPP, $EXFLG, $CRED));
	}' unless defined(&VFS_FHTOVP);
	eval 'sub VFS_VPTOFH {
	    local($VP, $FIDP) = @_;
    	    eval q((*($VP)-> ($v_mount->{mnt_op}->{vfs_vptofh}))($VP, $FIDP));
	}' unless defined(&VFS_VPTOFH);
	if(defined( &VFS_LKM)  && !defined( &KLD_MODULE)) {
	    require 'sys/conf.ph';
	    require 'sys/exec.ph';
	    require 'sys/sysent.ph';
	    require 'sys/lkm.ph';
	    eval 'sub VFS_SET {
	        local($vfsops, $fsname, $flags) = @_;
    		eval q( &static \'struct vfsconf\'  &_fs_vfsconf = { $vfsops, $fsname, -1, 0, $flags, };  &extern \'struct linker_set\'  &MODVNOPS;  &MOD_VFS($fsname, &MODVNOPS,& &_fs_vfsconf); \'int\' $fsname   &_mod(\'struct lkm_table\' * &lkmtp, \'int\'  &cmd, \'int\'  &ver); \'int\' $fsname   &_mod(\'struct lkm_table\' * &lkmtp, \'int\'  &cmd, \'int\'  &ver) {  &MOD_DISPATCH($fsname,  &lkmtp,  &cmd,  &ver,  &lkm_nullcmd,  &lkm_nullcmd,  &lkm_nullcmd); } \'struct __hack\');
	    }' unless defined(&VFS_SET);
	} else {
	    require 'sys/module.ph';
	    eval 'sub VFS_SET {
	        local($vfsops, $fsname, $flags) = @_;
    		eval q( &static \'struct vfsconf\' $fsname   &_vfsconf = { $vfsops, $fsname, -1, 0, $flags };  &static  &moduledata_t $fsname   &_mod = { $fsname,  &vfs_modevent, & $fsname   &_vfsconf };  &DECLARE_MODULE($fsname, $fsname   &_mod,  &SI_SUB_VFS,  &SI_ORDER_MIDDLE));
	    }' unless defined(&VFS_SET);
	}
	require 'net/radix.ph';
	eval 'sub AF_MAX () {33;}' unless defined(&AF_MAX);
    } else {
	require 'sys/cdefs.ph';
	eval 'sub getvfsbyname () { &new_getvfsbyname;}' unless defined(&getvfsbyname);
    }
}
1;
