require '_h2ph_pre.ph';

unless(defined(&_SYS_PARAM_H_)) {
    eval 'sub _SYS_PARAM_H_ () {1;}' unless defined(&_SYS_PARAM_H_);
    eval 'sub BSD () {199506;}' unless defined(&BSD);
    eval 'sub BSD4_3 () {1;}' unless defined(&BSD4_3);
    eval 'sub BSD4_4 () {1;}' unless defined(&BSD4_4);
    undef(&__FreeBSD_version) if defined(&__FreeBSD_version);
    eval 'sub __FreeBSD_version () {340001;}' unless defined(&__FreeBSD_version);
    unless(defined(&NULL)) {
	eval 'sub NULL () {0;}' unless defined(&NULL);
    }
    unless(defined(&LOCORE)) {
	require 'sys/types.ph';
    }
    require 'sys/syslimits.ph';
    eval 'sub MAXCOMLEN () {16;}' unless defined(&MAXCOMLEN);
    eval 'sub MAXINTERP () {32;}' unless defined(&MAXINTERP);
    eval 'sub MAXLOGNAME () {17;}' unless defined(&MAXLOGNAME);
    eval 'sub MAXUPRC () { &CHILD_MAX;}' unless defined(&MAXUPRC);
    eval 'sub NCARGS () { &ARG_MAX;}' unless defined(&NCARGS);
    eval 'sub NGROUPS () { &NGROUPS_MAX;}' unless defined(&NGROUPS);
    eval 'sub NOFILE () { &OPEN_MAX;}' unless defined(&NOFILE);
    eval 'sub NOGROUP () {65535;}' unless defined(&NOGROUP);
    eval 'sub MAXHOSTNAMELEN () {256;}' unless defined(&MAXHOSTNAMELEN);
    if(defined(&KERNEL)) {
	require 'sys/cdefs.ph';
	require 'sys/errno.ph';
	require 'sys/time.ph';
	eval 'sub FALSE () {0;}' unless defined(&FALSE);
	eval 'sub TRUE () {1;}' unless defined(&TRUE);
    }
    unless(defined(&KERNEL)) {
	require 'sys/signal.ph';
    }
    require 'machine/param.ph';
    unless(defined(&KERNEL)) {
	require 'machine/limits.ph';
    }
    eval 'sub PSWP () {0;}' unless defined(&PSWP);
    eval 'sub PVM () {4;}' unless defined(&PVM);
    eval 'sub PINOD () {8;}' unless defined(&PINOD);
    eval 'sub PRIBIO () {16;}' unless defined(&PRIBIO);
    eval 'sub PVFS () {20;}' unless defined(&PVFS);
    eval 'sub PZERO () {22;}' unless defined(&PZERO);
    eval 'sub PSOCK () {24;}' unless defined(&PSOCK);
    eval 'sub PWAIT () {32;}' unless defined(&PWAIT);
    eval 'sub PCONFIG () {32;}' unless defined(&PCONFIG);
    eval 'sub PLOCK () {36;}' unless defined(&PLOCK);
    eval 'sub PPAUSE () {40;}' unless defined(&PPAUSE);
    eval 'sub PUSER () {50;}' unless defined(&PUSER);
    eval 'sub MAXPRI () {127;}' unless defined(&MAXPRI);
    eval 'sub PRIMASK () {0x0ff;}' unless defined(&PRIMASK);
    eval 'sub PCATCH () {0x100;}' unless defined(&PCATCH);
    eval 'sub NZERO () {0;}' unless defined(&NZERO);
    eval 'sub NBPW () {$sizeof{\'int\'};}' unless defined(&NBPW);
    eval 'sub CMASK () {022;}' unless defined(&CMASK);
    eval 'sub NODEV () {(-1);}' unless defined(&NODEV);
    if(0) {
	eval 'sub CLBYTES () {( &CLSIZE* &PAGE_SIZE);}' unless defined(&CLBYTES);
    }
    eval 'sub CBLOCK () {128;}' unless defined(&CBLOCK);
    eval 'sub CBQSIZE () {( &CBLOCK/ &NBBY);}' unless defined(&CBQSIZE);
    eval 'sub CBSIZE () {( &CBLOCK - $sizeof{\'struct cblock\' } -  &CBQSIZE);}' unless defined(&CBSIZE);
    eval 'sub CROUND () {( &CBLOCK - 1);}' unless defined(&CROUND);
    eval 'sub MAXBSIZE () {65536;}' unless defined(&MAXBSIZE);
    eval 'sub BKVASIZE () {8192;}' unless defined(&BKVASIZE);
    eval 'sub DFLTBSIZE () {4096;}' unless defined(&DFLTBSIZE);
    eval 'sub MAXFRAG () {8;}' unless defined(&MAXFRAG);
    eval 'sub MAXPATHLEN () { &PATH_MAX;}' unless defined(&MAXPATHLEN);
    eval 'sub MAXSYMLINKS () {32;}' unless defined(&MAXSYMLINKS);
    eval 'sub setbit {
        local($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] |= 1<<(($i)% &NBBY)));
    }' unless defined(&setbit);
    eval 'sub clrbit {
        local($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] &= ~(1<<(($i)% &NBBY))));
    }' unless defined(&clrbit);
    eval 'sub isset {
        local($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))));
    }' unless defined(&isset);
    eval 'sub isclr {
        local($a,$i) = @_;
	    eval q(((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))) == 0));
    }' unless defined(&isclr);
    unless(defined(&howmany)) {
	eval 'sub howmany {
	    local($x, $y) = @_;
    	    eval q(((($x)+(($y)-1))/($y)));
	}' unless defined(&howmany);
    }
    eval 'sub rounddown {
        local($x, $y) = @_;
	    eval q(((($x)/($y))*($y)));
    }' unless defined(&rounddown);
    eval 'sub roundup {
        local($x, $y) = @_;
	    eval q((((($x)+(($y)-1))/($y))*($y)));
    }' unless defined(&roundup);
    eval 'sub roundup2 {
        local($x, $y) = @_;
	    eval q(((($x)+(($y)-1))(~(($y)-1))));
    }' unless defined(&roundup2);
    eval 'sub powerof2 {
        local($x) = @_;
	    eval q((((($x)-1)($x))==0));
    }' unless defined(&powerof2);
    unless(defined(&KERNEL)) {
	eval 'sub MIN {
	    local($a,$b) = @_;
    	    eval q(((($a)<($b))?($a):($b)));
	}' unless defined(&MIN);
	eval 'sub MAX {
	    local($a,$b) = @_;
    	    eval q(((($a)>($b))?($a):($b)));
	}' unless defined(&MAX);
    }
    if(defined( &__alpha__)) {
	eval 'sub MINBUCKET () {5;}' unless defined(&MINBUCKET);
    } else {
	eval 'sub MINBUCKET () {4;}' unless defined(&MINBUCKET);
    }
    eval 'sub MAXALLOCSAVE () {(2*  &PAGE_SIZE);}' unless defined(&MAXALLOCSAVE);
    eval 'sub FSHIFT () {11;}' unless defined(&FSHIFT);
    eval 'sub FSCALE () {(1<< &FSHIFT);}' unless defined(&FSCALE);
}
1;
