require '_h2ph_pre.ph';

unless(defined(&_SYS_REBOOT_H_)) {
    eval 'sub _SYS_REBOOT_H_ () {1;}' unless defined(&_SYS_REBOOT_H_);
    eval 'sub RB_AUTOBOOT () {0;}' unless defined(&RB_AUTOBOOT);
    eval 'sub RB_ASKNAME () {0x001;}' unless defined(&RB_ASKNAME);
    eval 'sub RB_SINGLE () {0x002;}' unless defined(&RB_SINGLE);
    eval 'sub RB_NOSYNC () {0x004;}' unless defined(&RB_NOSYNC);
    eval 'sub RB_HALT () {0x008;}' unless defined(&RB_HALT);
    eval 'sub RB_INITNAME () {0x010;}' unless defined(&RB_INITNAME);
    eval 'sub RB_DFLTROOT () {0x020;}' unless defined(&RB_DFLTROOT);
    eval 'sub RB_KDB () {0x040;}' unless defined(&RB_KDB);
    eval 'sub RB_RDONLY () {0x080;}' unless defined(&RB_RDONLY);
    eval 'sub RB_DUMP () {0x100;}' unless defined(&RB_DUMP);
    eval 'sub RB_MINIROOT () {0x200;}' unless defined(&RB_MINIROOT);
    eval 'sub RB_CONFIG () {0x400;}' unless defined(&RB_CONFIG);
    eval 'sub RB_VERBOSE () {0x800;}' unless defined(&RB_VERBOSE);
    eval 'sub RB_SERIAL () {0x1000;}' unless defined(&RB_SERIAL);
    eval 'sub RB_CDROM () {0x2000;}' unless defined(&RB_CDROM);
    eval 'sub RB_POWEROFF () {0x4000;}' unless defined(&RB_POWEROFF);
    eval 'sub RB_GDB () {0x8000;}' unless defined(&RB_GDB);
    eval 'sub RB_MUTE () {0x10000;}' unless defined(&RB_MUTE);
    eval 'sub RB_SELFTEST () {0x20000;}' unless defined(&RB_SELFTEST);
    eval 'sub RB_BOOTINFO () {0x80000000;}' unless defined(&RB_BOOTINFO);
    eval 'sub B_ADAPTORSHIFT () {24;}' unless defined(&B_ADAPTORSHIFT);
    eval 'sub B_ADAPTORMASK () {0x0f;}' unless defined(&B_ADAPTORMASK);
    eval 'sub B_ADAPTOR {
        local($val) = @_;
	    eval q(((($val) >>  &B_ADAPTORSHIFT) &  &B_ADAPTORMASK));
    }' unless defined(&B_ADAPTOR);
    eval 'sub B_CONTROLLERSHIFT () {20;}' unless defined(&B_CONTROLLERSHIFT);
    eval 'sub B_CONTROLLERMASK () {0xf;}' unless defined(&B_CONTROLLERMASK);
    eval 'sub B_CONTROLLER {
        local($val) = @_;
	    eval q(((($val)>> &B_CONTROLLERSHIFT) &  &B_CONTROLLERMASK));
    }' unless defined(&B_CONTROLLER);
    eval 'sub B_SLICESHIFT () {20;}' unless defined(&B_SLICESHIFT);
    eval 'sub B_SLICEMASK () {0xff;}' unless defined(&B_SLICEMASK);
    eval 'sub B_SLICE {
        local($val) = @_;
	    eval q(((($val)>> &B_SLICESHIFT) &  &B_SLICEMASK));
    }' unless defined(&B_SLICE);
    eval 'sub B_UNITSHIFT () {16;}' unless defined(&B_UNITSHIFT);
    eval 'sub B_UNITMASK () {0xf;}' unless defined(&B_UNITMASK);
    eval 'sub B_UNIT {
        local($val) = @_;
	    eval q(((($val) >>  &B_UNITSHIFT) &  &B_UNITMASK));
    }' unless defined(&B_UNIT);
    eval 'sub B_PARTITIONSHIFT () {8;}' unless defined(&B_PARTITIONSHIFT);
    eval 'sub B_PARTITIONMASK () {0xff;}' unless defined(&B_PARTITIONMASK);
    eval 'sub B_PARTITION {
        local($val) = @_;
	    eval q(((($val) >>  &B_PARTITIONSHIFT) &  &B_PARTITIONMASK));
    }' unless defined(&B_PARTITION);
    eval 'sub B_TYPESHIFT () {0;}' unless defined(&B_TYPESHIFT);
    eval 'sub B_TYPEMASK () {0xff;}' unless defined(&B_TYPEMASK);
    eval 'sub B_TYPE {
        local($val) = @_;
	    eval q(((($val) >>  &B_TYPESHIFT) &  &B_TYPEMASK));
    }' unless defined(&B_TYPE);
    eval 'sub B_MAGICMASK () {0xf0000000;}' unless defined(&B_MAGICMASK);
    eval 'sub B_DEVMAGIC () {0xa0000000;}' unless defined(&B_DEVMAGIC);
    eval 'sub MAKEBOOTDEV {
        local($type, $adaptor, $controller, $unit, $partition) = @_;
	    eval q(((($type) <<  &B_TYPESHIFT) | (($adaptor) <<  &B_ADAPTORSHIFT) | (($controller) <<  &B_CONTROLLERSHIFT) | (($unit) <<  &B_UNITSHIFT) | (($partition) <<  &B_PARTITIONSHIFT) |  &B_DEVMAGIC));
    }' unless defined(&MAKEBOOTDEV);
}
1;
