require '_h2ph_pre.ph';

unless(defined(&_SYS_SOCKETVAR_H_)) {
    eval 'sub _SYS_SOCKETVAR_H_ () {1;}' unless defined(&_SYS_SOCKETVAR_H_);
    require 'sys/queue.ph';
    require 'sys/select.ph';
    eval 'sub SB_MAX () {(256*1024);}' unless defined(&SB_MAX);
    eval 'sub SB_LOCK () {0x01;}' unless defined(&SB_LOCK);
    eval 'sub SB_WANT () {0x02;}' unless defined(&SB_WANT);
    eval 'sub SB_WAIT () {0x04;}' unless defined(&SB_WAIT);
    eval 'sub SB_SEL () {0x08;}' unless defined(&SB_SEL);
    eval 'sub SB_ASYNC () {0x10;}' unless defined(&SB_ASYNC);
    eval 'sub SB_UPCALL () {0x20;}' unless defined(&SB_UPCALL);
    eval 'sub SB_NOINTR () {0x40;}' unless defined(&SB_NOINTR);
    eval 'sub SS_NOFDREF () {0x0001;}' unless defined(&SS_NOFDREF);
    eval 'sub SS_ISCONNECTED () {0x0002;}' unless defined(&SS_ISCONNECTED);
    eval 'sub SS_ISCONNECTING () {0x0004;}' unless defined(&SS_ISCONNECTING);
    eval 'sub SS_ISDISCONNECTING () {0x0008;}' unless defined(&SS_ISDISCONNECTING);
    eval 'sub SS_CANTSENDMORE () {0x0010;}' unless defined(&SS_CANTSENDMORE);
    eval 'sub SS_CANTRCVMORE () {0x0020;}' unless defined(&SS_CANTRCVMORE);
    eval 'sub SS_RCVATMARK () {0x0040;}' unless defined(&SS_RCVATMARK);
    eval 'sub SS_NBIO () {0x0100;}' unless defined(&SS_NBIO);
    eval 'sub SS_ASYNC () {0x0200;}' unless defined(&SS_ASYNC);
    eval 'sub SS_ISCONFIRMING () {0x0400;}' unless defined(&SS_ISCONFIRMING);
    eval 'sub SS_INCOMP () {0x0800;}' unless defined(&SS_INCOMP);
    eval 'sub SS_COMP () {0x1000;}' unless defined(&SS_COMP);
    eval 'sub SS_ISDISCONNECTED () {0x2000;}' unless defined(&SS_ISDISCONNECTED);
    eval 'sub sb_notify {
        local($sb) = @_;
	    eval q(((($sb)-> &sb_flags & ( &SB_WAIT| &SB_SEL| &SB_ASYNC| &SB_UPCALL)) != 0));
    }' unless defined(&sb_notify);
    eval 'sub sbspace {
        local($sb) = @_;
	    eval q((  &imin((-> &sb_hiwat - -> &sb_cc), (($sb)-> &sb_mbmax - ($sb)-> &sb_mbcnt))));
    }' unless defined(&sbspace);
    eval 'sub sosendallatonce {
        local($so) = @_;
	    eval q((($so)-> ($so_proto->{pr_flags}) &  &PR_ATOMIC));
    }' unless defined(&sosendallatonce);
    eval 'sub soreadable {
        local($so) = @_;
	    eval q((($so)-> ($so_rcv->{sb_cc}) >= ($so)-> ($so_rcv->{sb_lowat}) || (($so)-> &so_state &  &SS_CANTRCVMORE) || ($so)-> ($so_comp->{tqh_first}) || ($so)-> &so_error));
    }' unless defined(&soreadable);
    eval 'sub sowriteable {
        local($so) = @_;
	    eval q((( &sbspace(($so)-> &so_snd) >= ($so)-> ($so_snd->{sb_lowat})  && ((($so)-> &so_state &SS_ISCONNECTED) || (($so)-> ($so_proto->{pr_flags})& &PR_CONNREQUIRED)==0)) || (($so)-> &so_state &  &SS_CANTSENDMORE) || ($so)-> &so_error));
    }' unless defined(&sowriteable);
    eval 'sub sballoc {
        local($sb, $m) = @_;
	    eval q({ ($sb)-> &sb_cc += ($m)-> &m_len; ($sb)-> &sb_mbcnt +=  &MSIZE;  &if (($m)-> &m_flags &  &M_EXT) ($sb)-> &sb_mbcnt += ($m)-> ($m_ext->{ext_size}); });
    }' unless defined(&sballoc);
    eval 'sub sbfree {
        local($sb, $m) = @_;
	    eval q({ ($sb)-> &sb_cc -= ($m)-> &m_len; ($sb)-> &sb_mbcnt -=  &MSIZE;  &if (($m)-> &m_flags &  &M_EXT) ($sb)-> &sb_mbcnt -= ($m)-> ($m_ext->{ext_size}); });
    }' unless defined(&sbfree);
    eval 'sub sblock {
        local($sb, $wf) = @_;
	    eval q((($sb)-> &sb_flags &  &SB_LOCK ? ((($wf) ==  &M_WAITOK) ?  &sb_lock($sb) :  &EWOULDBLOCK) : (($sb)-> &sb_flags |=  &SB_LOCK), 0));
    }' unless defined(&sblock);
    eval 'sub sbunlock {
        local($sb) = @_;
	    eval q({ ($sb)-> &sb_flags &= ~ &SB_LOCK;  &if (($sb)-> &sb_flags &  &SB_WANT) { ($sb)-> &sb_flags &= ~ &SB_WANT;  &wakeup(($sb)-> &sb_flags); } });
    }' unless defined(&sbunlock);
    eval 'sub sorwakeup {
        local($so) = @_;
	    eval q( &do {  &if ( &sb_notify(($so)-> &so_rcv))  &sowakeup(($so), ($so)-> &so_rcv); }  &while (0));
    }' unless defined(&sorwakeup);
    eval 'sub sowwakeup {
        local($so) = @_;
	    eval q( &do {  &if ( &sb_notify(($so)-> &so_snd))  &sowakeup(($so), ($so)-> &so_snd); }  &while (0));
    }' unless defined(&sowwakeup);
    if(defined(&KERNEL)) {
	eval("sub SOPT_GET () { 0; }") unless defined(&SOPT_GET);
	eval("sub SOPT_SET () { 1; }") unless defined(&SOPT_SET);
	if(defined(&MALLOC_DECLARE)) {
	}
    }
}
1;
