require '_h2ph_pre.ph';

unless(defined(&_SYS_TTY_H_)) {
    eval 'sub _SYS_TTY_H_ () {1;}' unless defined(&_SYS_TTY_H_);
    require 'sys/termios.ph';
    require 'sys/select.ph';
    eval 'sub t_cc () { ($t_termios->{c_cc});}' unless defined(&t_cc);
    eval 'sub t_cflag () { ($t_termios->{c_cflag});}' unless defined(&t_cflag);
    eval 'sub t_iflag () { ($t_termios->{c_iflag});}' unless defined(&t_iflag);
    eval 'sub t_ispeed () { ($t_termios->{c_ispeed});}' unless defined(&t_ispeed);
    eval 'sub t_lflag () { ($t_termios->{c_lflag});}' unless defined(&t_lflag);
    eval 'sub t_min () { ($t_termios->{c_min});}' unless defined(&t_min);
    eval 'sub t_oflag () { ($t_termios->{c_oflag});}' unless defined(&t_oflag);
    eval 'sub t_ospeed () { ($t_termios->{c_ospeed});}' unless defined(&t_ospeed);
    eval 'sub t_time () { ($t_termios->{c_time});}' unless defined(&t_time);
    eval 'sub TTIPRI () {25;}' unless defined(&TTIPRI);
    eval 'sub TTOPRI () {26;}' unless defined(&TTOPRI);
    eval 'sub IBUFSIZ () {384;}' unless defined(&IBUFSIZ);
    eval 'sub OBUFSIZ () {100;}' unless defined(&OBUFSIZ);
    unless(defined(&TTYHOG)) {
	eval 'sub TTYHOG () {1024;}' unless defined(&TTYHOG);
    }
    if(defined(&KERNEL)) {
	eval 'sub TTMAXHIWAT () { &roundup(2048,  &CBSIZE);}' unless defined(&TTMAXHIWAT);
	eval 'sub TTMINHIWAT () { &roundup(100,  &CBSIZE);}' unless defined(&TTMINHIWAT);
	eval 'sub TTMAXLOWAT () {256;}' unless defined(&TTMAXLOWAT);
	eval 'sub TTMINLOWAT () {32;}' unless defined(&TTMINLOWAT);
    }
    eval 'sub TS_SO_OLOWAT () {0x00001;}' unless defined(&TS_SO_OLOWAT);
    eval 'sub TS_ASYNC () {0x00002;}' unless defined(&TS_ASYNC);
    eval 'sub TS_BUSY () {0x00004;}' unless defined(&TS_BUSY);
    eval 'sub TS_CARR_ON () {0x00008;}' unless defined(&TS_CARR_ON);
    eval 'sub TS_FLUSH () {0x00010;}' unless defined(&TS_FLUSH);
    eval 'sub TS_ISOPEN () {0x00020;}' unless defined(&TS_ISOPEN);
    eval 'sub TS_TBLOCK () {0x00040;}' unless defined(&TS_TBLOCK);
    eval 'sub TS_TIMEOUT () {0x00080;}' unless defined(&TS_TIMEOUT);
    eval 'sub TS_TTSTOP () {0x00100;}' unless defined(&TS_TTSTOP);
    if(defined(&notyet)) {
	eval 'sub TS_WOPEN () {0x00200;}' unless defined(&TS_WOPEN);
    }
    eval 'sub TS_XCLUDE () {0x00400;}' unless defined(&TS_XCLUDE);
    eval 'sub TS_BKSL () {0x00800;}' unless defined(&TS_BKSL);
    eval 'sub TS_CNTTB () {0x01000;}' unless defined(&TS_CNTTB);
    eval 'sub TS_ERASE () {0x02000;}' unless defined(&TS_ERASE);
    eval 'sub TS_LNCH () {0x04000;}' unless defined(&TS_LNCH);
    eval 'sub TS_TYPEN () {0x08000;}' unless defined(&TS_TYPEN);
    eval 'sub TS_LOCAL () {( &TS_BKSL |  &TS_CNTTB |  &TS_ERASE |  &TS_LNCH |  &TS_TYPEN);}' unless defined(&TS_LOCAL);
    eval 'sub TS_CAN_BYPASS_L_RINT () {0x010000;}' unless defined(&TS_CAN_BYPASS_L_RINT);
    eval 'sub TS_CONNECTED () {0x020000;}' unless defined(&TS_CONNECTED);
    eval 'sub TS_SNOOP () {0x040000;}' unless defined(&TS_SNOOP);
    eval 'sub TS_SO_OCOMPLETE () {0x080000;}' unless defined(&TS_SO_OCOMPLETE);
    eval 'sub TS_ZOMBIE () {0x100000;}' unless defined(&TS_ZOMBIE);
    eval 'sub TS_CAR_OFLOW () {0x200000;}' unless defined(&TS_CAR_OFLOW);
    if(defined(&notyet)) {
	eval 'sub TS_CTS_OFLOW () {0x400000;}' unless defined(&TS_CTS_OFLOW);
	eval 'sub TS_DSR_OFLOW () {0x800000;}' unless defined(&TS_DSR_OFLOW);
    }
    eval 'sub ORDINARY () {0;}' unless defined(&ORDINARY);
    eval 'sub CONTROL () {1;}' unless defined(&CONTROL);
    eval 'sub BACKSPACE () {2;}' unless defined(&BACKSPACE);
    eval 'sub NEWLINE () {3;}' unless defined(&NEWLINE);
    eval 'sub TAB () {4;}' unless defined(&TAB);
    eval 'sub VTAB () {5;}' unless defined(&VTAB);
    eval 'sub RETURN () {6;}' unless defined(&RETURN);
    eval 'sub DMSET () {0;}' unless defined(&DMSET);
    eval 'sub DMBIS () {1;}' unless defined(&DMBIS);
    eval 'sub DMBIC () {2;}' unless defined(&DMBIC);
    eval 'sub DMGET () {3;}' unless defined(&DMGET);
    eval 'sub TTY_CHARMASK () {0x000000ff;}' unless defined(&TTY_CHARMASK);
    eval 'sub TTY_QUOTE () {0x00000100;}' unless defined(&TTY_QUOTE);
    eval 'sub TTY_ERRORMASK () {0xff000000;}' unless defined(&TTY_ERRORMASK);
    eval 'sub TTY_FE () {0x01000000;}' unless defined(&TTY_FE);
    eval 'sub TTY_PE () {0x02000000;}' unless defined(&TTY_PE);
    eval 'sub TTY_OE () {0x04000000;}' unless defined(&TTY_OE);
    eval 'sub TTY_BI () {0x08000000;}' unless defined(&TTY_BI);
    eval 'sub isctty {
        local($p, $tp) = @_;
	    eval q((($p)-> &p_session == ($tp)-> &t_session  && ($p)-> &p_flag &  &P_CONTROLT));
    }' unless defined(&isctty);
    eval 'sub isbackground {
        local($p, $tp) = @_;
	    eval q(( &isctty(($p), ($tp))  && ($p)-> &p_pgrp != ($tp)-> &t_pgrp));
    }' unless defined(&isbackground);
    eval 'sub TSA_CARR_ON {
        local($tp) = @_;
	    eval q((( &void *)($tp)-> &t_rawq));
    }' unless defined(&TSA_CARR_ON);
    eval 'sub TSA_HUP_OR_INPUT {
        local($tp) = @_;
	    eval q((( &void *)($tp)-> ($t_rawq->{c_cf})));
    }' unless defined(&TSA_HUP_OR_INPUT);
    eval 'sub TSA_OCOMPLETE {
        local($tp) = @_;
	    eval q((( &void *)($tp)-> ($t_outq->{c_cl})));
    }' unless defined(&TSA_OCOMPLETE);
    eval 'sub TSA_OLOWAT {
        local($tp) = @_;
	    eval q((( &void *)($tp)-> &t_outq));
    }' unless defined(&TSA_OLOWAT);
    eval 'sub TSA_PTC_READ {
        local($tp) = @_;
	    eval q((( &void *)($tp)-> ($t_outq->{c_cf})));
    }' unless defined(&TSA_PTC_READ);
    eval 'sub TSA_PTC_WRITE {
        local($tp) = @_;
	    eval q((( &void *)($tp)-> ($t_rawq->{c_cl})));
    }' unless defined(&TSA_PTC_WRITE);
    eval 'sub TSA_PTS_READ {
        local($tp) = @_;
	    eval q((( &void *)($tp)-> &t_canq));
    }' unless defined(&TSA_PTS_READ);
    if(defined(&KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
    }
}
1;
